SystemOrganization addCategory: #'FreeType-Fonts'!
SystemOrganization addCategory: #'FreeType-Base'!
SystemOrganization addCategory: #'FreeType-Cache'!
SystemOrganization addCategory: #'FreeType-FontManager'!
SystemOrganization addCategory: #'FreeType-Settings'!
SystemOrganization addCategory: #'FreeType-GlyphRendering'!
SystemOrganization addCategory: #'FreeType-UI'!

Link subclass: #FreeTypeCacheEntry
	instanceVariableNames: 'font charCode type object previousLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Cache'!

!FreeTypeCacheEntry methodsFor: 'comparing' stamp: 'tween 8/10/2006 14:58'!
= aFreeTypeCacheEntry
	"equailty based on font,charcode, type, object, but not nextLink"
	
	(aFreeTypeCacheEntry isKindOf: FreeTypeCacheEntry) 
		ifFalse:[^false].
	^font = aFreeTypeCacheEntry font and: [
		charCode = aFreeTypeCacheEntry charCode
			and: [type = aFreeTypeCacheEntry type
				and:[object = aFreeTypeCacheEntry object]]]! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 13:16'!
charCode
	"Answer the value of charCode"

	^ charCode! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 13:16'!
charCode: anObject
	"Set the value of charCode"

	charCode := anObject! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 13:16'!
font
	"Answer the value of font"

	^ font! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 13:16'!
font: anObject
	"Set the value of font"

	font := anObject! !

!FreeTypeCacheEntry methodsFor: 'comparing' stamp: 'tween 8/10/2006 13:34'!
hash
	^charCode hash! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 14:55'!
object
	"Answer the value of object"

	^ object! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 14:55'!
object: anObject
	"Set the value of object"

	object := anObject! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 17:56'!
previousLink
	"Answer the value of previousLink"

	^ previousLink! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 17:56'!
previousLink: anObject
	"Set the value of previousLink"

	previousLink := anObject! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 13:16'!
type
	"Answer the value of type"

	^ type! !

!FreeTypeCacheEntry methodsFor: 'accessing' stamp: 'tween 8/10/2006 13:16'!
type: anObject
	"Set the value of type"

	type := anObject! !

SharedPool subclass: #FT2Constants
	instanceVariableNames: ''
	classVariableNames: 'LoadCropBitmap LoadDefault LoadForceAutohint LoadIgnoreGlobalAdvanceWidth LoadIgnoreTransform LoadLinearDesign LoadMonochrome LoadNoAutohint LoadNoBitmap LoadNoHinting LoadNoRecurse LoadNoScale LoadPedantic LoadRender LoadSbitsOnly LoadTargetLCD LoadTargetLCDV LoadTargetLight LoadTargetMono LoadTargetNormal LoadVerticalLayout PixelModeGray PixelModeGray2 PixelModeGray4 PixelModeLCD PixelModeLCDV PixelModeMono PixelModeNone RenderModeLCD RenderModeLCDV RenderModeLight RenderModeMono RenderModeNormal StyleFlagBold StyleFlagItalic'
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2Constants commentStamp: '<historical>' prior: 0!
The various flags from the Freetype/2 header.

The LoadXXXX flags can be used with primitiveLoadGlyph:flags: or with the Cairo primCairoFtFontCreateForFtFace:flags:scale: primitives.

FT_LOAD_DEFAULT ::
  Corresponding to 0, this value is used a default glyph load.  In this
  case, the following will happen:
                                                                        
  1. FreeType looks for a bitmap for the glyph corresponding to the
     face's current size.  If one is found, the function returns.  The
     bitmap data can be accessed from the glyph slot (see note below).
                                                                        
  2. If no embedded bitmap is searched or found, FreeType looks for a
     scalable outline.  If one is found, it is loaded from the font
     file, scaled to device pixels, then "hinted" to the pixel grid in
     order to optimize it.  The outline data can be accessed from the
     glyph slot (see note below).
                                                                        
  Note that by default, the glyph loader doesn't render outlines into
  bitmaps.  The following flags are used to modify this default
  behaviour to more specific and useful cases.
                                                                        
FT_LOAD_NO_SCALE ::
  Don't scale the vector outline being loaded to 26.6 fractional
  pixels, but kept in font units.  Note that this also disables
  hinting and the loading of embedded bitmaps.  You should only use it
  when you want to retrieve the original glyph outlines in font units.
                                                                        
FT_LOAD_NO_HINTING ::
  Don't hint glyph outlines after their scaling to device pixels.
  This generally generates "blurrier" glyphs in anti-aliased modes.
                                                                        
  This flag is ignored if @FT_LOAD_NO_SCALE is set.
                                                                        
FT_LOAD_RENDER ::
  Render the glyph outline immediately into a bitmap before the glyph
  loader returns.  By default, the glyph is rendered for the
  @FT_RENDER_MODE_NORMAL mode, which corresponds to 8-bit anti-aliased
  bitmaps using 256 opacity levels.  You can use either
  @FT_LOAD_TARGET_MONO or @FT_LOAD_MONOCHROME to render 1-bit
  monochrome bitmaps.
                                                                        
  This flag is ignored if @FT_LOAD_NO_SCALE is set.
                                                                        
FT_LOAD_NO_BITMAP ::
  Don't look for bitmaps when loading the glyph.  Only scalable
  outlines will be loaded when available, and scaled, hinted, or
  rendered depending on other bit flags.
                                                                        
  This does not prevent you from rendering outlines to bitmaps
  with @FT_LOAD_RENDER, however.
                                                                        
FT_LOAD_VERTICAL_LAYOUT ::
  Prepare the glyph image for vertical text layout.  This basically
  means that `face.glyph.advance' will correspond to the vertical
  advance height (instead of the default horizontal advance width),
  and that the glyph image will be translated to match the vertical
  bearings positions.
                                                                        
FT_LOAD_FORCE_AUTOHINT ::
  Force the use of the FreeType auto-hinter when a glyph outline is
  loaded.  You shouldn't need this in a typical application, since it
  is mostly used to experiment with its algorithm.
                                                                        
FT_LOAD_CROP_BITMAP ::
  Indicates that the glyph loader should try to crop the bitmap (i.e.,
  remove all space around its black bits) when loading it.  This is
  only useful when loading embedded bitmaps in certain fonts, since
  bitmaps rendered with @FT_LOAD_RENDER are always cropped by default.
                                                                        
FT_LOAD_PEDANTIC ::
  Indicates that the glyph loader should perform pedantic
  verifications during glyph loading, rejecting invalid fonts.  This
  is mostly used to detect broken glyphs in fonts.  By default,
  FreeType tries to handle broken fonts also.
                                                                        
FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH ::
  Indicates that the glyph loader should ignore the global advance
  width defined in the font.  As far as we know, this is only used by
  the X-TrueType font server, in order to deal correctly with the
  incorrect metrics contained in DynaLab's TrueType CJK fonts.
                                                                        
FT_LOAD_NO_RECURSE ::
  This flag is only used internally.  It merely indicates that the
  glyph loader should not load composite glyphs recursively.  Instead,
  it should set the `num_subglyph' and `subglyphs' values of the glyph
  slot accordingly, and set "glyph->format" to
  @FT_GLYPH_FORMAT_COMPOSITE.
                                                                        
  The description of sub-glyphs is not available to client
  applications for now.
                                                                        
FT_LOAD_IGNORE_TRANSFORM ::
  Indicates that the glyph loader should not try to transform the
  loaded glyph image.  This doesn't prevent scaling, hinting, or
  rendering.
                                                                        
FT_LOAD_MONOCHROME ::
  This flag is used with @FT_LOAD_RENDER to indicate that you want
  to render a 1-bit monochrome glyph bitmap from a vectorial outline.
                                                                        
  Note that this has no effect on the hinting algorithm used by the
  glyph loader.  You should better use @FT_LOAD_TARGET_MONO if you
  want to render monochrome-optimized glyph images instead.
                                                                        
FT_LOAD_LINEAR_DESIGN ::
  Return the linearly scaled metrics expressed in original font units
  instead of the default 16.16 pixel values.
                                                                        
FT_LOAD_NO_AUTOHINT ::
  Indicates that the auto-hinter should never be used to hint glyph
  outlines.  This doesn't prevent native format-specific hinters from
  being used.  This can be important for certain fonts where unhinted
  output is better than auto-hinted one.

One of following flags (as LoadTargetXXX) can be used to further specify the result.

   FT_RENDER_MODE_NORMAL ::                                          
     This is the default render mode; it corresponds to 8-bit        
     anti-aliased bitmaps, using 256 levels of opacity.              
                                                                     
   FT_RENDER_MODE_LIGHT ::                                           
     This is similar to @FT_RENDER_MODE_NORMAL, except that this     
     changes the hinting to prevent stem width quantization.  This   
     results in glyph shapes that are more similar to the original,  
     while being a bit more fuzzy ("better shapes", instead of       
     "better contrast" if you want :-).                              
                                                                     
   FT_RENDER_MODE_MONO ::                                            
     This mode corresponds to 1-bit bitmaps.                         
                                                                     
   FT_RENDER_MODE_LCD ::                                             
     This mode corresponds to horizontal RGB/BGR sub-pixel displays, 
     like LCD-screens.  It produces 8-bit bitmaps that are 3 times   
     the width of the original glyph outline in pixels, and which use
     the @FT_PIXEL_MODE_LCD mode.                                    
                                                                     
   FT_RENDER_MODE_LCD_V ::                                           
     This mode corresponds to vertical RGB/BGR sub-pixel displays    
     (like PDA screens, rotated LCD displays, etc.).  It produces    
     8-bit bitmaps that are 3 times the height of the original       
     glyph outline in pixels and use the @FT_PIXEL_MODE_LCD_V mode.  
                                                                     
<Note>                                                               
  The LCD-optimized glyph bitmaps produced by FT_Render_Glyph are    
  _not filtered_ to reduce color-fringes.  It is up to the caller to 
  perform this pass.                                                 

!

!FT2Constants class methodsFor: 'class initialization' stamp: 'tween 8/13/2006 15:55'!
initialize
	"FT2Constants initialize"

	LoadDefault := 0.
	LoadNoScale := 1.
	LoadNoHinting := 2.
	LoadRender := 4.
	LoadNoBitmap := 8.
	LoadVerticalLayout := 16.
	LoadForceAutohint := 32.
	LoadCropBitmap := 64.
	LoadPedantic := 128.
	LoadIgnoreGlobalAdvanceWidth := 512.
	LoadNoRecurse := 1024.
	LoadIgnoreTransform := 2048.
	LoadMonochrome := 4096.
	LoadLinearDesign := 8192.
	LoadSbitsOnly := 16384.
	LoadNoAutohint := 32768.

	"One of these flags may be OR'd with the above."
	LoadTargetNormal := 0.
	LoadTargetLight := 1 bitShift: 16.
	LoadTargetMono := 2 bitShift: 16.
	LoadTargetLCD := 3 bitShift: 16.
	LoadTargetLCDV  := 4 bitShift: 16.

	"rendering mode constants"
	RenderModeNormal := 0.
	RenderModeLight := 1.
	RenderModeMono := 2.
	RenderModeLCD := 3.	
	RenderModeLCDV := 4.

	"pixel mode constants"
	PixelModeNone := 0.
	PixelModeMono := 1.
	PixelModeGray := 2.
	PixelModeGray2 := 3.
	PixelModeGray4 := 4.
	PixelModeLCD := 5.
	PixelModeLCDV := 6.
	
	StyleFlagItalic := 1.
	StyleFlagBold := 2.
! !

SharedPool subclass: #FreeTypeCacheConstants
	instanceVariableNames: ''
	classVariableNames: 'FreeTypeCacheGlyph FreeTypeCacheGlyphLCD FreeTypeCacheGlyphMono FreeTypeCacheLinearWidth FreeTypeCacheWidth'
	poolDictionaries: ''
	category: 'FreeType-Cache'!

!FreeTypeCacheConstants class methodsFor: 'class initialization' stamp: 'tween 3/31/2007 21:31'!
initialize
	"
	FreeTypeCacheConstants initialize
	"
	
	FreeTypeCacheWidth := 0.
	FreeTypeCacheGlyph := 100.	"start at 100 and allow room for 64 subpixel positioned glyphs"
	FreeTypeCacheGlyphLCD := 200. "start at 200 and allow room for 64 subpixel positioned glyphs"
	FreeTypeCacheGlyphMono := 3.
	FreeTypeCacheLinearWidth := 4
	! !

!CharacterBlockScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 12:49'!
crossedX
	"Text display has wrapping. The scanner just found a character past the x 
	location of the cursor. We know that the cursor is pointing at a character 
	or before one."

	| leadingTab currentX |
	characterIndex == nil ifFalse: [
		"If the last character of the last line is a space,
		and it crosses the right margin, then locating
		the character block after it is impossible without this hack."
		characterIndex > text size ifTrue: [
			lastIndex _ characterIndex.
			characterPoint _ (nextLeftMargin ifNil: [leftMargin]) @ (destY + line lineHeight).
			^true]].
	characterPoint x <= (destX + (lastCharacterExtent x // 2))
		ifTrue:	[lastCharacter _ (text at: lastIndex).
				characterPoint _ destX @ destY.
				^true].
	lastIndex >= line last 
		ifTrue:	[lastCharacter _ (text at: line last).
				characterPoint _ destX @ destY.
				^true].

	"Pointing past middle of a character, return the next character."
	lastIndex _ lastIndex + 1.
	lastCharacter _ text at: lastIndex.
	currentX _ destX + lastCharacterExtent x + kern.
	self lastCharacterExtentSetX: (font widthOf: lastCharacter).
	characterPoint _ currentX @ destY.
	lastCharacter = Space ifFalse: [^ true].

	"Yukky if next character is space or tab."
	alignment = Justified ifTrue:
		[self lastCharacterExtentSetX:
			(lastCharacterExtent x + 	(line justifiedPadFor: (spaceCount + 1) font: font)).
		^ true].

	true ifTrue: [^ true].
	"NOTE:  I find no value to the following code, and so have defeated it - DI"

	"See tabForDisplay for illumination on the following awfulness."
	leadingTab _ true.
	line first to: lastIndex - 1 do:
		[:index | (text at: index) ~= Tab ifTrue: [leadingTab _ false]].
	(alignment ~= Justified or: [leadingTab])
		ifTrue:	[self lastCharacterExtentSetX: (textStyle nextTabXFrom: currentX
					leftMargin: leftMargin rightMargin: rightMargin) -
						currentX]
		ifFalse:	[self lastCharacterExtentSetX:  (((currentX + (textStyle tabWidth -
						(line justifiedTabDeltaFor: spaceCount))) -
							currentX) max: 0)].
	^ true! !

!CharacterBlockScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 12:50'!
paddedSpace
	"When the line is justified, the spaces will not be the same as the font's 
	space character. A padding of extra space must be considered in trying 
	to find which character the cursor is pointing at. Answer whether the 
	scanning has crossed the cursor."

	| pad |
	pad _ 0.
	spaceCount _ spaceCount + 1.
	pad _ line justifiedPadFor: spaceCount font: font.
	lastSpaceOrTabExtent _ lastCharacterExtent copy.
	self lastSpaceOrTabExtentSetX:  spaceWidth + pad.
	(destX + lastSpaceOrTabExtent x)  >= characterPoint x
		ifTrue: [lastCharacterExtent _ lastSpaceOrTabExtent copy.
				^self crossedX].
	lastIndex _ lastIndex + 1.
	destX _ destX + lastSpaceOrTabExtent x.
	^ false
! !

!MultiDisplayScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 10:43'!
cr
	"When a carriage return is encountered, simply increment the pointer 
	into the paragraph."

	lastIndex_ lastIndex + 1.
	pendingKernX := 0.
	^false! !

!MultiDisplayScanner methodsFor: '*FreeType-override' stamp: 'tween 8/1/2006 20:22'!
displayLine: textLine offset: offset leftInRun: leftInRun
	"The call on the primitive (scanCharactersFrom:to:in:rightX:) will be interrupted according to an array of stop conditions passed to the scanner at which time the code to handle the stop condition is run and the call on the primitive continued until a stop condition returns true (which means the line has terminated).  leftInRun is the # of characters left to scan in the current run; when 0, it is time to call setStopConditions."
	| done stopCondition nowLeftInRun startIndex string lastPos underline strikeout |
	line := textLine.
	morphicOffset := offset.
	lineY := line top + offset y.
	lineHeight := line lineHeight.
	rightMargin := line rightMargin + offset x.
	lastIndex := line first.
	leftInRun <= 0 ifTrue: [self setStopConditions].
	leftMargin := (line leftMarginForAlignment: alignment) + offset x.
	destX := runX := leftMargin.
	fillBlt == nil ifFalse:
		["Not right"
		fillBlt destX: line left destY: lineY
			width: line width left height: lineHeight; copyBits].
	lastIndex := line first.
	leftInRun <= 0
		ifTrue: [nowLeftInRun := text runLengthFor: lastIndex]
		ifFalse: [nowLeftInRun := leftInRun].
	baselineY := lineY + line baseline.
	destY := baselineY - font ascent.
	runStopIndex := lastIndex + (nowLeftInRun - 1) min: line last.
	spaceCount := 0.
	done := false.
	string := text string.
	[done] whileFalse:[
		startIndex := lastIndex.
		lastPos := destX@destY.
		stopCondition := self scanCharactersFrom: lastIndex to: runStopIndex
						in: string rightX: rightMargin stopConditions: stopConditions
						kern: kern.
		lastIndex >= startIndex ifTrue:[
			underline := (emphasisCode bitAnd: 4) > 0.
			strikeout := (emphasisCode bitAnd: 16) > 0.
			font displayString: string on: bitBlt 
				from: startIndex to: lastIndex at: lastPos kern: kern baselineY: baselineY.
			underline 
				ifTrue:[font displayUnderlineOn: bitBlt from: lastPos x@baselineY to: destX@baselineY].
			strikeout 
				ifTrue:[font displayStrikeoutOn: bitBlt from: lastPos x@baselineY to: destX@baselineY ] ].
		"see setStopConditions for stopping conditions for displaying."
		done := self perform: stopCondition.
		"lastIndex > runStopIndex ifTrue: [done _ true]."
	].
	^ runStopIndex - lastIndex   "Number of characters remaining in the current run"! !

!MultiDisplayScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 12:52'!
paddedSpace
	"Each space is a stop condition when the alignment is right justified. 
	Padding must be added to the base width of the space according to 
	which space in the line this space is and according to the amount of 
	space that remained at the end of the line when it was composed."

	spaceCount _ spaceCount + 1.
	destX _ destX + spaceWidth + (line justifiedPadFor: spaceCount  font: font).
	lastIndex _ lastIndex + 1.
	pendingKernX := 0.
	^ false! !

!StringMorph methodsFor: '*FreeType-override' stamp: 'tween 3/2/2008 10:41'!
changeFont
	| newFont chooser|
	"newFont _ StrikeFont fromUser: self fontToUse."
	chooser := self openModal: (
		Cursor wait showWhile: [FontChooser 
			windowTitle: 'Choose a Font' 
			for: self 
			setSelector: #font: 
			getSelector: self fontToUse]).
	newFont := chooser result.
	newFont ifNotNil:[self font: newFont].! !

!TextMorphEditor methodsFor: '*FreeType-addition' stamp: 'tween 9/8/2007 12:11'!
alphabeticalGroupsFor: familyGroupList size: maxGroupSize
	| alphabetDict alphabetDict2 pendingGroup pendingGroupKeys group key |
	alphabetDict := Dictionary new.
	familyGroupList do:[:each |
		(alphabetDict at: each familyName first ifAbsentPut:[OrderedCollection new])
			add: each].
	alphabetDict2 := Dictionary new.
	pendingGroup := OrderedCollection new.
	pendingGroupKeys :=OrderedCollection new.
	alphabetDict keys asSortedCollection do:[:char |
		group := alphabetDict at: char.
		pendingGroup size + group size <= maxGroupSize
			ifTrue:[
				pendingGroupKeys addLast: char.
				pendingGroup addAll: group]
			ifFalse:[
				pendingGroup ifNotEmpty:[
					key := pendingGroupKeys first asString asUppercase.
					pendingGroupKeys size > 1 
						ifTrue:[key := key, ' - ', pendingGroupKeys last asString asUppercase].
					alphabetDict2 at: key put: pendingGroup].
				pendingGroup := OrderedCollection withAll: group.
				pendingGroupKeys := OrderedCollection with: char]].
	pendingGroup ifNotEmpty:[
		key := pendingGroupKeys first asString asUppercase.
		pendingGroupKeys size > 1 
			ifTrue:[key := key, ' - ', pendingGroupKeys last asString asUppercase].
		alphabetDict2 at: key put: pendingGroup].
	"need to split single char groups at this point. e,g. 'A' may have > maxGroupSize members"
	^alphabetDict2	
	! !

!TextMorphEditor methodsFor: '*FreeType-addition' stamp: 'pavel.krivanek 12/3/2008 21:48'!
changeSelectionFontTo: aFont

	| attr startIndex stopIndex f  code textIsBold textIsItalic copy fontIsBold fontIsItalic style squeakBoldEmphasis squeakItalicEmphasis |
	
	aFont ifNil:[^self].
	startIndex _ self startIndex.
	stopIndex := self stopIndex-1 min: paragraph text size.
	f := aFont. 
	squeakBoldEmphasis := 1.
	squeakItalicEmphasis := 2.
	(f isKindOf: LogicalFont)
		ifTrue:[
			copy := f copy 
				forceNotBold;
				forceNotItalic;
				clearRealFont;
				yourself.
			LogicalFont all remove: copy ifAbsent:[]. "remove the copy from all before getting another one"
			f := LogicalFont 
				familyName: copy familyName 
				pointSize: copy pointSize 
				stretchValue: copy stretchValue
				weightValue: copy weightValue
				slantValue: copy slantValue.
			"add aFont's emphasis to the text as a separate action"
			code := paragraph text emphasisAt: startIndex. 
			textIsBold :=  code anyMask: squeakBoldEmphasis.
			textIsItalic := code anyMask: squeakItalicEmphasis.
			(aFont isBoldOrBolder ~= textIsBold) 
				ifTrue:[self setEmphasis: #bold  "toggle bold"].
			(aFont isItalicOrOblique ~= textIsItalic) 
				ifTrue:[self setEmphasis: #italic "toggle italic"].
			paragraph composeAll.
			self recomputeSelection. ]
		ifFalse:["must be from a TextStyle?"
			style := TextStyle named: aFont familyName.
			style ifNil:[
				style := TextStyle actualTextStyles
					detect: [:aStyle | 
						(aStyle fontArray includes: aFont) or:[
							(aStyle fontArray select: [:e | e derivativeFonts includes: aFont]) notEmpty]]
					ifNone: []].
			f := style fontOfPointSize: aFont pointSize. "unemphasized"
			"add aFont's emphasis to the text as a separate action"
			code := paragraph text emphasisAt: startIndex. 
			textIsBold :=  code anyMask: squeakBoldEmphasis.
			textIsItalic := code anyMask: squeakItalicEmphasis.
			fontIsBold := aFont emphasis anyMask: squeakBoldEmphasis.
			fontIsItalic := aFont emphasis anyMask: squeakItalicEmphasis.
			(fontIsBold ~= textIsBold) 
				ifTrue:[self setEmphasis: #bold  "toggle bold"].
			(fontIsItalic ~= textIsItalic) 
				ifTrue:[self setEmphasis: #italic "toggle italic"].
			paragraph composeAll.
			self recomputeSelection. ].
	attr _ TextFontReference toFont: f.
	stopIndex >= startIndex
		ifTrue: [ paragraph text addAttribute: attr from: startIndex to: stopIndex ]
		ifFalse: [ paragraph text addAttribute: attr from: 1 to: paragraph text size. ].
	paragraph composeAll.
	self recomputeInterval.
	"next bit makes it reflow and redraw correctly"
	morph updateFromParagraph. 
	morph handleEdit:[]
! !

!TextMorphEditor methodsFor: '*FreeType-override' stamp: 'tween 3/2/2008 09:17'!
changeTextFont
	"Present a menu of available fonts, and if one is chosen, apply it to the current selection.
	If there is no selection, or the selection is empty, apply it to the whole morph."
	| useDialog |
	useDialog := true. "make this false to use a menu"
	^useDialog 
		ifTrue:[self changeTextFontDialog]
		ifFalse:[self changeTextFontAlphabeticalMenu]! !

!TextMorphEditor methodsFor: '*FreeType-addition' stamp: 'tween 9/8/2007 15:12'!
changeTextFontAlphabeticalMenu
	| dict startIndex stopIndex currrentFont currentFamilyMember fontMenu fams members styleName label  tag  ptMenu spec newFont attr applyStart applyStop allFontFamilies removeSet unBold unSlanted unSlantedUnBold alphaMenu itemFont alphaIncludesCurrent alphaLabel |

	startIndex := self startIndex.
	stopIndex := self stopIndex-1 min: paragraph text size.
	allFontFamilies := LogicalFontManager current allFamilies.
	currrentFont := paragraph text fontAt: startIndex withStyle: paragraph textStyle.
	currentFamilyMember := self familyMemberFor: currrentFont fromFamilies: allFontFamilies.
	fontMenu := MenuMorph new defaultTarget: self.
	dict := self alphabeticalGroupsFor: allFontFamilies size: 15.
	dict keys asSortedCollection do:[:k |
		alphaMenu := MenuMorph new defaultTarget: self. 
		fams := dict at: k.
		alphaIncludesCurrent := false.
		fams do:[:family |
			members := family members reject:[:mem | mem simulated].
			"reject any members that are simply bold, italic, or boldItalic versions of other members"
			removeSet := Set new.
			members do:[:mem |
				(mem weightValue = 700 and:[mem slantValue ~= 0])
					ifTrue:[
						unSlantedUnBold := family 
							closestMemberWithStretchValue: mem stretchValue
							weightValue: 400 
							slantValue: 0.
						unSlantedUnBold = mem ifFalse:[removeSet add: mem]]
					ifFalse:[
						mem weightValue = 700 
							ifTrue:[
								unBold := family 
									closestMemberWithStretchValue: mem stretchValue
									weightValue: 400 
									slantValue: mem slantValue.
								unBold = mem ifFalse:[removeSet add: mem]].
						mem slantValue ~= 0 
							ifTrue:[
								unSlanted := family 
									closestMemberWithStretchValue: mem stretchValue
									weightValue: mem weightValue 
									slantValue: 0.
								unSlanted = mem ifFalse:[removeSet add: mem]]]].				
			members := members copyWithoutAll: removeSet. 
			members := members asSortedCollection asArray.
			members do:[:member |
				styleName := member styleName.
				(#('book' 'normal' 'regular' 'roman' 'upright') includes: styleName asLowercase)
					ifTrue:[styleName := ''].
				(styleName notEmpty and:[member simulated]) 
					ifTrue:[styleName := '(', styleName, ')'].
				label := family familyName, ' ',styleName.
				self fontMenuItemsDisplayWithMenuFont ifFalse:[
					itemFont := member asLogicalFontOfPointSize: Preferences standardMenuFont pointSize.
					(itemFont isSymbolFont or:[(itemFont hasDistinctGlyphsForAll: label) not])
						ifTrue:[itemFont := nil]].
				alphaIncludesCurrent := alphaIncludesCurrent or:[member = currentFamilyMember].
				tag := member = currentFamilyMember ifTrue:['<on>'] ifFalse:['<off>'].
				label := tag , label.
				ptMenu := self 
					pointSizeMenuForFamilyMember: member
					parentMenu:fontMenu
					active: member = currentFamilyMember
					activePointSize: currrentFont pointSize.
				alphaMenu add: label subMenu: ptMenu. 				
				itemFont ifNotNil:[alphaMenu lastItem font: itemFont] ]].
		alphaLabel := alphaIncludesCurrent ifTrue:['<on>'] ifFalse:['<off>'].
		alphaLabel := alphaLabel, k.
		fontMenu add: alphaLabel subMenu: alphaMenu.
		"alphaIncludesCurrent ifTrue:[fontMenu lastItem color: Color red ]"].
	spec := fontMenu invokeModalAt: ActiveHand position in: ActiveWorld allowKeyboard: true.
	spec ifNil:[^nil].
	newFont := LogicalFont 
		familyName: spec first family familyName 
		pointSize: spec last 
		stretchValue: spec first stretchValue 
		weightValue: spec first weightValue 
		slantValue: spec first slantValue.
	newFont ifNil:[^self].
	attr := TextFontReference toFont: newFont.
	applyStart := stopIndex >= startIndex ifTrue:[startIndex] ifFalse:[1].
	applyStop := stopIndex >= startIndex ifTrue:[stopIndex] ifFalse:[paragraph text size].
	paragraph text addAttribute: attr from: applyStart to: applyStop.
	paragraph composeAll.
	self recomputeInterval			! !

!TextMorphEditor methodsFor: '*FreeType-addition' stamp: 'tween 3/2/2008 10:41'!
changeTextFontDialog
	"Present a dialog which allows the user to select a font, and if one is chosen, apply it to the current selection.	If there is no selection, or the selection is empty, apply it to the whole morph."
		
	"?? Should the dialog allow the user to select a bold/italic/black font.
	Or just the most regular member of a Font Family?"
	| curFont startIndex chooser newFont |
	startIndex := self startIndex.
	"stopIndex := self stopIndex-1 min: paragraph text size."
	curFont := (paragraph text fontAt: startIndex withStyle: paragraph textStyle).
	(curFont isKindOf: LogicalFont)
		ifTrue:[
			curFont := curFont copy.
			((paragraph text emphasisAt: startIndex) anyMask: 1) ifTrue:[curFont forceBold].
			((paragraph text emphasisAt: startIndex) anyMask: 2) ifTrue:[curFont forceItalicOrOblique].
			curFont clearRealFont].
	chooser := morph openModal: (
		Cursor wait showWhile: [ 
			FontChooser 
				windowTitle: 'Change the selected text''s font to...' translated
				for: self 
				setSelector: #changeSelectionFontTo:
				getSelector: curFont]).
	newFont := chooser result.
	newFont ifNotNil:[self changeSelectionFontTo: newFont].! !

!TextMorphEditor methodsFor: '*FreeType-addition' stamp: 'tween 9/8/2007 12:06'!
familyMemberFor: aFont fromFamilies: aCollection
	| family weightValue slantValue stretchValue |
	family := aCollection detect:[:each | each familyName = aFont familyName] ifNone:[].
	family ifNil:[^nil].
	(aFont isKindOf: LogicalFont)
		ifTrue:[
			weightValue := aFont weightValue.
			slantValue := aFont slantValue.
			stretchValue := aFont stretchValue]
		ifFalse:[
			weightValue := (aFont emphasis bitAnd: 1) > 0 ifTrue:[700] ifFalse:[400].
			slantValue := (aFont emphasis bitAnd: 2) > 0 ifTrue:[1] ifFalse:[0].
			stretchValue := 5 "normal"].		
	^family closestMemberWithStretchValue: stretchValue weightValue: weightValue slantValue: slantValue	
	! !

!TextMorphEditor methodsFor: '*FreeType-addition' stamp: 'tween 9/8/2007 14:05'!
fontMenuItemsDisplayWithMenuFont
	"Answer true if menu items should display using the standard menu font,
	false to display them in the font that they represent"
	^true! !

!TextMorphEditor methodsFor: '*FreeType-addition' stamp: 'tween 8/26/2007 16:27'!
otherFontSizeDialog: args
	"This is called from a modal menu and call back the menu with entered argument."
	| f n |
	f := UIManager default request: 'Enter the point size' initialAnswer: '12'.
	n := f asNumber.
	args second ifNotNil: [args second modalSelection: {args first. n}]! !

!TextMorphEditor methodsFor: '*FreeType-addition' stamp: 'tween 8/26/2007 16:37'!
pointSizeMenuForFamilyMember: aFontFamilyMember parentMenu: aMenuMorph active: aBoolean activePointSize: aNumberOrNil
		
	| ptMenu style pointSizes activePt ptLabel onLabel offLabel selector target |
	ptMenu := MenuMorph new defaultTarget: self.
	style := TextStyle named: aFontFamilyMember family familyName.
	pointSizes := style 
		ifNil:[
			pointSizes := #(6 8 10 11 12 15 18 20 22 24 26 28 30 36 42 52 72).
			aNumberOrNil ifNotNil:[
				pointSizes := (pointSizes copyWith: aNumberOrNil reduce) asSet asSortedCollection] ]
		ifNotNil:[
			pointSizes := style pointSizes].
	pointSizes do:[:ptSize |
		activePt := aBoolean and:[ptSize = aNumberOrNil].
		aNumberOrNil isNil
			ifTrue:[onLabel := ''. offLabel := '']
			ifFalse:[onLabel := '<on>'. offLabel := '<off>'].
		ptLabel := activePt
			ifTrue:[onLabel, ptSize printString, ' pt']
			ifFalse:[offLabel, ptSize printString, ' pt'].
		ptMenu 
			add: ptLabel 
			target: aMenuMorph
			selector: #modalSelection:
			argument: {aFontFamilyMember. ptSize}].	
		(style isNil or:[style isTTCStyle ]) ifTrue:[
			selector := style 
				ifNil:[#otherFontSizeDialog:] 
				ifNotNil:[#addNewFontSizeDialog: ].
			target := style ifNil:[self].
			ptMenu 
				addLine;
				add: 'Other size...' translated
					target: target
					selector: selector
					argument: {aFontFamilyMember. aMenuMorph}].
	^ptMenu! !

!TextStyle class methodsFor: '*FreeType-override' stamp: 'tween 8/10/2006 07:16'!
emphasisMenuForFont: font target: target selector: selector highlight: currentEmphasis
	"Offer a font emphasis menu for the given style. If one is selected, pass that font to target with a call to selector. The fonts will be displayed in that font.
	Answer nil if no derivatives exist.
	"

 	| aMenu derivs |
	derivs := font derivativeFonts.
	derivs isEmpty ifTrue: [ ^nil ].
	aMenu _ MenuMorph entitled: 'emphasis' translated.
	derivs := derivs asOrderedCollection.
	derivs addFirst: font.
	derivs do: [ :df | 
			aMenu 
				add: df emphasisString
				target: target 
				selector: selector
				argument: df.
                aMenu lastItem font: df.
                df emphasis == currentEmphasis ifTrue: [aMenu lastItem color: Color blue darker]].
        ^ aMenu! !

!TextStyle class methodsFor: '*FreeType-override' stamp: 'tween 3/29/2007 13:49'!
fontMenuForStyle: styleName target: target selector: selector highlight: currentFont 
	"Offer a font menu for the given style. If one is selected, pass 
	that font to target with a  
	call to selector. The fonts will be displayed in that font."
	| aMenu displayFont |
	aMenu := MenuMorph entitled: styleName.
	(TextStyle named: styleName)
		ifNotNilDo: [:s | s isTTCStyle
				ifTrue: [aMenu
						add: 'New Size'
						target: self
						selector: #chooseTTCFontSize:
						argument: {styleName. target. selector}]].
	(self pointSizesFor: styleName)
		do: [:pointSize | 
			| font subMenu | 
			font := (self named: styleName)
						fontOfPointSize: pointSize.
			subMenu := self
						emphasisMenuForFont: font
						target: target
						selector: selector
						highlight: (currentFont
								ifNotNilDo: [:cf | (cf familyName = styleName
											and: [cf pointSize = font pointSize])
										ifTrue: [currentFont emphasis]]).
			subMenu
				ifNil: [aMenu
						add: pointSize asString , ' Point'
						target: target
						selector: selector
						argument: font]
				ifNotNil: [aMenu add: pointSize asString , ' Point' subMenu: subMenu].
			displayFont := font.
			(font isSymbolFont or:[(font hasDistinctGlyphsForAll: pointSize asString , ' Point') not])
				ifTrue:[
					"don't use a symbol font to display its own name!!!!"
					displayFont := self default fontOfPointSize: pointSize].
			aMenu lastItem font: displayFont.
			currentFont
				ifNotNilDo: [:cf | (cf familyName = styleName
							and: [cf pointSize = font pointSize])
						ifTrue: [aMenu lastItem color: Color blue darker]]].
	^ aMenu! !

!TextStyle class methodsFor: '*FreeType-override' stamp: 'nk 9/1/2004 13:19'!
promptForFont: aPrompt andSendTo: aTarget withSelector: aSelector highlight: currentFont 
	"Morphic Only!! prompt for a font and if one is provided, send it to aTarget using a 
	message with selector aSelector."
	"TextStyle promptForFont: 'Choose system font:' andSendTo: Preferences withSelector: 
	#setSystemFontTo: "
	"Derived from a method written by Robin Gibson"
	| menu subMenu currentTextStyle |
	currentTextStyle := currentFont
				ifNotNil: [currentFont textStyleName].
	menu := MenuMorph entitled: aPrompt.
	self actualTextStyles keysSortedSafely
		do: [:styleName | 
			subMenu := self
						fontMenuForStyle: styleName
						target: aTarget
						selector: aSelector
						highlight: currentFont.
			menu add: styleName subMenu: subMenu.
			menu lastItem
				font: ((self named: styleName)
						fontOfSize: 18).
			styleName = currentTextStyle
				ifTrue: [menu lastItem color: Color blue darker]].
	menu popUpInWorld: self currentWorld! !

!TextStyle methodsFor: '*FreeType-override' stamp: 'tween 4/23/2006 22:46'!
addNewFontSize: pointSize
	"Add a font in specified size to the array of fonts."
	| f d newArray t isSet |
	fontArray first emphasis ~= 0 ifTrue: [
		t _ TextConstants at: self fontArray first familyName asSymbol.
		t fonts first emphasis = 0 ifTrue: [
			^ t addNewFontSize: pointSize.
		].
	].

	pointSize <= 0 ifTrue: [^ nil].
	fontArray do: [:s |
		s pointSize = pointSize ifTrue: [^ s].
	].

	(isSet _ fontArray first isKindOf: TTCFontSet) 
	ifTrue:[
		| fonts |
		fonts _ fontArray first fontArray collect: [ :font |
			| newFont |
			(font isNil)
			ifTrue: [newFont _ nil]
			ifFalse: [
				newFont _ (font ttcDescription size > 256)
					ifTrue: [MultiTTCFont new initialize]
					ifFalse: [TTCFont new initialize].
				newFont ttcDescription: font ttcDescription.
				newFont pixelSize: pointSize * 96 // 72.
				font derivativeFonts notEmpty ifTrue: [font derivativeFonts do: [ :proto |
					proto ifNotNil: [
						d _ proto class new initialize.
						d ttcDescription: proto ttcDescription.
						d pixelSize: newFont pixelSize.
						newFont derivativeFont: d]]].
				].
			newFont].
		f _ TTCFontSet newFontArray: fonts]
	ifFalse: [
		f _ fontArray first class new initialize: fontArray first.
		f pointSize: pointSize.
		fontArray first derivativeFonts do: [:proto |
			proto ifNotNil: [
				d _ proto class new initialize: proto.
				d pointSize: f pointSize.
				f derivativeFont: d mainFont: proto.
			].
		].
	].
	newArray _ ((fontArray copyWith: f) asSortedCollection: [:a :b | a pointSize <= b pointSize]) asArray.
	self newFontArray: newArray.
	isSet ifTrue: [
		TTCFontSet register: newArray at: newArray first familyName asSymbol.
	].
	^ self fontOfPointSize: pointSize
! !

!CanvasCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:02'!
cr
	"When a carriage return is encountered, simply increment the pointer 
	into the paragraph."

	lastIndex_ lastIndex + 1.
	pendingKernX := 0.
	^false! !

!CanvasCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 12:48'!
paddedSpace
	"Each space is a stop condition when the alignment is right justified. 
	Padding must be added to the base width of the space according to 
	which space in the line this space is and according to the amount of 
	space that remained at the end of the line when it was composed."

	destX _ destX + spaceWidth + (line justifiedPadFor: spaceCount font: font).
	lastIndex _ lastIndex + 1.
	pendingKernX := 0.
	^ false! !

!CanvasCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:03'!
tab

	destX _ (alignment == Justified and: [self leadingTab not])
		ifTrue:		"imbedded tabs in justified text are weird"
			[destX + (textStyle tabWidth - (line justifiedTabDeltaFor: spaceCount)) max: destX]
		ifFalse: 
			[textStyle nextTabXFrom: destX
				leftMargin: leftMargin
				rightMargin: rightMargin].
	lastIndex _ lastIndex + 1.
	pendingKernX := 0.
	^ false! !

!GrafPort methodsFor: '*FreeType-addition' stamp: 'tween 4/5/2007 08:39'!
installFreeTypeFont: aFreeTypeFont foregroundColor: foregroundColor backgroundColor: backgroundColor

	super installFreeTypeFont: aFreeTypeFont foregroundColor: foregroundColor backgroundColor: backgroundColor.
	lastFont _ aFreeTypeFont.
	lastFontForegroundColor _ foregroundColor.
	lastFontBackgroundColor _ backgroundColor.
! !

!GrafPort methodsFor: '*FreeType-override' stamp: 'tween 6/8/2008 12:29'!
installStrikeFont: aStrikeFont foregroundColor: foregroundColor backgroundColor: backgroundColor
	super installStrikeFont: aStrikeFont foregroundColor: foregroundColor backgroundColor: backgroundColor.
	aStrikeFont glyphs depth = 1 ifTrue: [
		alpha := foregroundColor privateAlpha.
		"dynamically switch between blend modes to support translucent text"
		"To handle the transition from TTCFont to StrikeFont, rule 34 must be taken into account."
		alpha = 255 ifTrue:[
			combinationRule = 30 ifTrue: [combinationRule := Form over].
			combinationRule = 31 ifTrue: [combinationRule := Form paint].
			combinationRule = 34 ifTrue: [combinationRule := Form paint].
			combinationRule = 41 ifTrue: [combinationRule := Form paint]. "41 is  SPRmode"
		] ifFalse:[
			combinationRule = Form over ifTrue: [combinationRule := 30].
			combinationRule = Form paint ifTrue: [combinationRule := 31].
			combinationRule = 34 ifTrue: [combinationRule := 31].
			combinationRule = 41 ifTrue: [combinationRule := 31]. "41 is SPR mode"
		]
	].
	lastFont := aStrikeFont.
	lastFontForegroundColor := foregroundColor.
	lastFontBackgroundColor := backgroundColor.
! !

!GrafPort methodsFor: '*FreeType-addition' stamp: 'tween 4/5/2007 08:03'!
lastFontForegroundColor
	^lastFontForegroundColor! !

!MultiCanvasCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:18'!
cr
	"When a carriage return is encountered, simply increment the pointer 
	into the paragraph."

	pendingKernX := 0.
	lastIndex_ lastIndex + 1.
	^false! !

!MultiCanvasCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 12:51'!
paddedSpace
	"Each space is a stop condition when the alignment is right justified. 
	Padding must be added to the base width of the space according to 
	which space in the line this space is and according to the amount of 
	space that remained at the end of the line when it was composed."

	pendingKernX := 0.
	destX _ destX + spaceWidth + (line justifiedPadFor: spaceCount  font: font).
	lastIndex _ lastIndex + 1.
	^ false! !

!MultiCanvasCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:19'!
tab

	pendingKernX := 0.
	destX _ (alignment == Justified and: [self leadingTab not])
		ifTrue:		"imbedded tabs in justified text are weird"
			[destX + (textStyle tabWidth - (line justifiedTabDeltaFor: spaceCount)) max: destX]
		ifFalse: 
			[textStyle nextTabXFrom: destX
				leftMargin: leftMargin
				rightMargin: rightMargin].

	lastIndex _ lastIndex + 1.
	^ false! !

!DisplayScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 12:51'!
paddedSpace
	"Each space is a stop condition when the alignment is right justified. 
	Padding must be added to the base width of the space according to 
	which space in the line this space is and according to the amount of 
	space that remained at the end of the line when it was composed."

	spaceCount _ spaceCount + 1.
	destX _ destX + spaceWidth + (line justifiedPadFor: spaceCount font: font).
	lastIndex _ lastIndex + 1.
	^ false! !

Model subclass: #FontChooser
	instanceVariableNames: 'title selectedFontIndex fontList fontListStrings target getSelector setSelector pointSize fontStyleList selectedFontStyleIndex weightValue slantValue stretchValue pointSizeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-UI'!

!FontChooser class methodsFor: 'as yet unclassified' stamp: 'tween 2/10/2008 11:13'!
open
	"
	FontChooser open.
	"
	| instance morph |
	instance := self new.
	(morph := FontChooserMorph withModel: instance)
		openInWorld.
	^morph! !

!FontChooser class methodsFor: 'as yet unclassified' stamp: 'RobRothwell 12/15/2008 23:21'!
openWithWindowTitle: titleString for: anObject setSelector: setSelector getSelector: getSelector
	"
	FontChooser openWithWindowTitle: 'Choose the Menu Font' for: Preferences setSelector: #setMenuFontTo: getSelector: #standardMenuFont
	"
	| instance windowMorph world |
	instance := self new.
	instance 
		title: titleString;
		target: anObject;
		setSelector: setSelector;
		getSelector: getSelector.
	world := self currentWorld.
	(windowMorph := FontChooserMorph withModel: instance)
		"position: self currentWorld primaryHand position;"
		position: ((World width-640)/2)@((World height-480)/2);
		extent: 640@480;
		openAsMorph.
	^windowMorph
   " [windowMorph model notNil]
       whileTrue: [ world doOneCycle]. self halt.
	^windowMorph result"! !

!FontChooser class methodsFor: 'as yet unclassified' stamp: 'tween 3/2/2008 10:43'!
windowTitle: titleString for: anObject setSelector: setSelector getSelector: getSelector
	| instance answer |
	
	instance := self new.
	instance 
		title: titleString;
		target: anObject;
		setSelector: setSelector;
		getSelector: getSelector.
	(answer := FontChooserMorph withModel: instance)
		position: self currentWorld primaryHand position;
		extent: 450@220;
		createWindow.
	^answer! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 13:46'!
apply
	| font |
	target ifNotNil:[
		setSelector ifNotNil:[
			font := self selectedFont.
			font ifNotNil:[
				target perform: setSelector with: font]]].! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 10:35'!
categoryList
	^OrderedCollection new
		"add:  self allCategoryLabel;
		addAll: preferences categoryNames asSortedCollection;
		add: self searchResultsCategoryLabel;"
		addAll: (TextStyle actualTextStyles keysSortedSafely);
		yourself.! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 9/8/2007 15:14'!
fontList
	
	fontList ifNotNil:[^fontList].
	^fontList := LogicalFontManager current allFamilies! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/16/2007 22:30'!
fontListStrings

	^fontListStrings ifNil:[
		fontListStrings := self fontList collect:[:each | each familyName]]! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/19/2007 16:22'!
fontStyleList
	| family |
	family := self selectedFontFamily.
	family ifNotNil:[^fontStyleList := family members asSortedCollection].
	^#()! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/17/2007 00:15'!
fontStyleListStrings
	"names of simulated styles are enclosed in parenthesis"
	^self fontStyleList collect: [:fontFamilyMember | | s |
		s := fontFamilyMember styleName.
		fontFamilyMember simulated
			ifTrue:[s := '(', s, ')'].
		s]! !

!FontChooser methodsFor: 'accessing' stamp: 'tween 8/4/2007 13:44'!
getSelector
	"Answer the value of getSelector"

	^ getSelector! !

!FontChooser methodsFor: 'accessing' stamp: 'tween 8/4/2007 20:16'!
getSelector: aSelectorSymbolOrFont
	"Set the value of getSelector"

	getSelector := aSelectorSymbolOrFont! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 10:27'!
initialize
	super initialize.
	title := 'Choose A Font'.! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 15:23'!
pointSize
	^pointSize ifNil: [pointSize := 10.0]! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 17:34'!
pointSize: aNumber
	pointSize := aNumber.
	self changed: #pointSize! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 23:50'!
pointSizeList

	^pointSizeList ifNil:[ pointSizeList := (1 to: 256) collect: [:each | each asString padded: #left to: 3 with: $ ]]! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/18/2007 11:18'!
selectedFont
	| font style |

	font := self unemphasizedSelectedFont.
	font ifNil:[^nil].
	style := self fontStyleList at: self selectedFontStyleIndex ifAbsent:[nil].
	style ifNil:[^nil].
	(style isKindOf: TextStyleAsFontFamilyMember)
		ifTrue:[	^font emphasized: style emphasisCode].		
	^LogicalFont 
		familyName: font familyName 
		pointSize: pointSize 
		stretchValue: style stretchValue
		weightValue: style weightValue
		slantValue: style slantValue

	! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/16/2007 22:42'!
selectedFontFamily
	| |

	^self fontList at: self selectedFontIndex ifAbsent:[nil].
	
	! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/28/2007 00:20'!
selectedFontIndex
	| font textStyleName family |
	selectedFontIndex ifNotNil: [^selectedFontIndex].
	selectedFontIndex := 0.
	font := (getSelector isSymbol and:[target notNil])
		ifTrue:[target perform: getSelector]
		ifFalse:[getSelector].
	self setStyleValuesFrom: font.
	(font isKindOf: AbstractFont)
		ifTrue:[
			pointSize := font pointSize.
			textStyleName := font textStyleName.
			family := self fontList detect:[:f | f familyName = textStyleName] ifNone:[].
			selectedFontIndex := self fontList indexOf: family ifAbsent:[0]].
	self selectedFontIndex: selectedFontIndex.
	^selectedFontIndex! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/28/2007 00:11'!
selectedFontIndex: anIndex
	| family member newStyleIndex |
	anIndex = 0
		ifTrue: [^self].
	selectedFontIndex := anIndex.
	"change the selected style to be the closest to the last
	user selected weight slant and stretch values. 
	By user selected I mean that the user changed the style list selection, 
	rather than a change being forced because a particular family didn't have that style"
	family := self fontList at: selectedFontIndex.
	member := family closestMemberWithStretchValue: stretchValue weightValue: weightValue slantValue: slantValue.
	newStyleIndex := self fontStyleList indexOf: member.
	selectedFontStyleIndex := newStyleIndex. 
	self setPointSizeListFrom: member.
	self changed: #selectedFontIndex.
	self changed: #selectedFontStyleIndex.! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/19/2007 16:23'!
selectedFontStyleIndex
	| family member |
	selectedFontStyleIndex ifNotNil: [
		^selectedFontStyleIndex := selectedFontStyleIndex min: self fontStyleList size].
	family := self fontList at: selectedFontIndex ifAbsent:[^0].
	member := family closestMemberWithStretchValue: stretchValue weightValue: weightValue slantValue: slantValue.
	selectedFontStyleIndex := self fontStyleList indexOf: member.
	^selectedFontStyleIndex! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/18/2007 12:07'!
selectedFontStyleIndex: anIndex
	| familyMember |
	anIndex = 0
		ifTrue: [^self].
	selectedFontStyleIndex := anIndex.
	familyMember := self fontStyleList at: anIndex.
	self setStyleValuesFrom: familyMember.
	self changed: #selectedFontStyleIndex! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 23:12'!
selectedPointSize
	^self selectedFont pointSize! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/28/2007 00:08'!
selectedPointSizeIndex
	^self pointSizeList indexOf: (pointSize reduce asString padded: #left to: 3 with: $ )! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/28/2007 00:06'!
selectedPointSizeIndex: anIndex

	anIndex = 0
		ifTrue: [^self].
	pointSize := (self pointSizeList at: anIndex) withBlanksTrimmed asNumber.
	self changed: #pointSize! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/28/2007 00:12'!
setPointSizeListFrom: aFontFamilyMember
	| style old new |
	old := pointSizeList.
	(aFontFamilyMember isKindOf: FontFamilyMemberAbstract)
		ifTrue:[
			style := TextStyle named: aFontFamilyMember family familyName.
			style ifNotNil:[
				new := style pointSizes collect: [:each | each reduce asString padded: #left to: 3 with: $ ]]].
	new ifNil:[new := (1 to: 256) collect: [:each | each asString padded: #left to: 3 with: $ ]].
	pointSizeList := new.
	old ~= new ifTrue:[self changed: #pointSizeList]! !

!FontChooser methodsFor: 'accessing' stamp: 'tween 8/4/2007 13:44'!
setSelector: anObject
	"Set the value of setSelector"

	setSelector := anObject! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/18/2007 13:49'!
setStyleValuesFrom: aFont
	((aFont isKindOf: LogicalFont) or:[aFont isKindOf: FontFamilyMemberAbstract])
		ifTrue:[
			weightValue := aFont weightValue.
			slantValue := aFont slantValue.
			stretchValue := aFont stretchValue]
		ifFalse:[
			weightValue := (aFont emphasis bitAnd: 1) > 0 ifTrue:[700] ifFalse:[400].
			slantValue := (aFont emphasis bitAnd: 2) > 0 ifTrue:[1] ifFalse:[0].
			stretchValue := 5 "normal"]! !

!FontChooser methodsFor: 'accessing' stamp: 'tween 8/4/2007 13:44'!
target
	"Answer the value of target"

	^ target! !

!FontChooser methodsFor: 'accessing' stamp: 'tween 8/4/2007 13:44'!
target: anObject
	"Set the value of target"

	target := anObject! !

!FontChooser methodsFor: 'accessing' stamp: 'tween 8/4/2007 13:44'!
title: anObject
	"Set the value of title"

	title := anObject! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/18/2007 21:10'!
unemphasizedSelectedFont
	|name font family |
	family := self fontList at: self selectedFontIndex ifAbsent:[nil].
	family ifNil:[^nil].
	(family isKindOf: TextStyleAsFontFamily)
		ifTrue:[^family textStyle fontOfPointSize: pointSize].
	name :=  family familyName.
	font := LogicalFont 
		familyName: name
		pointSize: pointSize 
		stretchValue: 5
		weightValue: 400
		slantValue: 0.
	font realFont isTTCFont "true for FreeTypeFont"
		ifFalse: [font := font textStyle fontOfPointSize: pointSize].
	^font
! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'RobRothwell 12/15/2008 22:54'!
updateFontList
	FreeTypeFontProvider current updateFromSystem.! !

!FontChooser methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 10:27'!
windowTitle
	^ title translated! !

!MultiCompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:11'!
columnBreak

	"Answer true. Set up values for the text line interval currently being 
	composed."

	pendingKernX := 0.
	line stop: lastIndex.
	presentationLine stop: lastIndex - numOfComposition.
	spaceX _ destX.
	line paddingWidth: rightMargin - spaceX.
	presentationLine paddingWidth: rightMargin - spaceX.
	^true! !

!MultiCompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:11'!
cr
	"Answer true. Set up values for the text line interval currently being 
	composed."

	pendingKernX := 0.
	line stop: lastIndex.
	presentationLine stop: lastIndex - numOfComposition.
	spaceX _ destX.
	line paddingWidth: rightMargin - spaceX.
	presentationLine paddingWidth: rightMargin - spaceX.
	^true! !

!MultiCompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:21'!
crossedX
	"There is a word that has fallen across the right edge of the composition 
	rectangle. This signals the need for wrapping which is done to the last 
	space that was encountered, as recorded by the space stop condition."

	pendingKernX := 0.
	(breakAtSpace) ifTrue: [
		spaceCount >= 1 ifTrue:
			["The common case. First back off to the space at which we wrap."
			line stop: breakableIndex.
			presentationLine stop: breakableIndex - numOfComposition.
			lineHeight _ lineHeightAtBreak.
			baseline _ baselineAtBreak.
			spaceCount _ spaceCount - 1.
			breakableIndex _ breakableIndex - 1.

			"Check to see if any spaces preceding the one at which we wrap.
				Double space after punctuation, most likely."
			[(spaceCount > 1 and: [(text at: breakableIndex) = Space])]
				whileTrue:
					[spaceCount _ spaceCount - 1.
					"Account for backing over a run which might
						change width of space."
					font _ text fontAt: breakableIndex withStyle: textStyle.
					breakableIndex _ breakableIndex - 1.
					spaceX _ spaceX - (font widthOf: Space)].
			line paddingWidth: rightMargin - spaceX.
			presentationLine paddingWidth: rightMargin - spaceX.
			presentationLine internalSpaces: spaceCount.
			line internalSpaces: spaceCount]
		ifFalse:
			["Neither internal nor trailing spaces -- almost never happens."
			lastIndex _ lastIndex - 1.
			[destX <= rightMargin]
				whileFalse:
					[destX _ destX - (font widthOf: (text at: lastIndex)).
					lastIndex _ lastIndex - 1].
			spaceX _ destX.
			line paddingWidth: rightMargin - destX.
			presentationLine paddingWidth: rightMargin - destX.
			presentationLine stop: (lastIndex max: line first).
			line stop: (lastIndex max: line first)].
		^true
	].

	(breakableIndex isNil or: [breakableIndex < line first]) ifTrue: [
		"Any breakable point in this line.  Just wrap last character."
		breakableIndex _ lastIndex - 1.
		lineHeightAtBreak _ lineHeight.
		baselineAtBreak _ baseline.
	].

	"It wasn't a space, but anyway this is where we break the line."
	line stop: breakableIndex.
	presentationLine stop: breakableIndex.
	lineHeight _ lineHeightAtBreak.
	baseline _ baselineAtBreak.
	^ true.
! !

!MultiCompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:12'!
tab
	"Advance destination x according to tab settings in the paragraph's 
	textStyle. Answer whether the character has crossed the right edge of 
	the composition rectangle of the paragraph."

	pendingKernX := 0.
	destX _ textStyle
				nextTabXFrom: destX leftMargin: leftMargin rightMargin: rightMargin.
	destX > rightMargin ifTrue:	[^self crossedX].
	lastIndex _ lastIndex + 1.
	^false
! !

LinkedList subclass: #FreeTypeCacheLinkedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Cache'!

!FreeTypeCacheLinkedList methodsFor: 'adding' stamp: 'tween 8/10/2006 18:47'!
add: link after: otherLink
	"Add otherLink  after link in the list. Answer aLink."

	| savedLink |

	savedLink := otherLink nextLink.
	otherLink nextLink: link.
	link nextLink:  savedLink.
	savedLink == nil ifFalse:[savedLink previousLink: link].
	link previousLink: otherLink.
	^link.
	
	! !

!FreeTypeCacheLinkedList methodsFor: 'adding' stamp: 'tween 8/10/2006 18:47'!
add: link before: otherLink
	| savedLink |
	firstLink == otherLink ifTrue: [^ self addFirst: link].
	otherLink 
		ifNotNil:[
			savedLink := otherLink previousLink.
			link nextLink: otherLink.
			link previousLink: savedLink.
			otherLink previousLink: link.
			savedLink == nil ifFalse:[savedLink nextLink: link]].
	^ self errorNotFound: otherLink! !

!FreeTypeCacheLinkedList methodsFor: 'adding' stamp: 'tween 8/10/2006 18:52'!
addFirst: aLink 
	"Add aLink to the beginning of the receiver's list. Answer aLink."

	self isEmpty 
		ifTrue: [^lastLink _firstLink _ aLink].
	aLink nextLink: firstLink.
	aLink previousLink: nil.
	firstLink == nil ifFalse: [firstLink previousLink: aLink].
	firstLink _ aLink.
	^aLink! !

!FreeTypeCacheLinkedList methodsFor: 'adding' stamp: 'tween 8/10/2006 18:52'!
addLast: aLink 
	"Add aLink to the end of the receiver's list. Answer aLink."

	self isEmpty 
		ifTrue: [^firstLink _ lastLink _ aLink].
	aLink previousLink: lastLink.
	aLink nextLink: nil.
	lastLink == nil ifFalse: [lastLink nextLink: aLink].
	lastLink _ aLink.
	^aLink! !

!FreeTypeCacheLinkedList methodsFor: 'reordering' stamp: 'tween 3/31/2007 12:31'!
moveDown: aLink
	|  e1 e2 e3 e4  |
	
	(e3 := aLink nextLink) ifNil:[^self].
	e2 := aLink.
	e4 := e3 nextLink.
	e1 := e2 previousLink.
	"swap e2 & e3"
	e1 ifNotNil:[e1 nextLink: e2].
	e2 nextLink: e3.
	e3 nextLink: e4.
	e4 ifNotNil:[e4 previousLink: e3].
	e3 previousLink: e2.
	e2 previousLink: e1

	! !

!FreeTypeCacheLinkedList methodsFor: 'removing' stamp: 'tween 8/10/2006 18:48'!
remove: aLink ifAbsent: aBlock  
	| prev next  |

	prev := aLink previousLink.
	next := aLink nextLink.
	prev == nil ifFalse: [prev nextLink: next].
	next == nil ifFalse: [next previousLink: prev].
	aLink == firstLink ifTrue:[firstLink := next].
	aLink == lastLink ifTrue:[lastLink := prev].
	aLink nextLink: nil.
	aLink previousLink: nil.		
	^aLink! !

!FreeTypeCacheLinkedList methodsFor: 'removing' stamp: 'tween 8/10/2006 21:06'!
removeFirst
	"Remove the first element and answer it. If the receiver is empty, create 
	an error notification."

	| oldLink |
	self emptyCheck.
	oldLink _ firstLink.
	oldLink previousLink: nil.
	lastLink == firstLink 
		ifTrue:[
			lastLink _ firstLink _ nil.
			oldLink nextLink: nil.
			^oldLink].
	firstLink := oldLink nextLink.
	firstLink == nil 
		ifTrue:[firstLink _ lastLink _ nil]
		ifFalse:[firstLink previousLink: nil].
	oldLink nextLink: nil.
	^oldLink! !

!FreeTypeCacheLinkedList methodsFor: 'removing' stamp: 'tween 8/10/2006 21:09'!
removeLast
	"Remove the first element and answer it. If the receiver is empty, create 
	an error notification."

	| oldLink |
	self emptyCheck.
	oldLink _ lastLink.
	oldLink nextLink: nil.
	lastLink == firstLink 
		ifTrue:[
			lastLink _ firstLink _ nil.
			oldLink previousLink: nil.
			^oldLink].
	lastLink := oldLink previousLink.
	lastLink == nil 
		ifTrue:[firstLink _ lastLink _ nil]
		ifFalse:[lastLink nextLink: nil].
	oldLink previousLink: nil.
	^oldLink! !

!PluggableListMorph methodsFor: '*FreeType-override' stamp: 'tween 9/8/2007 14:56'!
setListFont
	"set the font for the list"

	Preferences 
		chooseFontWithPrompt: 'Choose the font for this list' translated 
		andSendTo: self 
		withSelector: #font: 
		highlightSelector: #font! !

!TextLineInterval methodsFor: '*FreeType-addition' stamp: 'tween 4/6/2007 12:48'!
justifiedPadFor: spaceIndex font: aFont
	"Compute the width of pad for a given space in a line of justified text."

	| pad |
	internalSpaces = 0 ifTrue: [^0].
	^(aFont notNil and:[aFont isSubPixelPositioned])
		ifTrue:[paddingWidth * 1.0 / internalSpaces]
		ifFalse:[
			pad _ paddingWidth // internalSpaces.
			spaceIndex <= (paddingWidth \\ internalSpaces)
				ifTrue: [pad + 1]
				ifFalse: [pad]]! !

!CompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:13'!
columnBreak

	"Answer true. Set up values for the text line interval currently being 
	composed."

	pendingKernX := 0.
	line stop: lastIndex.
	spaceX _ destX.
	line paddingWidth: rightMargin - spaceX.
	^true! !

!CompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:14'!
cr
	"Answer true. Set up values for the text line interval currently being 
	composed."

	pendingKernX := 0.
	line stop: lastIndex.
	spaceX _ destX.
	line paddingWidth: rightMargin - spaceX.
	^true! !

!CompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:14'!
crossedX
	"There is a word that has fallen across the right edge of the composition 
	rectangle. This signals the need for wrapping which is done to the last 
	space that was encountered, as recorded by the space stop condition."

	pendingKernX := 0.
	spaceCount >= 1 ifTrue:
		["The common case. First back off to the space at which we wrap."
		line stop: spaceIndex.
		lineHeight _ lineHeightAtSpace.
		baseline _ baselineAtSpace.
		spaceCount _ spaceCount - 1.
		spaceIndex _ spaceIndex - 1.

		"Check to see if any spaces preceding the one at which we wrap.
			Double space after punctuation, most likely."
		[(spaceCount > 1 and: [(text at: spaceIndex) = Space])]
			whileTrue:
				[spaceCount _ spaceCount - 1.
				"Account for backing over a run which might
					change width of space."
				font _ text fontAt: spaceIndex withStyle: textStyle.
				spaceIndex _ spaceIndex - 1.
				spaceX _ spaceX - (font widthOf: Space)].
		line paddingWidth: rightMargin - spaceX.
		line internalSpaces: spaceCount]
	ifFalse:
		["Neither internal nor trailing spaces -- almost never happens."
		lastIndex _ lastIndex - 1.
		[destX <= rightMargin]
			whileFalse:
				[destX _ destX - (font widthOf: (text at: lastIndex)).
				lastIndex _ lastIndex - 1].
		spaceX _ destX.
		line paddingWidth: rightMargin - destX.
		line stop: (lastIndex max: line first)].
	^true! !

!CompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:14'!
space
	"Record left x and character index of the space character just encounted. 
	Used for wrap-around. Answer whether the character has crossed the 
	right edge of the composition rectangle of the paragraph."

	pendingKernX := 0.
	spaceX _ destX.
	destX _ spaceX + spaceWidth.
	spaceIndex _ lastIndex.
	lineHeightAtSpace _ lineHeight.
	baselineAtSpace _ baseline.
	lastIndex _ lastIndex + 1.
	spaceCount _ spaceCount + 1.
	destX > rightMargin ifTrue: 	[^self crossedX].
	^false
! !

!CompositionScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:15'!
tab
	"Advance destination x according to tab settings in the paragraph's 
	textStyle. Answer whether the character has crossed the right edge of 
	the composition rectangle of the paragraph."

	pendingKernX := 0.
	destX _ textStyle
				nextTabXFrom: destX leftMargin: leftMargin rightMargin: rightMargin.
	destX > rightMargin ifTrue:	[^self crossedX].
	lastIndex _ lastIndex + 1.
	^false
! !

!CharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 09:53'!
basicScanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta
	"Primitive. This is the inner loop of text display--but see 
	scanCharactersFrom: to:rightX: which would get the string, 
	stopConditions and displaying from the instance. March through source 
	String from startIndex to stopIndex. If any character is flagged with a 
	non-nil entry in stops, then return the corresponding value. Determine 
	width of each character from xTable, indexed by map. 
	If dextX would exceed rightX, then return stops at: 258. 
	Advance destX by the width of the character. If stopIndex has been
	reached, then return stops at: 257. Optional. 
	See Object documentation whatIsAPrimitive."
	| ascii nextDestX char  floatDestX widthAndKernedWidth nextChar atEndOfRun |
	<primitive: 103>
	lastIndex _ startIndex.
	floatDestX := destX.
	widthAndKernedWidth := Array new: 2.
	atEndOfRun := false.
	[lastIndex <= stopIndex]
		whileTrue: 
			[char _ (sourceString at: lastIndex).
			ascii _ char asciiValue + 1.
			(stops at: ascii) == nil ifFalse: [^stops at: ascii].
			"Note: The following is querying the font about the width
			since the primitive may have failed due to a non-trivial
			mapping of characters to glyphs or a non-existing xTable."
			nextChar := (lastIndex + 1 <= stopIndex) 
				ifTrue:[sourceString at: lastIndex + 1]
				ifFalse:[
					atEndOfRun := true.
					"if there is a next char in sourceString, then get the kern 
					and store it in pendingKernX"
					lastIndex + 1 <= sourceString size
						ifTrue:[sourceString at: lastIndex + 1]
						ifFalse:[	nil]].
			font 
				widthAndKernedWidthOfLeft: char 
				right: nextChar
				into: widthAndKernedWidth.
			nextDestX _ floatDestX + (widthAndKernedWidth at: 1).
			nextDestX > rightX ifTrue: [^stops at: CrossedX].
			floatDestX := floatDestX + kernDelta + (widthAndKernedWidth at: 2).
			atEndOfRun 
				ifTrue:[
					pendingKernX := (widthAndKernedWidth at: 2) - (widthAndKernedWidth at: 1).
					floatDestX := floatDestX - pendingKernX].
			destX _ floatDestX.
			lastIndex _ lastIndex + 1].
	lastIndex _ stopIndex.
	^stops at: EndOfRun! !

!CharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:16'!
columnBreak

	pendingKernX := 0.
	^true! !

!CharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 09:59'!
setFont
	| priorFont |
	"Set the font and other emphasis."
	priorFont _ font.
	text == nil ifFalse:[
		emphasisCode _ 0.
		kern _ 0.
		indentationLevel _ 0.
		alignment _ textStyle alignment.
		font _ nil.
		(text attributesAt: lastIndex forStyle: textStyle)
			do: [:att | att emphasizeScanner: self]].
	font == nil ifTrue:
		[self setFont: textStyle defaultFontIndex].
	font _ font emphasized: emphasisCode.
	priorFont 
		ifNotNil: [
			font = priorFont 
				ifTrue:[
					"font is the same, perhaps the color has changed?
					We still want kerning between chars of the same
					font, but of different color. So add any pending kern to destX"
					destX := destX + (pendingKernX ifNil:[0])].
			destX _ destX + priorFont descentKern].
	pendingKernX := 0. "clear any pending kern so there is no danger of it being added twice"
	destX _ destX - font descentKern.
	"NOTE: next statement should be removed when clipping works"
	leftMargin ifNotNil: [destX _ destX max: leftMargin].
	kern _ kern - font baseKern.

	"Install various parameters from the font."
	spaceWidth _ font widthOf: Space.
	xTable _ font xTable.
	stopConditions _ DefaultStopConditions.! !

!MultiCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 10:11'!
basicScanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta
	"Primitive. This is the inner loop of text display--but see 
	scanCharactersFrom: to:rightX: which would get the string, 
	stopConditions and displaying from the instance. March through source 
	String from startIndex to stopIndex. If any character is flagged with a 
	non-nil entry in stops, then return the corresponding value. Determine 
	width of each character from xTable, indexed by map. 
	If dextX would exceed rightX, then return stops at: 258. 
	Advance destX by the width of the character. If stopIndex has been
	reached, then return stops at: 257. Optional. 
	See Object documentation whatIsAPrimitive."
	| ascii nextDestX char floatDestX widthAndKernedWidth nextChar atEndOfRun |
	<primitive: 103>
	lastIndex _ startIndex.
	floatDestX := destX.
	widthAndKernedWidth := Array new: 2.
	atEndOfRun := false.
	[lastIndex <= stopIndex]
		whileTrue: 
			[char _ (sourceString at: lastIndex).
			ascii _ char asciiValue + 1.
			(stops at: ascii) == nil ifFalse: [^stops at: ascii].
			"Note: The following is querying the font about the width
			since the primitive may have failed due to a non-trivial
			mapping of characters to glyphs or a non-existing xTable."
			nextChar := (lastIndex + 1 <= stopIndex) 
				ifTrue:[sourceString at: lastIndex + 1]
				ifFalse:[
					atEndOfRun := true.
					"if there is a next char in sourceString, then get the kern 
					and store it in pendingKernX"
					lastIndex + 1 <= sourceString size
						ifTrue:[sourceString at: lastIndex + 1]
						ifFalse:[	nil]].
			font 
				widthAndKernedWidthOfLeft: char 
				right: nextChar
				into: widthAndKernedWidth.
			nextDestX _ floatDestX + (widthAndKernedWidth at: 1).
			nextDestX > rightX ifTrue: [^stops at: CrossedX].
			floatDestX := floatDestX + kernDelta + (widthAndKernedWidth at: 2).
			atEndOfRun 
				ifTrue:[
					pendingKernX := (widthAndKernedWidth at: 2) - (widthAndKernedWidth at: 1).
					floatDestX := floatDestX - pendingKernX].
			destX _ floatDestX.
			lastIndex _ lastIndex + 1].
	lastIndex _ stopIndex.
	^stops at: EndOfRun! !

!MultiCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 11:17'!
columnBreak

	pendingKernX := 0.
	^true! !

!MultiCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 10:56'!
plainTab
	"This is the basic method of adjusting destX for a tab."
	destX _ (alignment == Justified and: [self leadingTab not])
		ifTrue:		"embedded tabs in justified text are weird"
			[destX + (textStyle tabWidth - (line justifiedTabDeltaFor: spaceCount)) max: destX]
		ifFalse: 
			[textStyle nextTabXFrom: destX
				leftMargin: leftMargin
				rightMargin: rightMargin].
	pendingKernX := 0.! !

!MultiCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 10:14'!
scanMultiCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta

	| ascii encoding f nextDestX maxAscii startEncoding floatDestX widthAndKernedWidth nextChar atEndOfRun |
	lastIndex _ startIndex.
	lastIndex > stopIndex ifTrue: [lastIndex _ stopIndex. ^ stops at: EndOfRun].
	startEncoding _ (sourceString at: startIndex) leadingChar.
	font ifNil: [font _ (TextConstants at: #DefaultMultiStyle) fontArray at: 1].
	((font isMemberOf: StrikeFontSet) or: [font isKindOf: TTCFontSet]) ifTrue: [
		[f _ font fontArray at: startEncoding + 1]
			on: Exception do: [:ex | f _ font fontArray at: 1].
		f ifNil: [ f _ font fontArray at: 1].
		maxAscii _ f maxAscii.
		spaceWidth _ f widthOf: Space.
	] ifFalse: [
		maxAscii _ font maxAscii.
	].
	floatDestX := destX.
	widthAndKernedWidth := Array new: 2.
	atEndOfRun := false.
	[lastIndex <= stopIndex] whileTrue: [
		encoding _ (sourceString at: lastIndex) leadingChar.
		encoding ~= startEncoding ifTrue: [lastIndex _ lastIndex - 1. ^ stops at: EndOfRun].
		ascii _ (sourceString at: lastIndex) charCode.
		ascii > maxAscii ifTrue: [ascii _ maxAscii].
		(encoding = 0 and: [ascii < stopConditions size and: [(stopConditions at: ascii + 1) ~~ nil]]) ifTrue: [^ stops at: ascii + 1].
		(self isBreakableAt: lastIndex in: sourceString in: Latin1Environment) ifTrue: [
			self registerBreakableIndex.
		].
		nextChar := (lastIndex + 1 <= stopIndex) 
			ifTrue:[sourceString at: lastIndex + 1]
			ifFalse:[
				atEndOfRun := true.
				"if there is a next char in sourceString, then get the kern 
				and store it in pendingKernX"
				lastIndex + 1 <= sourceString size
					ifTrue:[sourceString at: lastIndex + 1]
					ifFalse:[	nil]].
		font 
			widthAndKernedWidthOfLeft: (sourceString at: lastIndex) 
			right: nextChar
			into: widthAndKernedWidth.
		nextDestX _ floatDestX + (widthAndKernedWidth at: 1).
		nextDestX > rightX ifTrue: [destX ~= firstDestX ifTrue: [^stops at: CrossedX]].
		floatDestX := floatDestX + kernDelta + (widthAndKernedWidth at: 2).
		atEndOfRun 
			ifTrue:[
				pendingKernX := (widthAndKernedWidth at: 2) - (widthAndKernedWidth at: 1).
				floatDestX := floatDestX - pendingKernX].
		destX _ floatDestX .
		lastIndex _ lastIndex + 1.
	].
	lastIndex _ stopIndex.
	^ stops at: EndOfRun! !

!MultiCharacterScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 10:16'!
setFont
	| priorFont |
	"Set the font and other emphasis."
	priorFont _ font.
	text == nil ifFalse:[
		emphasisCode _ 0.
		kern _ 0.
		indentationLevel _ 0.
		alignment _ textStyle alignment.
		font _ nil.
		(text attributesAt: lastIndex forStyle: textStyle)
			do: [:att | att emphasizeScanner: self]].
	font == nil ifTrue:
		[self setFont: textStyle defaultFontIndex].
	font _ font emphasized: emphasisCode.
	priorFont 
		ifNotNil: [
			font = priorFont 
				ifTrue:[
					"font is the same, perhaps the color has changed?
					We still want kerning between chars of the same
					font, but of different color. So add any pending kern to destX"
					destX := destX + (pendingKernX ifNil:[0])].
			destX _ destX + priorFont descentKern].
	pendingKernX := 0. "clear any pending kern so there is no danger of it being added twice"
	destX _ destX - font descentKern.
	"NOTE: next statement should be removed when clipping works"
	leftMargin ifNotNil: [destX _ destX max: leftMargin].
	kern _ kern - font baseKern.

	"Install various parameters from the font."
	spaceWidth _ font widthOf: Space.
	xTable _ font xTable.
"	map _ font characterToGlyphMap."
	stopConditions _ DefaultStopConditions.! !

!Preferences class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 01:59'!
chooseCodeFont
	"Not currently sent, but once protocols are sorted out so that we can disriminate on whether a text object being launched is for code or not, will be reincorporated"

	self 
		chooseFontWithPrompt: 'Code font...' translated 
		andSendTo: self 
		withSelector: #setCodeFontTo: 
		highlightSelector: #standardCodeFont.! !

!Preferences class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 02:00'!
chooseFlapsFont
	self 
		chooseFontWithPrompt: 'Flaps font...' translated
		andSendTo: self 
		withSelector: #setFlapsFontTo: 
		highlightSelector: #standardFlapFont! !

!Preferences class methodsFor: '*FreeType-addition' stamp: 'marcus.denker 11/27/2008 16:16'!
chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector highlightSelector: highlightSelector

	FontChooser openWithWindowTitle: aPrompt 
				for: aReceiver 
				setSelector: aSelector
				getSelector: highlightSelector
	! !

!Preferences class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 02:00'!
chooseHaloLabelFont
	"present a menu with the possible fonts for label in halo"
	self
		chooseFontWithPrompt: 'Halo Label font...'
		andSendTo: self
		withSelector: #setHaloLabelFontTo:
		highlightSelector: #standardHaloLabelFont! !

!Preferences class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 02:01'!
chooseListFont
	self 
		chooseFontWithPrompt: 'List font...' translated
		andSendTo: self 
		withSelector: #setListFontTo: 
		highlightSelector: #standardListFont! !

!Preferences class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 02:01'!
chooseMenuFont
	self 
		chooseFontWithPrompt: 'Menu font...' translated
		andSendTo: self 
		withSelector: #setMenuFontTo: 
		highlightSelector: #standardMenuFont! !

!Preferences class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 02:01'!
chooseStandardButtonFont
	self 
		chooseFontWithPrompt: 'Button font...' translated
		andSendTo: self 
		withSelector: #setButtonFontTo: 
		highlightSelector: #standardButtonFont

! !

!Preferences class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 02:01'!
chooseSystemFont
	self 
		chooseFontWithPrompt: 'Default font...' translated
		andSendTo: self 
		withSelector: #setSystemFontTo: 
		highlightSelector: #standardSystemFont! !

!Preferences class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 02:01'!
chooseWindowTitleFont
	self 
		chooseFontWithPrompt: 'Window Title font...' translated
		andSendTo: self 
		withSelector: #setWindowTitleFontTo: 
		highlightSelector: #windowTitleFont! !

!Preferences class methodsFor: '*FreeType-addition' stamp: 'tween 8/4/2007 14:30'!
standardSystemFont
	"Answer the standard system font "

	^(TextConstants at: #DefaultTextStyle) defaultFont! !

!TransformMorph methodsFor: '*FreeType-override' stamp: 'tween 3/30/2007 18:33'!
drawSubmorphsOn: aCanvas

	aCanvas transformBy: transform
		clippingTo: self innerBounds
		during: [:myCanvas |
			(self angle ~= 0.0 or: [self scale ~= 1.0])
				ifTrue:[ 
					FreeTypeSettings current forceNonSubPixelDuring:[
						submorphs reverseDo:[:m | myCanvas fullDrawMorph: m] ] ]
				ifFalse:[
					submorphs reverseDo:[:m | myCanvas fullDrawMorph: m] ] ] 
		smoothing: smoothing! !

Error subclass: #FT2Error
	instanceVariableNames: 'errorCode errorString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2Error commentStamp: '<historical>' prior: 0!
This is an Error that knows how to get the Freetype2 error code and string.!

!FT2Error methodsFor: 'accessing' stamp: 'nk 11/4/2004 13:31'!
errorCode
	errorCode
		ifNotNil: [^ errorCode].
	^ errorCode := [FT2Library errorCode]
				on: Error
				do: [:ex | ex return: 'can''t get error code']! !

!FT2Error methodsFor: 'accessing' stamp: 'nk 11/4/2004 13:31'!
errorString
	errorString
		ifNotNil: [^ errorString].
	^ errorString := [FT2Library errorString]
				on: Error
				do: [:ex | ex return: 'can''t get error string']! !

!FT2Error methodsFor: 'accessing' stamp: 'nk 3/17/2005 12:50'!
messageText
	^String streamContents: [ :strm |
		messageText ifNotNil: [ strm nextPutAll: messageText; space ].
		self errorCode isZero ifFalse: [
			strm nextPutAll: '[error '; print: self errorCode; nextPutAll: '][';
				nextPutAll: self errorString;
				nextPut: $] ]]! !

!TextLine methodsFor: '*FreeType-addition' stamp: 'tween 4/6/2007 12:48'!
justifiedPadFor: spaceIndex font: aFont
	"Compute the width of pad for a given space in a line of justified text."

	| pad |
	internalSpaces = 0 ifTrue: [^0].
	^(aFont notNil and:[aFont isSubPixelPositioned])
		ifTrue:[paddingWidth * 1.0 / internalSpaces]
		ifFalse:[
			pad _ paddingWidth // internalSpaces.
			spaceIndex <= (paddingWidth \\ internalSpaces)
				ifTrue: [pad + 1]
				ifFalse: [pad]]
		! !

WeakRegistry subclass: #FT2HandleRegistry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2HandleRegistry methodsFor: 'as yet unclassified' stamp: 'nk 3/17/2005 16:54'!
add: anObject
	"Add anObject to the receiver. Store the object as well as the associated executor."
	| executor dup |
	executor := anObject executor.
	dup := nil.
	self protected:[
		dup := valueDictionary detect: [ :v | v handle = executor handle ] ifNone: [ ].
		valueDictionary at: anObject put: executor.
	].
	dup ifNotNil: [ self error: 'Duplicate object added!!'. self remove: anObject ].
	^anObject! !

Form subclass: #GlyphForm
	instanceVariableNames: 'advance linearAdvance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Fonts'!

!GlyphForm methodsFor: 'accessing' stamp: 'tween 4/23/2006 20:54'!
advance
	^advance! !

!GlyphForm methodsFor: 'accessing' stamp: 'tween 4/23/2006 20:54'!
advance: aNumber
	^advance := aNumber! !

!GlyphForm methodsFor: 'converting' stamp: 'tween 8/6/2006 21:57'!
asFormOfDepth: d
	| newForm |
	d = self depth ifTrue:[^self].
	newForm := self class extent: self extent depth: d.
	(BitBlt current toForm: newForm)
		colorMap: (self colormapIfNeededFor: newForm);
		copy: (self boundingBox)
		from: 0@0 in: self
		fillColor: nil rule: Form over.
	newForm 
		offset: offset;
		advance:advance;
		linearAdvance: linearAdvance.
	^newForm! !

!GlyphForm methodsFor: 'accessing' stamp: 'tween 8/6/2006 21:10'!
linearAdvance
	^linearAdvance
! !

!GlyphForm methodsFor: 'accessing' stamp: 'tween 8/6/2006 21:10'!
linearAdvance: aNumber
	^linearAdvance := aNumber! !

!MultiCharacterBlockScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 12:52'!
crossedX
	"Text display has wrapping. The scanner just found a character past the x 
	location of the cursor. We know that the cursor is pointing at a character 
	or before one."

	| leadingTab currentX |
	characterIndex == nil ifFalse: [
		"If the last character of the last line is a space,
		and it crosses the right margin, then locating
		the character block after it is impossible without this hack."
		characterIndex > text size ifTrue: [
			lastIndex _ characterIndex.
			characterPoint _ (nextLeftMargin ifNil: [leftMargin]) @ (destY + line lineHeight).
			^true]].
	characterPoint x <= (destX + (lastCharacterExtent x // 2))
		ifTrue:	[lastCharacter _ (text at: lastIndex).
				characterPoint _ destX @ destY.
				^true].
	lastIndex >= line last 
		ifTrue:	[lastCharacter _ (text at: line last).
				characterPoint _ destX @ destY.
				^true].

	"Pointing past middle of a character, return the next character."
	lastIndex _ lastIndex + 1.
	lastCharacter _ text at: lastIndex.
	currentX _ destX + lastCharacterExtent x + kern.
	self lastCharacterExtentSetX: (font widthOf: lastCharacter).
	characterPoint _ currentX @ destY.
	lastCharacter = Space ifFalse: [^ true].

	"Yukky if next character is space or tab."
	alignment = Justified ifTrue:
		[self lastCharacterExtentSetX:
			(lastCharacterExtent x + 	(line justifiedPadFor: (spaceCount + 1) font: font)).
		^ true].

	true ifTrue: [^ true].
	"NOTE:  I find no value to the following code, and so have defeated it - DI"

	"See tabForDisplay for illumination on the following awfulness."
	leadingTab _ true.
	line first to: lastIndex - 1 do:
		[:index | (text at: index) ~= Tab ifTrue: [leadingTab _ false]].
	(alignment ~= Justified or: [leadingTab])
		ifTrue:	[self lastCharacterExtentSetX: (textStyle nextTabXFrom: currentX
					leftMargin: leftMargin rightMargin: rightMargin) -
						currentX]
		ifFalse:	[self lastCharacterExtentSetX:  (((currentX + (textStyle tabWidth -
						(line justifiedTabDeltaFor: spaceCount))) -
							currentX) max: 0)].
	^ true! !

!MultiCharacterBlockScanner methodsFor: '*FreeType-override' stamp: 'tween 4/6/2007 12:52'!
paddedSpace
	"When the line is justified, the spaces will not be the same as the font's 
	space character. A padding of extra space must be considered in trying 
	to find which character the cursor is pointing at. Answer whether the 
	scanning has crossed the cursor."

	| pad |
	pad _ 0.
	spaceCount _ spaceCount + 1.
	pad _ line justifiedPadFor: spaceCount font: font.
	lastSpaceOrTabExtent _ lastCharacterExtent copy.
	self lastSpaceOrTabExtentSetX:  spaceWidth + pad.
	(destX + lastSpaceOrTabExtent x)  >= characterPoint x
		ifTrue: [lastCharacterExtent _ lastSpaceOrTabExtent copy.
				^self crossedX].
	lastIndex _ lastIndex + 1.
	destX _ destX + lastSpaceOrTabExtent x.
	^ false
! !

!MultiCharacterBlockScanner methodsFor: '*FreeType-override' stamp: 'tween 4/2/2007 23:59'!
scanMultiCharactersCombiningFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta

	| encoding f nextDestX maxAscii startEncoding char charValue floatDestX widthAndKernedWidth nextChar |
	lastIndex _ startIndex.
	lastIndex > stopIndex ifTrue: [lastIndex _ stopIndex. ^ stops at: EndOfRun].
	startEncoding _ (sourceString at: startIndex) leadingChar.
	font ifNil: [font _ (TextConstants at: #DefaultMultiStyle) fontArray at: 1].
	((font isMemberOf: StrikeFontSet) or: [font isKindOf: TTCFontSet]) ifTrue: [
		[f _ font fontArray at: startEncoding + 1]
			on: Exception do: [:ex | f _ font fontArray at: 1].
		f ifNil: [ f _ font fontArray at: 1].
		maxAscii _ f maxAscii.
		spaceWidth _ f widthOf: Space.
	] ifFalse: [
		maxAscii _ font maxAscii.
	].
	floatDestX := destX.
	widthAndKernedWidth := Array new: 2.
	[lastIndex <= stopIndex] whileTrue: [
		encoding _ (sourceString at: lastIndex) leadingChar.
		encoding ~= startEncoding ifTrue: [lastIndex _ lastIndex - 1. ^ stops at: EndOfRun].
		char _ (sourceString at: lastIndex).
		charValue _ char charCode.
		charValue > maxAscii ifTrue: [charValue _ maxAscii].
		(encoding = 0 and: [(stopConditions at: charValue + 1) ~~ nil]) ifTrue: [
			^ stops at: charValue + 1
		].
		nextChar := (lastIndex + 1 <= stopIndex) 
			ifTrue:[sourceString at: lastIndex + 1]
			ifFalse:[nil].
		font 
			widthAndKernedWidthOfLeft: ((char isMemberOf: CombinedChar) ifTrue:[char base] ifFalse:[char]) 
			right: nextChar
			into: widthAndKernedWidth.
		nextDestX _ floatDestX + (widthAndKernedWidth at: 1).	
		nextDestX > rightX ifTrue: [^ stops at: CrossedX].
		floatDestX := floatDestX + kernDelta + (widthAndKernedWidth at: 2).
		destX _ floatDestX.
		lastIndex _ lastIndex + 1.
	].
	lastIndex _ stopIndex.
	^ stops at: EndOfRun! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 7/29/2006 14:36'!
displayStrikeoutOn: aDisplayContext from: baselineStartPoint to: baselineEndPoint
	"display the strikeout if appropriate for the receiver"! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 7/29/2006 13:51'!
displayUnderlineOn: aDisplayContext from: baselineStartPoint to: baselineEndPoint
	"display the underline if appropriate for the receiver"! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 8/10/2006 07:16'!
emphasisString
	"Answer a translated string that represents the receiver's emphasis."
	
	^self emphasisStringFor: self emphasis! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 8/10/2006 07:13'!
emphasisStringFor: emphasisCode
	"Answer a translated string that represents the attributes given in emphasisCode."
	
	^self class emphasisStringFor: emphasisCode! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 3/29/2007 13:43'!
hasDistinctGlyphsForAll: asciiString
	"Answer true if the receiver has glyphs for all the characters
	in asciiString and no single glyph is shared by more than one character, false otherwise.
	The default behaviour is to answer true, but subclasses may reimplement"
	
	^true! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 3/29/2007 13:25'!
hasGlyphsForAll: asciiString
	"Answer true if the receiver has glyphs for all the characters
	in asciiString, false otherwise.
	The default behaviour is to answer true, but subclasses may reimplement"
	
	^true! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 4/6/2007 12:58'!
isSubPixelPositioned
	"Answer true if the receiver is currently using subpixel positioned
	glyphs, false otherwise. This affects how padded space sizes are calculated
	when composing text. 
	Currently, only FreeTypeFonts are subPixelPositioned, and only when not
	Hinted"
	
	^false ! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 3/29/2007 13:32'!
isSymbolFont
	"Answer true if the receiver is a Symbol font, false otherwise.
	The default is to answer false, subclasses can reimplement"
	
	^false! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 3/10/2007 13:08'!
kerningLeft: leftChar right: rightChar
	^0! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 3/31/2007 20:17'!
linearWidthOf: aCharacter
	"This is the scaled, unrounded advance width."
	^self widthOf: aCharacter! !

!AbstractFont methodsFor: '*FreeType-addition' stamp: 'tween 4/3/2007 16:47'!
widthAndKernedWidthOfLeft: leftCharacter right: rightCharacterOrNil into: aTwoElementArray
	"Set the first element of aTwoElementArray to the width of leftCharacter and 
	the second element to the width of left character when kerned with
	rightCharacterOrNil. Answer aTwoElementArray"
	| w k |
	w := self widthOf: leftCharacter.
	rightCharacterOrNil isNil
		ifTrue:[
			aTwoElementArray 
				at: 1 put: w; 
				at: 2 put: w]
		ifFalse:[
			k := self kerningLeft: leftCharacter right: rightCharacterOrNil.
			aTwoElementArray 
				at: 1 put: w; 
				at: 2 put: w+k].
	^aTwoElementArray
	! !

AbstractFont subclass: #FreeTypeFont
	instanceVariableNames: 'face pointSize simulatedEmphasis pixelSize widthAndKernedWidthCache cachedHeight cachedAscent cachedDescent subPixelPositioned symbolFont'
	classVariableNames: ''
	poolDictionaries: 'FT2Constants FreeTypeCacheConstants'
	category: 'FreeType-Fonts'!

!FreeTypeFont class methodsFor: 'instance creation' stamp: 'tween 9/29/2007 10:28'!
forLogicalFont: aLogicalFont fileInfo: aFreeTypeFileInfoAbstract
	| pointSize index |
	pointSize := aLogicalFont pointSize.
	index := aFreeTypeFileInfoAbstract index.  
	^aFreeTypeFileInfoAbstract isEmbedded
		ifTrue:[
			self 
				fromBytes: aFreeTypeFileInfoAbstract fileContents 
				pointSize: pointSize 
				index: index]
		ifFalse:[
			self 
				fromFile: aFreeTypeFileInfoAbstract absolutePath 
				pointSize: pointSize 
				index: index]! !

!FreeTypeFont class methodsFor: 'instance creation' stamp: 'tween 7/16/2007 00:33'!
fromBytes: aByteArray pointSize: anInteger  index: i
	^self new
		setFace: (FreeTypeFace fromBytes: aByteArray index: i) pointSize: anInteger; 
		yourself! !

!FreeTypeFont class methodsFor: 'instance creation' stamp: 'marcus.denker 12/16/2008 11:17'!
fromFile: aFileName pointSize: anInteger index: i
	^self new
		setFace: (FreeTypeFace fromFile: aFileName index: i) pointSize: anInteger; 
		yourself! !

!FreeTypeFont class methodsFor: 'instance creation' stamp: 'tween 9/29/2007 07:43'!
new
	
	^super new! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 21:42'!
profileHintedComposition
	"
	self profileHintedComposition
	"
	| t f m text |
	Preferences enable: #HintingNone.
	Preferences enable: #HintingLight. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
TimeProfileBrowser onBlock: [
	2 timesRepeat:[m justified; leftFlush]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 23:01'!
profileHintedDisplayCached
	"
	self profileHintedDisplayCached
	"
	| t f m text canvas |
	Preferences enable: #HintingNone.
	Preferences enable: #HintingLight. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
canvas := (FormCanvas on: (Form extent: 1000@1000 depth: 32)).
m drawOn: canvas. "this fills the cache"
TimeProfileBrowser onBlock: [
	2 timesRepeat: [m drawOn: canvas ]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 23:31'!
profileHintedDisplayCachedUsingMode34
	"
	self profileHintedDisplayCachedUsingMode34
	"
	| t f m text canvas |
	Preferences enable: #HintingNone.
	Preferences enable: #HintingLight. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
FreeTypeSettings current pretendBitBltSubPixelUnavailableDuring:[
	canvas := (FormCanvas on: (Form extent: 1000@1000 depth: 32)).
	m drawOn: canvas. "this fills the cache"
	TimeProfileBrowser onBlock: [
		2 timesRepeat: [m drawOn: canvas ]]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/3/2007 08:50'!
profileHintedWidthOfString
	"
	self profileHintedWidthOfString
	"
	| t f string |
	Preferences enable: #HintingNone.
	Preferences enable: #HintingLight. "cache is now clear"
	t := TextStyle named: 'Arial'.
	f := t fontOfPointSize: 12.
string :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' .

TimeProfileBrowser onBlock: [
	200 timesRepeat:[f widthOfString: string]].
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/3/2007 08:50'!
profileHintedWidthOfStringCached
	"
	self profileHintedWidthOfStringCached
	"
	| t f string |
	Preferences enable: #HintingNone.
	Preferences enable: #HintingLight. "cache is now clear"
	t := TextStyle named: 'Arial'.
	f := t fontOfPointSize: 12.
string :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' .
f widthOfString: string. "this fills any caches"
TimeProfileBrowser onBlock: [
	200 timesRepeat:[f widthOfString: string]].
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/3/2007 08:54'!
profileHintedWidthOfStringCachedMulti
	"
	self profileHintedWidthOfStringCachedMulti
	"
	| t f string |
	Preferences enable: #HintingNone.
	Preferences enable: #HintingLight. "cache is now clear"
	t := TextStyle named: 'Arial'.
	f := t fontOfPointSize: 12.
string :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' , 1000 asCharacter asString.
f widthOfString: string. "this fills any caches"
TimeProfileBrowser onBlock: [
	200 timesRepeat:[f widthOfString: string]].
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/3/2007 08:55'!
profileHintedWidthOfStringMulti
	"
	self profileHintedWidthOfStringMulti
	"
	| t f string |
	Preferences enable: #HintingNone.
	Preferences enable: #HintingLight. "cache is now clear"
	t := TextStyle named: 'Arial'.
	f := t fontOfPointSize: 12.
string :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' , 1000 asCharacter asString.

TimeProfileBrowser onBlock: [
	200 timesRepeat:[f widthOfString: string]].
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 18:56'!
profileUnhinted
	"
	self profileUnhinted
	"
	| t f m text |
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
TimeProfileBrowser onBlock: [m justified; leftFlush].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 21:43'!
profileUnhintedComposition
	"
	self profileUnhintedComposition
	"
	| t f m text |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
TimeProfileBrowser onBlock: [
	2 timesRepeat:[m justified; leftFlush]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 23:32'!
profileUnhintedCompositionMulti
	"
	self profileUnhintedCompositionMulti
	"
	| t f m text |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  ('Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' , 1000 asCharacter asString) asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
TimeProfileBrowser onBlock: [
	2 timesRepeat:[m justified; leftFlush]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 22:42'!
profileUnhintedDisplay
	"
	self profileUnhintedDisplay
	"
	| t f m text canvas |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
canvas := (FormCanvas on: (Form extent: 1000@1000 depth: 32)).
TimeProfileBrowser onBlock: [
	2 timesRepeat: [m drawOn: canvas ]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 22:43'!
profileUnhintedDisplayCached
	"
	self profileUnhintedDisplayCached
	"
	| t f m text canvas |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
canvas := (FormCanvas on: (Form extent: 1000@1000 depth: 32)).
m drawOn: canvas. "this fills the cache"
TimeProfileBrowser onBlock: [
	2 timesRepeat: [m drawOn: canvas ]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 23:41'!
profileUnhintedDisplayCachedMulti
	"
	self profileUnhintedDisplayCachedMulti
	"
	| t f m text canvas |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  ('Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' , 1000 asCharacter asString) asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
canvas := (FormCanvas on: (Form extent: 1000@1000 depth: 32)).
m drawOn: canvas. "this fills the cache"
TimeProfileBrowser onBlock: [
	2 timesRepeat: [m drawOn: canvas ]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/2/2007 23:40'!
profileUnhintedDisplayMulti
	"
	self profileUnhintedDisplayMulti
	"
	| t f m text canvas |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
f := t fontOfPointSize: 12.
m := TextMorph new.
m width: 200; height: 200.
m backgroundColor: Color white.
text :=  ('Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' , 1000 asCharacter asString) asText.
text addAttribute: (TextFontReference toFont: f).
m contents: text.
m openInWorld.
canvas := (FormCanvas on: (Form extent: 1000@1000 depth: 32)).
TimeProfileBrowser onBlock: [
	2 timesRepeat: [m drawOn: canvas ]].
m delete
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/3/2007 08:51'!
profileUnhintedWidthOfString
	"
	self profileUnhintedWidthOfString
	"
	| t f string |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
	f := t fontOfPointSize: 12.
string :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' .

TimeProfileBrowser onBlock: [
	200 timesRepeat:[f widthOfString: string]].
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/3/2007 08:51'!
profileUnhintedWidthOfStringCached
	"
	self profileUnhintedWidthOfStringCached
	"
	| t f string |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
	f := t fontOfPointSize: 12.
string :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' .
f widthOfString: string. "this fills any caches"
TimeProfileBrowser onBlock: [
	200 timesRepeat:[f widthOfString: string]].
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/3/2007 08:52'!
profileUnhintedWidthOfStringCachedMulti
	"
	self profileUnhintedWidthOfStringCachedMulti
	"
	| t f string |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
	f := t fontOfPointSize: 12.
string :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' , 1000 asCharacter asString.
f widthOfString: string. "this fills any caches"
TimeProfileBrowser onBlock: [
	200 timesRepeat:[f widthOfString: string]].
! !

!FreeTypeFont class methodsFor: 'profiling' stamp: 'tween 4/3/2007 08:53'!
profileUnhintedWidthOfStringMulti
	"
	self profileUnhintedWidthOfStringMulti
	"
	| t f string |
	Preferences enable: #HintingLight.
	Preferences enable: #HintingNone. "cache is now clear"
	t := TextStyle named: 'Arial'.
	f := t fontOfPointSize: 12.
string :=  'Welcome to the finale version of 3.9 of 7 of November 2006

You will find more recent versions at http://www.squeak.org/
This image will be used to produce other distributions such as a developer image and a fun with Squeak image. 

We hope that you will really appreciate this version and that Squeak will help you making your projects reality.

You can also participate to Squeak at different kinds of levels. This can be as simple as:	
	- asking questions in the beginner list (beginners@lists.squeakfoundation.org) 
		or in the dev list (squeak-dev@lists.squeakfoundation.org)	
	- answering questions 	
	- finding and reporting bugs at:		http://bugs.impara.de
	- fixing them, testing fixes and commenting them
	- writing tests for uncovered parts	
	- helping for the website
	- creating new cool products, frameworks, applications in squeak
	- writing articles....
	
We wish you a lot of fun and we would like to thanks all the 
persons that participated to make this release a really good one.
We know who you are!!

	Stephane Ducasse and Marcus Denker
	stephane.ducasse@free.fr and denker@iam.unibe.ch' , 1000 asCharacter asString.

TimeProfileBrowser onBlock: [
	200 timesRepeat:[f widthOfString: string]].
! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 4/3/2007 17:22'!
ascent
	| asc desc h |
	cachedAscent ifNotNil:[^cachedAscent].
	asc := self basicAscent.
	desc := self descent.
	h := self height.
	asc + desc < h ifFalse:[^cachedAscent := asc].
	"height is greater than asc+desc, adjust ascent to include the difference"
	^cachedAscent := h - desc ! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 3/26/2007 13:14'!
basicAscent

	^(self face ascender * self pixelSize // self face unitsPerEm).
! !

!FreeTypeFont methodsFor: 'glyph lookup' stamp: 'tween 9/1/2007 09:54'!
characterFormAt: aCharacter
	FreeTypeSettings current 
		forceNonSubPixelDuring:[
			^self 
				glyphOf: aCharacter 
				destDepth: 32 
				colorValue: (Color black pixelValueForDepth: 32)
				subpixelPosition: 0]! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 7/15/2007 22:00'!
clearCachedMetrics
	widthAndKernedWidthCache := cachedHeight := cachedAscent := cachedDescent := subPixelPositioned := nil! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 9/29/2007 09:44'!
defaultSimulatedItalicSlant
	^0.22! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 3/17/2007 11:27'!
depth

	^ 32.! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 4/3/2007 17:24'!
descent
	^cachedDescent ifNil:[ 
		cachedDescent := ((self face descender * self pixelSize // self face unitsPerEm) negated) ]! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 3/17/2007 11:28'!
descentKern
	"should have default in AbstractFont"
	^0! !

!FreeTypeFont methodsFor: 'displaying' stamp: 'tween 9/1/2007 10:32'!
displayLineGlyphOn: aDisplayContext from: startPoint to: endPoint
	|  oldCombinationRule oldHalftoneForm originalColorMap clr depth foreColorVal foreColorAlpha glyph width height
	startPointX startPointY endPointX endPointY foreColor |
	oldCombinationRule := aDisplayContext combinationRule .
	oldHalftoneForm := aDisplayContext halftoneForm .
	originalColorMap := aDisplayContext colorMap.
	clr := (foreColor := aDisplayContext lastFontForegroundColor ifNil:[Color black asNontranslucentColor]) 
		pixelValueForDepth: 32.
	depth := aDisplayContext destForm depth.
	foreColorVal := clr bitAnd: 16rFFFFFF.
	foreColorAlpha := (clr bitAnd: 16rFF000000) >> 24.
	depth <= 8
		ifTrue:[
			aDisplayContext colorMap: (aDisplayContext cachedFontColormapFrom:32 to: depth)]
		ifFalse:[
			aDisplayContext colorMap: nil].
	startPointX := startPoint x truncated.
	startPointY := startPoint y.
	endPointX := endPoint x ceiling.
	endPointY := endPoint y.
	width := endPointX - startPointX.
	height := endPointY - startPointY.
	glyph := (Form extent: width@height depth: 32) fillWhite. "we could cache a big white glyph somewhere to save having to create this. Clipping will make only a part of it display"
	aDisplayContext sourceForm: glyph.
	aDisplayContext destOrigin: startPointX@startPointY.
	aDisplayContext width: width.
	aDisplayContext height: height.
	aDisplayContext 
		sourceOrigin: 0@0;
		halftoneForm: nil.
	(FreeTypeSettings current bitBltSubPixelAvailable and: [depth >= 8])
		ifTrue:[
			aDisplayContext 
				combinationRule: 41.
			aDisplayContext 
				copyBitsColor: foreColorVal 
				alpha: foreColorAlpha 
				gammaTable: FreeTypeSettings current gammaTable
				ungammaTable: FreeTypeSettings current gammaInverseTable]
		ifFalse:[
			glyph fillWithColor: foreColor.
			aDisplayContext combinationRule: (depth <= 8 ifTrue: [Form paint] ifFalse: [34]).
			aDisplayContext copyBits].		
	aDisplayContext 
		colorMap: originalColorMap;
		combinationRule: oldCombinationRule;
		halftoneForm: oldHalftoneForm.
	
	! !

!FreeTypeFont methodsFor: 'displaying' stamp: 'tween 3/17/2007 11:30'!
displayStrikeoutOn: aDisplayContext from: baselineStartPoint to: baselineEndPoint
	| top bottom strikeoutThickness s e |
	
	"the strikeout size/position for TrueType fonts should really come from the TT_OS2 table.
	This needs to be read by the plugin when the face is created.
	For now, we use the underlineThickness, and 1/4 of the ascender from the baseline"
	strikeoutThickness := (self face underlineThickness * self pixelSize / self face unitsPerEm). 			
	top := ((self face ascender / 4) * self pixelSize / self face unitsPerEm) negated - (strikeoutThickness/2).
	top := top rounded.
	bottom := top + strikeoutThickness ceiling.
	s := baselineStartPoint + (0@top).
	e := baselineEndPoint + (0@bottom).
	self displayLineGlyphOn: aDisplayContext from: s to: e
	! !

!FreeTypeFont methodsFor: 'displaying' stamp: 'tween 3/17/2007 11:30'!
displayString: aString on: aDisplayContext from: startIndex to: stopIndex at: aPoint kern: kernDelta
	
	^self displayString: aString
		on: aDisplayContext
		from: startIndex
		to: stopIndex
		at: aPoint
		kern: kernDelta
		baselineY: aPoint y  + self ascent! !

!FreeTypeFont methodsFor: 'displaying' stamp: 'tween 4/5/2007 09:32'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: baselineY
	| glyph  depth foreColorVal foreColorAlpha originalColorMap clr subPixelPosition widthAndKernedWidth char nextChar floatDestX  destX destY offset gammaTable gammaInverseTable useRule41 |
	
	useRule41 := FreeTypeSettings current bitBltSubPixelAvailable and: [aBitBlt destForm depth >= 8].
	depth := aBitBlt destForm depth.
	originalColorMap := aBitBlt colorMap.
	clr := (aBitBlt lastFontForegroundColor ifNil:[Color black asNontranslucentColor]) 
		pixelValueForDepth: 32.
	useRule41 
		ifTrue:[
			foreColorVal := clr bitAnd: 16rFFFFFF.
			foreColorAlpha := (clr bitAnd: 16rFF000000) >> 24.
			gammaTable := FreeTypeSettings current gammaTable.
			gammaInverseTable := FreeTypeSettings current gammaInverseTable.]
		ifFalse:[
			foreColorVal := clr].
	depth <= 8
		ifTrue:[
			aBitBlt colorMap: (aBitBlt cachedFontColormapFrom:32 to: depth)]
		ifFalse:[
			aBitBlt colorMap: nil].
	destX := aPoint x.
	destY := baselineY.
	floatDestX := aPoint x.
	widthAndKernedWidth := Array new: 2.
 	startIndex to: stopIndex do: [:i | 
		subPixelPosition := ((floatDestX \\ 1) roundTo: "1/64" 0.015625) * 64.
		subPixelPosition = 64 
			ifTrue:[
				subPixelPosition := 0.
				destX := destX + 1].
		char := aString at: i.
		glyph := self 
			glyphOf: char 
			destDepth: depth 
			colorValue: foreColorVal 
			subpixelPosition: subPixelPosition.
		aBitBlt sourceForm: glyph.
		offset := glyph offset.
		aBitBlt destX: destX + offset x.
		aBitBlt destY: destY + offset y.
		aBitBlt width: glyph width.
		aBitBlt height: glyph height.
		useRule41
			ifTrue:[
				aBitBlt 
					copyBitsColor: foreColorVal 
					alpha: foreColorAlpha 
					gammaTable: gammaTable
					ungammaTable: gammaInverseTable]
			ifFalse:[
				aBitBlt copyBits].
		nextChar := (i + 1 <= stopIndex) 
				ifTrue:[aString at: i + 1]
				ifFalse:[nil].
		self 
			widthAndKernedWidthOfLeft: char 
			right: nextChar
			into: widthAndKernedWidth.
		floatDestX := floatDestX + (widthAndKernedWidth at: 2) + kernDelta.
		destX := floatDestX ].
	aBitBlt colorMap: originalColorMap.
	^ destX @ destY 
! !

!FreeTypeFont methodsFor: 'displaying' stamp: 'tween 3/17/2007 11:32'!
displayUnderlineOn: aDisplayContext from: baselineStartPoint to: baselineEndPoint
	| underlineTop underlineBottom underlineThickness s e |

	underlineThickness := (self face underlineThickness * self pixelSize / self face unitsPerEm). 
	underlineTop := (self face underlinePosition * self pixelSize / self face unitsPerEm) negated - (underlineThickness/2).
	underlineTop := underlineTop rounded + 1.  "needs the +1 , possibly because glyph origins are moved down by 1 so that their baselines line up with strike fonts"
	underlineBottom := underlineTop + underlineThickness ceiling.
	s := baselineStartPoint + (0@underlineTop).
	e := baselineEndPoint + (0@(underlineBottom)).
	self displayLineGlyphOn: aDisplayContext from: s to: e! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 3/17/2007 11:33'!
face
	"Validate, and answer, the receiver's face"
	
	^face validate! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 3/17/2007 11:34'!
face: aFace
	face := aFace! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 8/6/2007 22:37'!
getLinearWidthOf: aCharacter 
	| em glyph la charCode |

	aCharacter < $  ifTrue: [^self getLinearWidthOf: $ ].
	charCode := aCharacter asUnicode asInteger.
	(self face charmaps includes:'unic')
		ifTrue:[
			(self isSymbolFont and:[charCode >= 16r20 and: [charCode <= 16rFF ] ])
				ifTrue:[charCode := charCode + 16rF000]]
		ifFalse:[
			(self face charmaps includes:'armn')
				ifTrue:[ "select apple roman char map, and map character from unicode to mac encoding"
					self face setCharMap:'armn'.
					charCode := aCharacter squeakToMac asUnicode asInteger. "check this!!"]].
	em := self pixelSize.
	face validate.
	face setPixelWidth: em height: em.
	[face loadCharacter: charCode flags: (LoadNoBitmap bitOr: (LoadIgnoreTransform bitOr: "FreeTypeSettings current hintingFlags" 2 "no hinting"))]
		on: FT2Error do:[:e |
			face loadGlyph: 0 flags: (LoadNoBitmap bitOr: (LoadIgnoreTransform bitOr: FreeTypeSettings current hintingFlags "no hinting")) ].
	glyph := face glyph.
	la := glyph linearHorizontalAdvance.
	la isZero ifTrue:[
		"FreeType 2.2.1 sometimes screws up when getting metrics,
		Maybe the bug is in the plugin?
		For example Calibri pixel size 13 gives linearAdvance x of zero !!
		We try again at double the size, and half the result"
		em := self pixelSize * 2.
		face validate.
		face setPixelWidth: em height: em.
		face loadCharacter: charCode flags:(LoadNoBitmap bitOr: (LoadIgnoreTransform bitOr: "FreeTypeSettings current hintingFlags" 2 "no hinting")). "load glyph metrics"
		glyph := face glyph.
		la := glyph linearHorizontalAdvance / 2.0].
	^la
! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 8/6/2007 22:37'!
getWidthOf: aCharacter 
	"Glyphs are either 1 or 8 bit deep. For 32 bpp we use 8 bits, otherwise 1"
	| em glyph hintingFlags flags charCode |

	aCharacter < $  ifTrue: [^self getWidthOf: $ ].
	charCode := aCharacter asUnicode asInteger.
	(self face charmaps includes:'unic')
		ifTrue:[
			(self isSymbolFont and:[charCode >= 16r20 and: [charCode <= 16rFF ] ])
				ifTrue:[charCode := charCode + 16rF000]]
		ifFalse:[
			(self face charmaps includes:'armn')
				ifTrue:[ "select apple roman char map, and map character from unicode to mac encoding"
					self face setCharMap:'armn'.
					charCode := aCharacter squeakToMac asUnicode asInteger. "check this!!"]].
	em := self pixelSize.
	face validate.
	face isValid ifFalse:[^0].
	face setPixelWidth: em height: em.
	hintingFlags := FreeTypeSettings current hintingFlags.
	flags :=  LoadNoBitmap bitOr:( LoadIgnoreTransform bitOr: hintingFlags). 
	[face loadCharacter: charCode flags: flags.
	] on:FT2Error do:[:e | "character not in map?"^0]. 
	glyph := face glyph.
	"When not hinting FreeType sets the advance to the truncated linearAdvance.
	The characters appear squashed together. Rounding is probably better, so we 
	answer the rounded linear advance here"
	^self subPixelPositioned
		ifTrue:[ glyph roundedPixelLinearAdvance x]
		ifFalse:[ glyph advance x].
! !

!FreeTypeFont methodsFor: 'glyph lookup' stamp: 'tween 4/4/2007 19:13'!
glyphOf: aCharacter colorValue: aColorValue mono: monoBoolean subpixelPosition: sub

	| |
	^FreeTypeCache current
		atFont: self
		charCode: aCharacter asUnicode asInteger
		type: ((1+sub) << 32) + aColorValue
		ifAbsentPut: [
			FreeTypeGlyphRenderer current
				glyphOf: aCharacter 
				colorValue: aColorValue 
				mono: monoBoolean 
				subpixelPosition: sub 
				font: self]

! !

!FreeTypeFont methodsFor: 'glyph lookup' stamp: 'tween 9/1/2007 15:35'!
glyphOf: aCharacter destDepth: destDepth colorValue: aColorValue subpixelPosition: sub
	"sub can be between 0 and 63 and denotes the sub-pixel position of the glyph"
	| validSub |
	validSub := self isSubPixelPositioned
		ifTrue: [((sub asInteger max: 0) min: 63) "bitAnd: 2r111000"]
		ifFalse:[0].
	^(destDepth >=8 and:[FreeTypeSettings current subPixelAntiAliasing])
		ifTrue:[
			self 
				subGlyphOf: aCharacter
				colorValue: aColorValue
				mono: FreeTypeSettings current monoHinting
				subpixelPosition: validSub]
		ifFalse:[
			(destDepth >= 8 and:[FreeTypeSettings current bitBltSubPixelAvailable])
				ifTrue:[
					self 
						mode41GlyphOf: aCharacter
						colorValue: aColorValue
						mono: FreeTypeSettings current monoHinting
						subpixelPosition: validSub]
				ifFalse:[
					self 
						glyphOf: aCharacter
						colorValue: aColorValue
						mono: FreeTypeSettings current monoHinting
						subpixelPosition: validSub]]! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 3/29/2007 13:48'!
hasDistinctGlyphsForAll: asciiString
	"Answer true if the receiver has glyphs for all the characters
	in asciiString and no single glyph is shared by more than one character, false otherwise.
	The default behaviour is to answer true, but subclasses may reimplement"
	| setOfIndices i |
	self face isValid ifFalse:[^false].
	setOfIndices := Set new.
	asciiString asSet do:[:c |
		(i := self face primGetCharIndex: c asInteger) = 0
			ifTrue:[^false]
			ifFalse:[
				(setOfIndices includes: i)
					ifTrue:[^false]
					ifFalse:[setOfIndices add: i]]].
	^true! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 3/29/2007 13:28'!
hasGlyphsForAll: asciiString
	"Answer true if the receiver has glyphs for all the characters
	in asciiString, false otherwise.
	The default behaviour is to answer true, but subclasses may reimplement"
	
	self face isValid ifFalse:[^false].
	asciiString do:[:c |
		(self face primGetCharIndex: c asInteger) = 0
			ifTrue:[^false]].
	^true! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 3/31/2007 11:57'!
hash
	^pointSize hash! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 4/3/2007 17:25'!
height

	^cachedHeight ifNil:[
		cachedHeight := (self face height * self pixelSize / self face unitsPerEm) ceiling ]! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 4/3/2007 16:42'!
hintedKerningLeft: leftChar right: rightChar
	^(self linearKerningLeft: leftChar right: rightChar) rounded! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 3/31/2007 23:08'!
hintedWidthOf: aCharacter
	"retrieve advance width for character. try to use cached glyph if possible"
	| charCode answer |
	
	charCode := aCharacter asUnicode asInteger.
	answer := FreeTypeCache current 
		atFont: self 
		charCode: charCode 
		type: FreeTypeCacheWidth
		ifAbsentPut: [self getWidthOf: aCharacter].
	^answer
! !

!FreeTypeFont methodsFor: 'initialize-release' stamp: 'tween 3/17/2007 11:39'!
initialize: aFont

	self face: aFont face.! !

!FreeTypeFont methodsFor: 'displaying' stamp: 'tween 4/5/2007 08:15'!
installOn: aBitBlt foregroundColor: foreColor backgroundColor: backColor

	| |
	"fcolor := foreColor pixelValueForDepth: 32."
	aBitBlt installFreeTypeFont: self foregroundColor: foreColor backgroundColor: backColor.
! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 9/29/2007 09:49'!
isBold
	^(simulatedEmphasis == nil and:[self face isBold])
		or:[self isSimulatedBold]! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 3/17/2007 11:41'!
isFixedWidth
	^self face isFixedWidth ! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 9/29/2007 09:48'!
isItalic
	^(simulatedEmphasis == nil and:[self face isItalic])
		or:[self isSimulatedItalic]! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 9/29/2007 09:49'!
isRegular
	^(simulatedEmphasis == nil and:[self face isRegular])
		or: [self isSimulatedRegular]! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 9/29/2007 09:41'!
isSimulated
	^simulatedEmphasis notNil! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 9/29/2007 09:42'!
isSimulatedBold
	^self simulatedEmphasis anyMask: 1! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 9/29/2007 09:45'!
isSimulatedItalic
	^self simulatedEmphasis anyMask: 2! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 9/29/2007 09:45'!
isSimulatedRegular
	^simulatedEmphasis = 0! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 7/15/2007 21:55'!
isSubPixelPositioned
	"Answer true if the receiver is currently using subpixel positioned
	glyphs, false otherwise. This affects how padded space sizes are calculated
	when composing text. 
	Currently, only FreeTypeFonts are subPixelPositioned, and only when not
	Hinted"
	
	^self subPixelPositioned! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 8/1/2007 01:08'!
isSymbolFont
	| charmaps |
	symbolFont ifNotNil:[^symbolFont].
	self face isValid ifFalse:[^false].
	charmaps := self face charmaps.
	(charmaps includes: 'symb') ifTrue:[^symbolFont := true]."MS Symbol font"
	^symbolFont := false! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 3/17/2007 11:42'!
isTTCFont
	"not really - look for senders of this"
	^true! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 7/15/2007 21:59'!
kerningLeft: leftChar right: rightChar
	^self isSubPixelPositioned
		ifTrue: [self linearKerningLeft: leftChar right: rightChar]
		ifFalse:[self hintedKerningLeft: leftChar right: rightChar]! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 3/17/2007 11:43'!
lineGrid

	^self height! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 8/6/2007 22:37'!
linearKerningLeft: leftChar right: rightChar
	| f  l r |

	f := self face.
	f hasKerning ifFalse:[^0].
	l := leftChar asUnicode.
	r := rightChar asUnicode.
	(self face charmaps includes:'unic')
		ifTrue:[
			self isSymbolFont 
				ifTrue:[
					(l asInteger >= 16r20 and:[l asInteger <= 16rFF ])
						ifTrue:[l := (Character value: l asInteger + 16rF000) asUnicode].
					(r asInteger >= 16r20 and:[ r asInteger <= 16rFF ])
						ifTrue:[r := (Character value: r asInteger + 16rF000) asUnicode]]]
		ifFalse:[
			(self face charmaps includes:'armn')
				ifTrue:[ "select apple roman char map, and map characters from unicode to mac encoding"
					self face setCharMap:'armn'.
					(l asInteger >= 16r20 and:[l asInteger <= 16rFF ])
						ifTrue:[l := (Character value: l asInteger) squeakToMac].
					(r asInteger >= 16r20 and:[ r asInteger <= 16rFF ])
						ifTrue:[r := (Character value: r asInteger) squeakToMac]]].
	^(f kerningLeft: l right: r) x asFloat *  self pixelSize / f unitsPerEm! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 3/31/2007 20:18'!
linearWidthOf: aCharacter
	"retrieve linear advance width for character. try to use cached glyph if possible.
	This is the scaled, unrounded advance width."
	| charCode answer |
	
	charCode := aCharacter asUnicode asInteger.
	answer := FreeTypeCache current 
		atFont: self 
		charCode: charCode 
		type: FreeTypeCacheLinearWidth
		ifAbsentPut: [self getLinearWidthOf: aCharacter].
	^answer
! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 3/17/2007 11:44'!
maxAscii
	"should have default in AbstractFont"
	^SmallInteger maxVal! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 3/17/2007 11:44'!
minAscii
	"should have default in AbstractFont"
	^0! !

!FreeTypeFont methodsFor: 'glyph lookup' stamp: 'tween 4/4/2007 19:14'!
mode41GlyphOf: aCharacter colorValue: aColorValue mono: monoBoolean subpixelPosition: sub

	| |
	^FreeTypeCache current
		atFont: self
		charCode: aCharacter asUnicode asInteger
		type: (FreeTypeCacheGlyph + sub)
		ifAbsentPut: [
			FreeTypeGlyphRenderer current
				mode41GlyphOf: aCharacter 
				colorValue: aColorValue 
				mono: monoBoolean 
				subpixelPosition: sub 
				font: self]

! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 3/31/2007 11:38'!
pixelSize
	^pixelSize ifNil:[pixelSize := super pixelSize rounded]! !

!FreeTypeFont methodsFor: 'notifications' stamp: 'tween 4/3/2007 16:48'!
pixelsPerInchChanged
	"the TextStyle pixels per inch setting has changed"
	
	pixelSize := nil.
	widthAndKernedWidthCache := nil.
	FreeTypeCache current removeAllForFont: self.! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 3/17/2007 11:45'!
pointSize
	^pointSize! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 3/17/2007 11:45'!
pointSize: aSize
	pointSize _ aSize! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 8/27/2007 10:02'!
postscriptName
	^self face postscriptName! !

!FreeTypeFont methodsFor: 'printing' stamp: 'tween 3/17/2007 11:45'!
printOn: aStream

	aStream
		nextPutAll: self class name;
		nextPut: $(;
		print: face familyName;
		space;
		print: face styleName;
		space;
		print: pointSize;
		nextPut: $)! !

!FreeTypeFont methodsFor: 'initialize-release' stamp: 'tween 3/17/2007 11:45'!
releaseCachedState
	face releaseCachedState.
	FreeTypeCache current removeAllForFont: self.! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 3/17/2007 11:47'!
setFace: aFreetypeFace pointSize: anInteger
	face := aFreetypeFace.
	pointSize := anInteger.! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 9/29/2007 09:43'!
simulatedBoldStrength
	"Answer the amount by which glyphs need to be emboldened/lightened
	according to the receiver's simulated emphasis and the face's real emphasis"
	| bold faceBold |
	
	self isSimulated ifFalse:[^0].
	bold := self isSimulatedBold.
	faceBold := face isBold.
	(bold and: [faceBold not])
		ifTrue:[^self pixelSize/24].
	^0! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 9/29/2007 09:42'!
simulatedEmphasis
	"Answer the simulatedEmphasis.
	This is 
		0 - normal (no simulatedEmphasis, or simulated regular).
		1 - bold 
		2 - italic
		3 - bold & italic"
	^simulatedEmphasis ifNil:[0]! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 9/29/2007 09:43'!
simulatedEmphasis: anIntegerOrNil
	"Set the simulatedEmphasis.
	This is 
		nil - no simulated emphasis
		0 - normal (simulated regular).
		1 - bold 
		2 - italic
		3 - bold & italic"
	simulatedEmphasis := anIntegerOrNil! !

!FreeTypeFont methodsFor: 'accessing' stamp: 'tween 9/29/2007 09:44'!
simulatedItalicSlant
	"Answer the slant that needs to be added to italicize/un-italicize
	glyphs according to the receiver's simulated emphasis and the face's 
	real emphasis"
	| italic faceItalic |
	
	self isSimulated ifFalse:[^0].
	italic := self isSimulatedItalic.
	faceItalic := face isItalic.
	(italic and: [faceItalic not])
		ifTrue:[^self defaultSimulatedItalicSlant].
	^0! !

!FreeTypeFont methodsFor: 'glyph lookup' stamp: 'tween 4/4/2007 19:13'!
subGlyphOf: aCharacter colorValue: aColorValue mono: monoBoolean subpixelPosition: sub

	| |
	^FreeTypeCache current
		atFont: self
		charCode: aCharacter asUnicode asInteger
		type: FreeTypeCacheGlyphLCD + sub
		ifAbsentPut: [
			FreeTypeGlyphRenderer current
				subGlyphOf: aCharacter 
				colorValue: aColorValue 
				mono: monoBoolean 
				subpixelPosition: sub 
				font: self]

! !

!FreeTypeFont methodsFor: 'testing' stamp: 'tween 7/15/2007 21:57'!
subPixelPositioned
	"Answer true if the receiver is currently using subpixel positioned
	glyphs, false otherwise. This affects how padded space sizes are calculated
	when composing text."
	| settings |
	^subPixelPositioned 
		ifNil:[
			settings := FreeTypeSettings current.
			subPixelPositioned := settings hinting not or:[settings lightHinting]]! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 4/2/2007 22:10'!
widthAndKernedWidthCache
	^widthAndKernedWidthCache ifNil:[widthAndKernedWidthCache := Dictionary new]! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 4/2/2007 22:11'!
widthAndKernedWidthOfLeft: leftCharacter right: rightCharacterOrNil into: aTwoElementArray
	"Set the first element of aTwoElementArray to the width of leftCharacter and 
	the second element to the width of left character when kerned with
	rightCharacterOrNil. Answer the receiver
	
	We use a widthAndKernedWidthCache to store these values for speed"	
	| privateArray |
 
	privateArray := (self widthAndKernedWidthCache at: leftCharacter ifAbsentPut:[Dictionary new])
		at: (rightCharacterOrNil ifNil:[0 asCharacter])
		ifAbsentPut:[ 
			super 
				widthAndKernedWidthOfLeft: leftCharacter 
				right: rightCharacterOrNil 
				into: (Array new: 2)].
	"We can't answer privateArray, we MUST copy its elements into aTwoElementArray"
	aTwoElementArray 
		at: 1 put: (privateArray at: 1);
		at: 2 put: (privateArray at: 2).
	^aTwoElementArray! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 7/15/2007 22:00'!
widthOf: aCharacter
	"retrieve advance width for character. try to use cached glyph if possible"
	^self isSubPixelPositioned
		ifTrue:[self linearWidthOf: aCharacter]
		ifFalse: [self hintedWidthOf: aCharacter]
! !

!FreeTypeFont methodsFor: 'measuring' stamp: 'tween 2/10/2008 10:40'!
widthOfString: aString from: startIndex to: stopIndex
	"Measure the length of the given string between start and stop index.
	Currently this allows for the right side bearing of the last char, but does not allow for the left side bearing of the first char. We really need a new method - boundingBoxOfString that allows for both. Senders of this will also need to know the LSB of the first char, and position their text accordingly"
	| char nextChar resultX glyph a subPixelPosition |

	a := Array new: 2.
	"FreeTypeSettings current hinting ifFalse:[
		^self linearWidthOfString: aString from: startIndex to: stopIndex]."
	resultX := 0.
	startIndex to: stopIndex do:[:i | 
		char := aString at: i.
		nextChar := (i + 1 <= stopIndex)
			ifTrue:[ aString at: i + 1]
			ifFalse:[nil].
		self widthAndKernedWidthOfLeft: char right:  nextChar into: a. 
		resultX := resultX + (a at:2).
		i = stopIndex 
			ifTrue:[
				subPixelPosition := (((resultX \\ 1) roundTo: "1/64" 0.015625) * 64) asInteger.
				subPixelPosition = 64 
					ifTrue:[
						subPixelPosition := 0.
						resultX := resultX + 1 ].
				subPixelPosition := (subPixelPosition max: 0) min: 63.
				glyph := self glyphOf: char colorValue: 0 mono: FreeTypeSettings current monoHinting subpixelPosition: subPixelPosition.
				glyph ifNotNil:[
					"currently the glyph is too wide. This is to allow for some extra space to ensure 
					the glyph is not clipped when it is produced. Either make the width accurate,
					or hold the RSB value separately, or hold an accurate width separately"
					resultX := resultX "+ 2" + glyph offset x negated + (glyph width - (a at: 2)  "glyph linearAdvance x floor")]]].
	^resultX ceiling ! !

AbstractFont subclass: #LogicalFont
	instanceVariableNames: 'realFont emphasis familyName fallbackFamilyNames pointSize stretchValue weightValue slantValue derivatives boldDerivative italicDerivative boldItalicDerivative'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

LogicalFont class
	instanceVariableNames: 'all'!

LogicalFont class
	instanceVariableNames: 'all'!

!LogicalFont class methodsFor: 'accessing' stamp: 'tween 8/11/2007 01:22'!
all
	^all ifNil:[
		all := WeakSet new
			addAll: self allInstances;
			yourself]! !

!LogicalFont class methodsFor: 'instance creation' stamp: 'tween 8/27/2007 11:28'!
familyName: familyName fallbackFamilyNames: fallbackFamilyNames pointSize: pointSize 
	
	^self familyName: familyName fallbackFamilyNames: fallbackFamilyNames pointSize: pointSize stretchValue: 5 weightValue: 400 slantValue: 0! !

!LogicalFont class methodsFor: 'instance creation' stamp: 'tween 8/27/2007 11:24'!
familyName: familyName fallbackFamilyNames: fallbackFamilyNames pointSize: pointSize stretchValue: stretch weightValue: weight slantValue: slant

	"^self all asArray"
	"^(self all collect:[:each | each]) asArray"
	^self all
		detect:[:each |
			each familyName = familyName and:[
			each fallbackFamilyNames = fallbackFamilyNames and:[
			each pointSize = pointSize and:[
			each weightValue = weight and:[
			each stretchValue = stretch and:[
			each slantValue = slant]]]]]]
		ifNone:[
			self  new
				familyName: familyName; 
				fallbackFamilyNames: fallbackFamilyNames;
				pointSize: pointSize; 
				weightValue:weight;
				stretchValue: stretch;
				slantValue: slant;
				yourself]! !

!LogicalFont class methodsFor: 'instance creation' stamp: 'tween 8/27/2007 11:26'!
familyName: familyName pointSize: pointSize 
	
	^self familyName: familyName fallbackFamilyNames: nil pointSize: pointSize stretchValue: 5 weightValue: 400 slantValue: 0! !

!LogicalFont class methodsFor: 'instance creation' stamp: 'tween 8/27/2007 11:24'!
familyName: familyName pointSize: pointSize stretchValue: stretch weightValue: weight slantValue: slant

	^self familyName: familyName fallbackFamilyNames: nil pointSize: pointSize stretchValue: stretch weightValue: weight slantValue: slant! !

!LogicalFont class methodsFor: 'class initialization' stamp: 'tween 3/17/2007 10:50'!
initialize
	"
	self initialize.
	"
	Smalltalk addToShutDownList: self.  "should it be at a particular place in the list?"! !

!LogicalFont class methodsFor: 'instance creation' stamp: 'tween 8/11/2007 01:23'!
new
	
	^self all add: super new! !

!LogicalFont class methodsFor: 'shutdown' stamp: 'tween 4/3/2007 16:19'!
shutDown: quitting 

	self  allSubInstances do: [:i | i clearRealFont].! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:59'!
slantBackslanted
	^2! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:58'!
slantBook
	^0! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 12:00'!
slantCursive
	^1! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:59'!
slantInclined
	^2! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 12:00'!
slantItalic
	^1! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 12:00'!
slantKursiv
	^1! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:58'!
slantNormal
	^0! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:59'!
slantOblique
	^2! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:58'!
slantRegular
	^0! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:58'!
slantRoman
	^0! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:59'!
slantSlanted
	^2! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:59'!
slantUpright
	^0! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 12:42'!
squeakSlantItalic
	^2! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 12:41'!
squeakStretchCondensed
	^8! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 12:42'!
squeakWeightBold
	^1! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:55'!
stretchCompact
	^4! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:54'!
stretchCompressed
	^2! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:56'!
stretchCondensed
	^3! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:56'!
stretchExpanded
	^7! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:57'!
stretchExtended
	^7! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:53'!
stretchExtraCompressed
	^1! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:54'!
stretchExtraCondensed
	^2! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:55'!
stretchExtraExpanded
	^8! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:55'!
stretchExtraExtended
	^8! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:54'!
stretchNarrow
	^4! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:57'!
stretchRegular
	^5! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:55'!
stretchSemiCondensed
	^4! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:55'!
stretchSemiExpanded
	^6! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:55'!
stretchSemiExtended
	^6! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:53'!
stretchUltraCompressed
	^1! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:53'!
stretchUltraCondensed
	^1! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:56'!
stretchUltraExpanded
	^9! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:56'!
stretchUltraExtended
	^9! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:55'!
stretchWide
	^6! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:52'!
weightBlack
	^900! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:51'!
weightBold
	^700! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:52'!
weightDemi
	^600! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:50'!
weightDemiBold
	^600! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:51'!
weightExtraBlack
	^950! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:50'!
weightExtraBold
	^800! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:49'!
weightExtraLight
	^200! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:49'!
weightExtraThin
	^100! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:52'!
weightHeavy
	^900! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:52'!
weightLight
	^300! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:52'!
weightMedium
	^500! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:52'!
weightNord
	^900! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:57'!
weightRegular
	^400! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:50'!
weightSemiBold
	^600! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:51'!
weightThin
	^100! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:53'!
weightUltra
	^800! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:51'!
weightUltraBlack
	^950! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:50'!
weightUltraBold
	^800! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:50'!
weightUltraLight
	^200! !

!LogicalFont class methodsFor: 'emphasis values' stamp: 'tween 9/29/2007 11:49'!
weightUltraThin
	^100! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 13:37'!
ascent
	^self realFont ascent! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 14:02'!
baseKern
	^self realFont baseKern! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 4/5/2007 08:30'!
characterFormAt: aCharacter
	^self realFont characterFormAt: aCharacter! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 3/17/2007 10:49'!
clearRealFont
	realFont := nil! !

!LogicalFont methodsFor: 'derivatives' stamp: 'tween 3/16/2007 15:44'!
derivativeFont: newFont
	"add aFont as derivative, answer new basefont"
	(self isRegular and: [newFont isRegular not]) ifTrue: [
		self derivativeFontsAt: newFont emphasis put: newFont.
		^self].
	"new font is base, copy everything over"
	self isRegular
		ifFalse: [newFont derivativeFontsAt: self emphasis put: self].
	self derivativeFonts do: [:f |
		newFont derivativeFontsAt: f emphasis put: f].
	derivatives := nil.
	^newFont! !

!LogicalFont methodsFor: 'derivatives' stamp: 'tween 3/16/2007 17:43'!
derivativeFont: newFont mainFont: ignore
	self derivativeFont: newFont! !

!LogicalFont methodsFor: 'derivatives' stamp: 'tween 3/16/2007 15:46'!
derivativeFonts

	derivatives ifNil: [^ #()].
	^derivatives copyWithout: nil! !

!LogicalFont methodsFor: 'derivatives' stamp: 'tween 3/16/2007 15:44'!
derivativeFontsAt: index put: aFont

	derivatives ifNil:[derivatives := Array new: 32].
	derivatives at: index put: aFont! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 13:38'!
descent
	^self realFont descent! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 14:02'!
descentKern
	^self realFont descentKern! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 14:13'!
displayStrikeoutOn: aGrafPort from: aPoint to: aPoint3 
	^self realFont displayStrikeoutOn: aGrafPort from: aPoint to: aPoint3 ! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 16:03'!
displayString: aString on: aDisplayContext from: startIndex to: stopIndex at: aPoint kern: kernDelta
	^self realFont displayString: aString on: aDisplayContext from: startIndex to: stopIndex at: aPoint kern: kernDelta! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 14:11'!
displayString: aWideString on: aGrafPort from: aSmallInteger to: aSmallInteger4 at: aPoint kern: aSmallInteger6 baselineY: aSmallInteger7 
	^self realFont displayString: aWideString on: aGrafPort from: aSmallInteger to: aSmallInteger4 at: aPoint kern: aSmallInteger6 baselineY: aSmallInteger7 ! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 14:12'!
displayUnderlineOn: aGrafPort from: aPoint to: aPoint3 
	^self realFont displayUnderlineOn: aGrafPort from: aPoint to: aPoint3 ! !

!LogicalFont methodsFor: 'emphasis' stamp: 'tween 9/29/2007 12:48'!
emphasis
	"Answer the squeak emphasis code for the receiver.
	1=bold, 2=italic, 3=bold-italic etc"
	| answer |
	answer := 0.
	self isBoldOrBolder ifTrue:[answer := answer + self class squeakWeightBold].
	self isItalicOrOblique ifTrue:[answer := answer + self class squeakSlantItalic].
	^answer! !

!LogicalFont methodsFor: 'emphasis' stamp: 'tween 9/22/2007 12:41'!
emphasis: code
	
	^self emphasized: code! !

!LogicalFont methodsFor: 'emphasis' stamp: 'tween 3/16/2007 15:59'!
emphasisString
	^AbstractFont emphasisStringFor: emphasis! !

!LogicalFont methodsFor: 'emphasis' stamp: 'tween 9/29/2007 12:45'!
emphasized: code
	| validCode newWeight newSlant answer  validCodeMask |

	"we only handle bold and italic here since underline/strikeout are drawn separately"
	validCodeMask := self class squeakWeightBold bitOr: self class squeakSlantItalic.
	validCode := code bitAnd: validCodeMask. 
	validCode = 0 ifTrue:[^self].
	(validCode anyMask: self class squeakWeightBold) 
		ifTrue:[newWeight := self class weightBold max: weightValue] 
		ifFalse:[newWeight := weightValue].
	((validCode anyMask:  self class squeakSlantItalic) and:[self isItalicOrOblique not]) 
		ifTrue:[newSlant := self class slantItalic]
		ifFalse:[newSlant := slantValue].
	(weightValue = newWeight and:[slantValue = newSlant]) ifTrue:[^self].
	(weightValue ~= newWeight and:[slantValue ~= newSlant])
		ifTrue:[
			boldItalicDerivative ifNotNil:[^boldItalicDerivative]]
		ifFalse:[
			(weightValue ~= newWeight)
				ifTrue:[boldDerivative ifNotNil:[^boldDerivative]].
			(slantValue ~= newSlant)
				ifTrue:[italicDerivative ifNotNil:[^italicDerivative]]].		
	answer := self class 
		familyName: familyName 
		fallbackFamilyNames: fallbackFamilyNames 
		pointSize: pointSize 
		stretchValue: stretchValue 
		weightValue: newWeight 
		slantValue: newSlant.
	(weightValue ~= newWeight and:[slantValue ~= newSlant])
		ifTrue:[^boldItalicDerivative := answer].
	(weightValue ~= newWeight)
		ifTrue:[^boldDerivative := answer].
	(slantValue ~= newSlant)
		ifTrue:[^italicDerivative := answer].	
	^answer
! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/27/2007 11:18'!
fallbackFamilyNames
	^fallbackFamilyNames! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/27/2007 11:19'!
fallbackFamilyNames: aSequencableCollection
	fallbackFamilyNames := aSequencableCollection! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 3/16/2007 16:25'!
familyName
	^familyName! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 3/16/2007 13:57'!
familyName: aString
	familyName := aString! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/27/2007 11:38'!
familyNames
	"Answer an array containing the receiver's familyName
	followed by any fallbackFamilyNames"
	|answer|
	answer := {familyName}.
	fallbackFamilyNames ifNotNil:[
		answer := answer, fallbackFamilyNames].
	^answer! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 3/16/2007 17:39'!
familySizeFace
	"should have default in AbstractFont"
	^{self familyName. self pointSize. self emphasis}! !

!LogicalFont methodsFor: 'as yet unclassified' stamp: 'tween 3/16/2007 18:04'!
findRealFont
	"for now just get a strike"
	"^((TextStyle named: 'Accuny') fontOfPointSize: pointSize)
		emphasized: emphasis"
	^LogicalFontManager current bestFontFor: self! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 16:19'!
fontArray
	| real | 
	real := self realFont.
	((real isMemberOf: StrikeFontSet) or: [real isKindOf: TTCFontSet]) ifTrue: [
		^real fontArray
	] ifFalse: [
		^{self}
	].! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/18/2007 16:32'!
forceBold
	weightValue := (self weightValue max: 700).! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/18/2007 16:34'!
forceItalicOrOblique
	self slantValue = 0 ifTrue:[slantValue := 1]! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/18/2007 17:04'!
forceNotBold
	"anything other than bold (700) is not changed.
	we only remove boldness that can be put back with 
	a TextAttribute bold."
	
	self weightValue = 700 
		ifTrue:[weightValue := 400].! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/18/2007 21:47'!
forceNotItalic
	"leave oblique style in place"
	slantValue = 1 ifTrue:[slantValue := 0].! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/29/2007 13:43'!
hasDistinctGlyphsForAll: asciiString
	
	^self realFont hasDistinctGlyphsForAll: asciiString! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/29/2007 13:29'!
hasGlyphsForAll: asciiString
	
	^self realFont hasGlyphsForAll: asciiString! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 13:33'!
height
	^self realFont height! !

!LogicalFont methodsFor: 'initialize-release' stamp: 'tween 3/16/2007 17:42'!
initialize: aFont

	familyName := aFont familyName.
	emphasis := aFont emphasis.! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 14:04'!
installOn: a foregroundColor: b backgroundColor: c
	^self realFont installOn: a foregroundColor: b backgroundColor: c! !

!LogicalFont methodsFor: 'testing' stamp: 'tween 9/29/2007 10:56'!
isBold
	^self isBoldOrBolder! !

!LogicalFont methodsFor: 'testing' stamp: 'tween 9/29/2007 10:48'!
isBoldOrBolder
	^(weightValue ifNil:[400]) >= 700! !

!LogicalFont methodsFor: 'testing' stamp: 'tween 9/29/2007 10:57'!
isItalic
	^self isItalicOrOblique! !

!LogicalFont methodsFor: 'testing' stamp: 'tween 9/29/2007 10:47'!
isItalicOrOblique
	slantValue ifNil:[slantValue := 0].
	^slantValue = 1 or:[slantValue = 2]! !

!LogicalFont methodsFor: 'testing' stamp: 'tween 3/16/2007 15:48'!
isRegular
	^emphasis = 0! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 4/6/2007 12:58'!
isSubPixelPositioned
	"Answer true if the receiver is currently using subpixel positioned
	glyphs, false otherwise. This affects how padded space sizes are calculated
	when composing text. 
	Currently, only FreeTypeFonts are subPixelPositioned, and only when not
	Hinted"
	
	^self realFont isSubPixelPositioned! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/29/2007 14:04'!
isSymbolFont
	
	^self realFont isSymbolFont! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 13:38'!
isTTCFont
	^self realFont isTTCFont! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/21/2007 09:16'!
kerningLeft: leftChar right: rightChar
	^self realFont kerningLeft: leftChar right: rightChar! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/31/2007 17:13'!
linearWidthOf: aCharacter
	^self realFont linearWidthOf: aCharacter! !

!LogicalFont methodsFor: 'as yet unclassified' stamp: 'tween 3/16/2007 16:21'!
maxAscii
	"???
	what to do if realFont happens to be a StrikeFontSet?"
	^SmallInteger maxVal! !

!LogicalFont methodsFor: 'objects from disk' stamp: 'tween 8/27/2007 11:23'!
objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  Write a reference to a known LogicalFont in the other system instead."

	dp _ DiskProxy global: #LogicalFont selector: #familyName:fallbackFamilyNames:pointSize:stretchValue:weightValue:slantValue:
			args: {self familyName. self fallbackFamilyNames. self pointSize. self stretchValue. self weightValue. self slantValue}.
	refStrm replace: self with: dp.
	^ dp.
! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 3/16/2007 16:07'!
pointSize
	^pointSize! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 3/16/2007 13:58'!
pointSize: aNumber
	pointSize := aNumber! !

!LogicalFont methodsFor: 'printing' stamp: 'tween 8/18/2007 20:22'!
printOn: aStream
	super printOn: aStream.
	aStream cr;
		nextPutAll: ' familyName: ', familyName asString;cr;
		nextPutAll: ' emphasis: ', emphasis asString;cr;
		nextPutAll: ' pointSize: ', pointSize asString;cr;
		nextPutAll: ' realFont: ', realFont asString;
		nextPutAll: ' weight: ', weightValue asString;
		nextPutAll: ' stretch: ', stretchValue asString;
		nextPutAll: ' slant: ', slantValue asString.! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/18/2007 19:49'!
realFont
	^realFont ifNil:[realFont := self findRealFont]! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 3/16/2007 15:57'!
setEmphasis: code

	emphasis := code! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/18/2007 19:46'!
slantValue
	"Answer the value of slantValue"

	^ slantValue ifNil:[slantValue := 0]! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/17/2007 00:27'!
slantValue: anObject
	"Set the value of slantValue"

	slantValue := anObject! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/18/2007 19:46'!
stretchValue
	"Answer the value of stretchValue"

	^ stretchValue ifNil:[stretchValue := 5]! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/17/2007 00:27'!
stretchValue: anObject
	"Set the value of stretchValue"

	stretchValue := anObject! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/18/2007 19:46'!
weightValue
	"Answer the value of weightValue"

	^ weightValue ifNil:[weightValue := 400]! !

!LogicalFont methodsFor: 'accessing' stamp: 'tween 8/17/2007 00:27'!
weightValue: anObject
	"Set the value of weightValue"

	weightValue := anObject! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 4/2/2007 22:12'!
widthAndKernedWidthOfLeft: leftCharacter right: rightCharacterOrNil into: aTwoElementArray
	^self realFont widthAndKernedWidthOfLeft: leftCharacter right: rightCharacterOrNil into: aTwoElementArray! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 14:03'!
widthOf: anObject
	^self realFont widthOf: anObject! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/28/2007 14:56'!
widthOfString: aString
	^self realFont widthOfString: aString! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/28/2007 14:52'!
widthOfString: aString from: startIndex to: stopIndex
	^self realFont widthOfString: aString from: startIndex to: stopIndex! !

!LogicalFont methodsFor: 'forwarded to realFont' stamp: 'tween 3/16/2007 14:03'!
xTable
	^self realFont xTable! !

!BalloonMorph class methodsFor: '*FreeType-override' stamp: 'tween 8/7/2007 01:59'!
chooseBalloonFont
	"BalloonMorph chooseBalloonFont"

	Preferences 
		chooseFontWithPrompt:  'Ballon Help font...' translated
		andSendTo: self 
		withSelector: #setBalloonFontTo: 
		highlightSelector: #balloonFont! !

!BitBlt methodsFor: '*FreeType-addition' stamp: 'tween 8/1/2006 17:52'!
combinationRule
	"Answer the receiver's combinationRule"
	
	^combinationRule! !

!BitBlt methodsFor: '*FreeType-addition' stamp: 'tween 7/28/2006 17:54'!
copyBitsColor: argbColorSmallInteger alpha: argbAlphaSmallInteger gammaTable: gammaByteArray ungammaTable: ungammaByteArray
	"This entry point to BitBlt supplies an extra argument to specify the fore color
	argb value for operation 41. This is split into an alpha value and an rgb value,
	so that both can be passed as smallIntegers to the primitive.  
	rgbColorInteger must be a smallInteger between 0 and 16rFFFFFF.
	alpha must be a smallInteger between 0 and 16rFF."

	<primitive: 'primitiveCopyBits' module: 'BitBltPlugin'>

	"Check for compressed source, destination or halftone forms"
	((sourceForm isForm) and: [sourceForm unhibernate])
		ifTrue: [^ self copyBitsColor: argbColorSmallInteger alpha: argbAlphaSmallInteger gammaTable: gammaByteArray ungammaTable: ungammaByteArray].
	((destForm isForm) and: [destForm unhibernate ])
		ifTrue: [^ self copyBitsColor: argbColorSmallInteger alpha: argbAlphaSmallInteger gammaTable: gammaByteArray ungammaTable: ungammaByteArray].
	((halftoneForm isForm) and: [halftoneForm unhibernate])
		ifTrue: [^ self copyBitsColor: argbColorSmallInteger alpha: argbAlphaSmallInteger gammaTable: gammaByteArray ungammaTable: ungammaByteArray].

	self primitiveFailed  "Later do nicer error recovery -- share copyBits recovery"! !

!BitBlt methodsFor: '*FreeType-addition' stamp: 'tween 4/4/2007 20:59'!
installFreeTypeFont: aFreeTypeFont foregroundColor: foregroundColor backgroundColor: backgroundColor
	"Set up the parameters.  Since the glyphs in a TTCFont is 32bit depth form, it tries to use rule=34 to get better AA result if possible."

	(FreeTypeSettings current bitBltSubPixelAvailable and: [destForm depth >= 8])
		ifTrue:[
			self combinationRule: 41.
			destForm depth = 8
				ifTrue:[self colorMap: (self cachedFontColormapFrom: 32 to: destForm depth)]
				ifFalse:[self colorMap: nil]]
		ifFalse:[
			"use combination rule 34 when rule 41 is not available in the BitBlt plugin,
			or the destination form depth <= 8"
			destForm depth <= 8 
				ifTrue: [
					self colorMap: (self cachedFontColormapFrom: 32 to: destForm depth).
					self combinationRule: Form paint.] 
				ifFalse: [
					self colorMap: nil.
					self combinationRule: 34]].
	halftoneForm _ nil.
	sourceX _ sourceY _ 0.
	height _ aFreeTypeFont height.
! !

SystemWindow subclass: #FontChooserMorph
	instanceVariableNames: 'mainPanel fontPreviewPanel okButton cancelButton applyButton updateButton result pointSizeMorph pointSizeSlider fontListStylePanel styleList pointSizeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-UI'!

!FontChooserMorph class methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 10:24'!
withModel: aFontChooser
	^self new 
		initializeWithModel: aFontChooser;
		yourself.! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 20:28'!
apply
	result := model selectedFont.
	model apply! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 13:49'!
applyButton
	^applyButton ifNil: [
		applyButton := self basicButton 
			label: ' Apply ' translated; 
			target:self;
			actionSelector: #applyButtonClicked;						
			setBalloonText: 
				'Click here to apply your selection without closing this dialog' translated]! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 13:49'!
applyButtonClicked
	self apply.
	! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 16:46'!
basicButton
	| button |
	button := SimpleButtonMorph new.
	button
		borderWidth: 2;
		borderColor: #raised;
		on: #mouseEnter send: #value to: [button borderColor: self paneColor];
		on: #mouseLeave send: #value to: [button borderColor: #raised];
		"vResizing: #shrinkWrap;"
		useRoundedCorners;
		clipSubmorphs: true;
		color: self paneColor lighter;
		target: self model.
	^button
	! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 13:31'!
cancelButton
	^cancelButton ifNil: [
		cancelButton := self basicButton 
			label: ' Cancel ' translated; 
			target:self;
			actionSelector: #cancelButtonClicked;						
			setBalloonText: 
				'Click here to cancel and close this dialog' translated]! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 20:27'!
cancelButtonClicked
	result :=nil.
	self delete
	! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'RobRothwell 12/15/2008 23:11'!
createWindow
	"Create the package loader window."
	| buttonBarHeight b |

	buttonBarHeight := Preferences standardDefaultTextFont height + 22.
	self addMorph: (self newFontList borderWidth: 0)
		frame: (0.0 @ 0.0 corner: 0.5 @ 0.4) .
	self addMorph: ((styleList := self newFontStyleList) borderWidth: 0)
		frame: (0.5 @ 0.0 corner: 0.9 @ 0.4).
	self addMorph: (pointSizeList := self newPointSizeList borderWidth:0)
		frame: (0.9 @ 0.0 corner: 1.0 @ 0.4).
	self addMorph: (self fontPreviewPanel borderWidth: 0)
		fullFrame: (LayoutFrame fractions: (0@0.4 corner: 1.0@1.0) offsets: (0@0 corner: 0@buttonBarHeight negated)). 

	self addMorph: (applyButton:=self applyButton)
		fullFrame: (LayoutFrame fractions: (0@1.0 corner: 0.25@1.0) offsets: (10@(buttonBarHeight negated + 2) corner: -10@-4)).
	applyButton color: self paneColor darker.

	self addMorph: (okButton :=self okButton) 
		fullFrame: (LayoutFrame fractions: (0.25@1.0 corner: 0.50@1.0) offsets: (10@(buttonBarHeight negated + 2)  corner: -10@-4)).
	okButton color: self paneColor darker.

	self addMorph: (cancelButton :=self cancelButton) 
		fullFrame: (LayoutFrame fractions: (0.50@1.0 corner: 0.75@1.0) offsets: (10@(buttonBarHeight negated + 2) corner: -10@-4)).
	cancelButton color: self paneColor darker.

	self addMorph: (updateButton:=self updateButton)
		fullFrame: (LayoutFrame fractions: (0.75@1.0 corner: 1.0@1.0) offsets: (10@(buttonBarHeight negated + 2) corner: -10@-4)).
	updateButton color: self paneColor darker.

	self addMorph: (b :=Morph new)
		fullFrame: (LayoutFrame fractions: (0@1.0 corner: 1.0@1.0) offsets: (4@buttonBarHeight negated  - 4 corner: 0@0)).


	b color: self paneColor lighter.
	updateButton comeToFront.
"	applyButton comeToFront."
	okButton comeToFront.
	cancelButton comeToFront.
	self on: #mouseEnter send: #paneTransition: to: self.
	self on: #mouseLeave send: #paneTransition: to: self! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 20:25'!
delete
	model := nil.
	super delete
	! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 11:24'!
fontPreviewPanel 
	^fontPreviewPanel ifNil:
		[fontPreviewPanel := ScrollPane new
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #spaceFill.
		fontPreviewPanel scroller
			on: #mouseEnter send: #value: 
				to: [:event | event hand newKeyboardFocus: fontPreviewPanel scroller];
			on: #keyStroke send: #keyPressed: to: self.
		fontPreviewPanel.]! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 3/2/2008 19:16'!
initializeLabelArea
	super initializeLabelArea.
	collapseBox hide.  " need to keep collapseBox for title bar to display correctly?"
	expandBox delete.
	menuBox delete.
	expandBox := nil.
	collapseBox := nil.! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 23:29'!
initializeWithModel: aFontChooser
	self 
		model: aFontChooser;
		clipSubmorphs: true;
		setLabel: self model windowTitle;
		name: 'FontChooser'.
	self updatePreview! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 13:43'!
newFontList 
	| answer fon max |
	answer := PluggableListMorph
		on: self model
		list: #fontListStrings
		selected: #selectedFontIndex
		changeSelected: #selectedFontIndex:.
	fon := answer font.
	max := 20.
	model fontList do:[:each |
		max := max max: (fon widthOfStringOrText: each familyName)].	
	answer	
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			"hResizing: #rigid;"
			width: max + answer scrollBarThickness + (fon widthOfStringOrText: '  ');
			yourself.
	^answer! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 13:13'!
newFontPointSizeField 
	| answer |
	
	answer := (PluggableTextMorph on: self text: #pointSizeString accept: #pointSizeString:)
		acceptOnCR: true;
		hideVScrollBarIndefinitely: true;
		color: Color gray veryMuchLighter;
		borderColor: #inset;
		vResizing: #rigid;
		hResizing: #spaceFill;
		width: (TextStyle defaultFont widthOfString: '99999999.99');
		height: TextStyle defaultFont height + 6;
		"wrapFlag: true;"
		"autoFit: false;"
		"margins: 2@2;"
		"borderWidth: 1;"
		"contents: model pointSize asString;"
		yourself.
	^answer! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 13:14'!
newFontPointSizeLabel 
	^StringMorph contents: 'Point size:' translated.! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/19/2007 16:26'!
newFontPreviewInnerPanel 
	| sample i c f |
	sample := WriteStream on: ''.
	f := model selectedFont.
	f isNil ifTrue:[^TextMorph new contents:''; yourself].
	f isSymbolFont
		ifFalse:[
			sample 
				nextPutAll: 'the quick brown fox jumps over the lazy dog' ;cr;
				nextPutAll:  'THE QUICK BROWN FOX JUMPS OVER THE LAZY DOG.' ;cr].
	i := 0.
	33 to: 255 do:[:ci |
		sample nextPut: (c:=Character value: ci).
		i := i + 1.
		(('@Z`z' includes:c) or:[i = 30]) 
			ifTrue:[i :=0. sample cr]].
	sample := sample contents asText.
	"(f weightValue >= 700) ifTrue:[sample addAttribute: TextEmphasis bold].
	(f slantValue ~= 0) ifTrue:[sample addAttribute: TextEmphasis italic]."
	^TextMorph new 
		contents: sample;
		beAllFont: f;
		yourself! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 13:13'!
newFontSizePanel
	^Morph new
		borderWidth: 1;
		borderColor: Color black;
		hResizing: #spaceFill;
		vResizing: #shrinkwrap;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellInset: 0;
		listCentering: #topLeft;
		listDirection: #leftToRight;
		cellPositioning: #leftCenter;
		clipSubmorphs: true;
		"addMorphBack: self newFontEmphasisBoldButton;
		addMorphBack: self newFontEmphasisItalicButton;"
		addMorphBack: self newFontPointSizeLabel;
		addMorphBack: (pointSizeMorph := self newFontPointSizeField)
		! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 13:42'!
newFontStyleList 
	| answer fon max |
	answer := PluggableListMorph
		on: self model
		list: #fontStyleListStrings
		selected: #selectedFontStyleIndex
		changeSelected: #selectedFontStyleIndex:.
	fon := answer font.
	max := fon widthOfStringOrText: 'Condensed Extra Bold Oblique' "long, but not the longest".
	model fontStyleList do:[:fontFamilyMember |
		max := max max: (fon widthOfStringOrText: fontFamilyMember styleName)].	
	answer	
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			"hResizing: #rigid;"
			width: max + answer scrollBarThickness + (fon widthOfStringOrText: '  ');
			yourself.
	^answer! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 23:22'!
newPointSizeList 
	| answer |
	answer := PluggableListMorph
		on: self model
		list: #pointSizeList
		selected: #selectedPointSizeIndex
		changeSelected: #selectedPointSizeIndex:.
	answer	
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			yourself.
	^answer! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 13:22'!
newSeparator
	^BorderedMorph new
		borderWidth: 2;
		borderColor: Color transparent;
		color: self paneColor;
		hResizing: #rigid;
		width: 5;
		vResizing: #spaceFill;
		yourself! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 13:31'!
okButton
	^okButton ifNil: [
		okButton := self basicButton 
			label: '     OK     ' translated; 
			target:self;
			actionSelector: #okButtonClicked;						
			setBalloonText: 
				'Click here to close this dialog, and accept your selection' translated]! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 13:37'!
okButtonClicked
	self apply.
	self delete
	! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 17:19'!
openAsMorph
	^self createWindow openAsIsIn: self currentWorld! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 22:58'!
paneColor
	^Color blue muchLighter! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 22:47'!
pointSizeSlider: aNumber

	(aNumber < 1 or:[ aNumber > 1024])
		ifTrue:[^self].
	pointSizeMorph ifNotNil:[
		pointSizeMorph 
			setText: aNumber asString asText;
			hasUnacceptedEdits: false].
	model pointSize: aNumber! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 17:33'!
pointSizeString
	^model pointSize asString! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 22:27'!
pointSizeString: aText
	| s n|

	s := aText asString withBlanksTrimmed.
	s isEmpty ifTrue:[^self].
	(s detect:[:c | c isDigit not and:[c ~= $.]] ifNone:[]) ifNotNil:[^self].
	[n := s asNumber asFloat] on: Error do:[:e | ^self].
	(n < 1 or:[ n > 1024])
		ifTrue:[^self].
	pointSizeMorph ifNotNil:[pointSizeMorph hasUnacceptedEdits: false].
	model pointSize: n! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 3/2/2008 19:16'!
replaceBoxes
	super replaceBoxes.
	collapseBox hide.  " need to keep collapseBox for title bar to display correctly?"
! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/4/2007 20:28'!
result
	^result! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/28/2007 00:02'!
update: aSymbol
	super update: aSymbol.
	aSymbol == #selectedFontIndex
		ifTrue: [
			styleList ifNotNil:[styleList updateList].
			pointSizeList ifNotNil:[pointSizeList updateList].
			self updatePreview].
	aSymbol == #selectedFontStyleIndex
		ifTrue: [
			self updatePreview].
	aSymbol == #pointSize
		ifTrue: [
			pointSizeList ifNotNil:[pointSizeList selectionIndex: model selectedPointSizeIndex]. 
			self updatePreview].
	aSymbol == #pointSizeList
		ifTrue: [
			pointSizeList ifNotNil:[pointSizeList updateList].
			self updatePreview].! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'RobRothwell 12/15/2008 22:57'!
updateButton
	^updateButton ifNil: [
		updateButton := self basicButton 
			label: ' Update ' translated; 
			target:self;
			actionSelector: #updateButtonClicked;						
			setBalloonText: 
				'Click here to rescan Font Folder and update the font list' translated]! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'RobRothwell 12/15/2008 23:01'!
updateButtonClicked
	self updateFontList.
	! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'RobRothwell 12/15/2008 22:55'!
updateFontList
	model updateFontList! !

!FontChooserMorph methodsFor: 'as yet unclassified' stamp: 'tween 8/27/2007 23:26'!
updatePreview

	Cursor wait showWhile: 
		[
		self fontPreviewPanel
				hScrollBarValue: 0;
				vScrollBarValue: 0.
		self fontPreviewPanel scroller removeAllMorphs.
		self fontPreviewPanel scroller addMorphBack: self newFontPreviewInnerPanel]! !

Object subclass: #FT2BitmapSize
	instanceVariableNames: 'height width size xPpEm yPpEm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2BitmapSize commentStamp: '<historical>' prior: 0!
Do not rearrange these fields!!

This structure models the size of a bitmap strike (i.e., a bitmap
instance of the font for a given resolution) in a fixed-size font
face.  It is used for the `availableSizes' field of the
FT2Face structure.

<Fields>
height :: The (vertical) baseline-to-baseline distance in pixels.
It makes most sense to define the height of a bitmap
font in this way.

width  :: The average width of the font (in pixels).  Since the
algorithms to compute this value are different for the
various bitmap formats, it can only give an additional
hint if the `height' value isn't sufficient to select
the proper font.  For monospaced fonts the average width
is the same as the maximum width.

size   :: The point size in 26.6 fractional format this font shall
represent (for a given vertical resolution).

x_ppem :: The horizontal ppem value (in 26.6 fractional format).

y_ppem :: The vertical ppem value (in 26.6 fractional format).
Usually, this is the `nominal' pixel height of the font.

<Note>
The values in this structure are taken from the bitmap font.  If
the font doesn't provide a parameter it is set to zero to indicate
that the information is not available.

The following formula converts from dpi to ppem:

ppem = size * dpi / 72

where `size' is in points.

Windows FNT:
The `size' parameter is not reliable: There exist fonts (e.g.,
app850.fon) which have a wrong size for some subfonts; x_ppem
and y_ppem are thus set equal to pixel width and height given in
in the Windows FNT header.

TrueType embedded bitmaps:
`size', `width', and `height' values are not contained in the
bitmap strike itself.  They are computed from the global font
parameters.
!

Object subclass: #FT2GlyphSlot
	instanceVariableNames: 'face linearHorizontalAdvance linearVerticalAdvance advanceX advanceY format bitmapLeft bitmapTop width height hBearingX hBearingY hAdvance vBearingX vBearingY vAdvance outline'
	classVariableNames: ''
	poolDictionaries: 'FT2Constants'
	category: 'FreeType-Base'!

!FT2GlyphSlot commentStamp: '<historical>' prior: 0!
Do not rearrange these fields!!

face -- the FT2Face that owns this FT2GlyphSlot.


Note that even when the glyph image is transformed, the metrics are not.

linearHoriAdvance -- For scalable formats only, this field holds the
linearly scaled horizontal advance width for the glyph (i.e. the scaled
and unhinted value of the hori advance).  This can be important to
perform correct WYSIWYG layout.

Note that this value is expressed by default in 16.16 pixels. However,
when the glyph is loaded with the FT_LOAD_LINEAR_DESIGN flag, this field
contains simply the value of the advance in original font units.

linearVertAdvance -- For scalable formats only, this field holds the
linearly scaled vertical advance height for the glyph.  See
linearHoriAdvance for comments.

advance -- This is the transformed advance width for the glyph.

format -- This field indicates the format of the image contained in the
glyph slot.  Typically FT_GLYPH_FORMAT_BITMAP, FT_GLYPH_FORMAT_OUTLINE,
and FT_GLYPH_FORMAT_COMPOSITE, but others are possible.

bitmap -- This field is used as a bitmap descriptor when the slot format
is FT_GLYPH_FORMAT_BITMAP.  Note that the address and content of the
bitmap buffer can change between calls of @FT_Load_Glyph and a few other
functions.

bitmap_left -- This is the bitmap's left bearing expressed in integer
pixels.  Of course, this is only valid if the format is
FT_GLYPH_FORMAT_BITMAP.

bitmap_top -- This is the bitmap's top bearing expressed in integer
pixels.  Remember that this is the distance from the baseline to the
top-most glyph scanline, upwards y-coordinates being *positive*.

outline -- The outline descriptor for the current glyph image if its
format is FT_GLYPH_FORMAT_OUTLINE.

num_subglyphs -- The number of subglyphs in a composite glyph.  This
field is only valid for the composite glyph format that should normally
only be loaded with the @FT_LOAD_NO_RECURSE flag.  For now this is
internal to FreeType.

subglyphs -- An array of subglyph descriptors for composite glyphs.
There are `num_subglyphs' elements in there.  Currently internal to
FreeType.

control_data -- Certain font drivers can also return the control data
for a given glyph image (e.g.  TrueType bytecode, Type 1 charstrings,
etc.).  This field is a pointer to such data.

control_len -- This is the length in bytes of the control data.

other -- Really wicked formats can use this pointer to present their own
glyph image to client apps.  Note that the app will need to know about
the image format.

width, height, hBearingX, hBearingY, hAdvance, vBearingX, vBearingY, vAdvance 
-- The metrics of the last loaded glyph in the slot.  The
returned values depend on the last load flags (see the @FT_Load_Glyph
API function) and can be expressed either in 26.6 fractional pixels or
font units.
!

!FT2GlyphSlot class methodsFor: 'instance creation' stamp: 'nk 11/3/2004 17:38'!
fromFace: anFT2Face
	^(super new)
		loadFrom: anFT2Face;
		yourself.! !

!FT2GlyphSlot methodsFor: 'accessing-convenience' stamp: 'bf 11/19/2005 17:16'!
advance
	^advanceX@advanceY! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'nk 11/3/2004 12:11'!
advanceX
	^advanceX! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'nk 11/3/2004 12:11'!
advanceY
	^advanceY! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'nk 11/3/2004 12:11'!
bitmapLeft
	^bitmapLeft! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'nk 11/3/2004 12:11'!
bitmapTop
	^bitmapTop! !

!FT2GlyphSlot methodsFor: 'accessing-convenience' stamp: 'bf 11/20/2005 14:42'!
extent
	^width@height! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'nk 11/3/2004 12:11'!
format
	^format! !

!FT2GlyphSlot methodsFor: 'accessing-convenience' stamp: 'bf 11/20/2005 14:56'!
hBearing
	^hBearingX@hBearingY! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'bf 11/20/2005 14:52'!
hBearingX
	^hBearingX! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'bf 11/20/2005 14:52'!
hBearingY
	^hBearingY! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'bf 11/20/2005 14:53'!
height
	^height! !

!FT2GlyphSlot methodsFor: 'accessing-convenience' stamp: 'tween 8/5/2007 11:14'!
linearAdvance
	^"("(linearHorizontalAdvance @ linearVerticalAdvance) "* 2540) rounded"
! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'nk 11/3/2004 12:11'!
linearHorizontalAdvance
	^linearHorizontalAdvance! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'nk 11/3/2004 12:11'!
linearVerticalAdvance
	^linearVerticalAdvance! !

!FT2GlyphSlot methodsFor: 'private' stamp: 'bf 11/20/2005 14:43'!
loadFrom: anFT2Face
	face := anFT2Face.
	self primLoadFrom: anFT2Face.
	format := ((SmalltalkImage current isLittleEndian) ifTrue: [ format reversed ] ifFalse: [ format ]) asString.
	linearHorizontalAdvance := linearHorizontalAdvance / 65536.0.
	linearVerticalAdvance isZero ifFalse: [ linearVerticalAdvance := linearVerticalAdvance / 65536.0 ].
	advanceX := advanceX bitShift: -6.
	advanceY isZero ifFalse: [ advanceY := advanceY bitShift: -6 ].
	width := width + 63 bitShift: -6. "round up"
	height := height + 63 bitShift: -6. "round up"
	hBearingX := hBearingX bitShift: -6.
	hBearingY := hBearingY bitShift: -6.
	hAdvance := hAdvance bitShift: -6.
	vBearingX := vBearingX bitShift: -6.
	vBearingY := vBearingY bitShift: -6.
	vAdvance := vAdvance bitShift: -6.! !

!FT2GlyphSlot methodsFor: 'private' stamp: 'nk 11/3/2004 17:58'!
primLoadFrom: anFT2Face
	<primitive: 'primitiveLoadGlyphSlotFromFace' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2GlyphSlot methodsFor: 'accessing-convenience' stamp: 'tween 3/11/2007 08:56'!
roundedPixelLinearAdvance
	"Answer the scaled linearAdvance, rounded to whole pixels"
	^linearHorizontalAdvance  rounded @ linearVerticalAdvance rounded
! !

!FT2GlyphSlot methodsFor: 'accessing-fields' stamp: 'bf 11/20/2005 14:53'!
width
	^width! !

Object subclass: #FT2Handle
	instanceVariableNames: 'handle'
	classVariableNames: 'Registry'
	poolDictionaries: 'FT2Constants'
	category: 'FreeType-Base'!

!FT2Handle commentStamp: '<historical>' prior: 0!
handle holds a (typically 32-bit) pointer to an externally managed object.!

FT2Handle subclass: #FT2Face
	instanceVariableNames: 'numFaces faceIndex faceFlags styleFlags numGlyphs familyName styleName numFixedSizes availableSizes numCharmaps charmaps bbox unitsPerEm ascender descender height maxAdvanceWidth maxAdvanceHeight underlinePosition underlineThickness glyph encoding platformId encodingId size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2Face commentStamp: '<historical>' prior: 0!
Do not rearrange these fields!!
New fields should go at the end, because the plugin has to know about these indexes.

ByteArray representing a pointer to the malloc'd FT_Face struct:
handle

Copied from the FT_Face struct on creation:
numFaces faceIndex faceFlags styleFlags numGlyphs familyName styleName numFixedSizes availableSizes numCharmaps charmaps

Copied on creation, but only relevant to scalable outlines:
bbox unitsPerEm ascender descender height maxAdvanceWidth maxAdvanceHeight underlinePosition underlineThickness 

Working memory:
glyph -- FT2GlyphSlot, set by loadGlyph or loadChar
size -- the active size, set by activateSize, used by loadGlyph, getKerning, etc.
charmap -- set by setCharmap
!

!FT2Face methodsFor: 'rendering' stamp: 'bf 11/21/2005 18:07'!
angle: angle scale: scale offset: aPoint
	| one matrix delta |
	one := (16r10000 * scale) asInteger.
	matrix := IntegerArray new: 4.
	angle isZero ifTrue: [
		matrix at: 1 put: one.
		matrix at: 4 put: one.
	] ifFalse: [
		| phi cos sin |
		phi := angle degreesToRadians.
		cos := (phi sin * one) rounded.
		sin := (phi cos * one) rounded.
		matrix at: 1 put: sin.
		matrix at: 2 put: cos negated.
		matrix at: 3 put: cos.
		matrix at: 4 put: sin.
 	].
	delta := IntegerArray new: 2.
	delta at: 1 put: (aPoint x * 64) rounded. 
	delta at: 2 put: (aPoint y * 64) rounded.
	self primSetTransform: matrix delta: delta.
! !

!FT2Face methodsFor: 'rendering' stamp: 'tween 8/2/2006 10:05'!
angle: angle scale: scale offset: aPoint slant: slant
	| one matrix delta slantOne |
	one := (16r10000 * scale) asInteger.
	slantOne := (16r10000 * scale* slant) asInteger.
	matrix := IntegerArray new: 4.
	angle isZero ifTrue: [
		matrix at: 1 put: one.
		matrix at: 2 put: slantOne.
		matrix at: 4 put: one.
	] ifFalse: [
		| phi cos sin |
		phi := angle degreesToRadians.
		cos := (phi sin * one) rounded.
		sin := (phi cos * one) rounded.
		matrix at: 1 put: sin.
		matrix at: 2 put: cos negated.
		matrix at: 3 put: cos.
		matrix at: 4 put: sin.
 	].
	delta := IntegerArray new: 2.
	delta at: 1 put: (aPoint x * 64) rounded. 
	delta at: 2 put: (aPoint y * 64) rounded.
	self primSetTransform: matrix delta: delta.
! !

!FT2Face methodsFor: 'rendering' stamp: 'tween 3/22/2006 23:07'!
angle: angle scalePoint: scalePoint offset: aPoint
	| oneX oneY matrix delta |
	oneX := (16r10000 * scalePoint x) asInteger.
	oneY :=  (16r10000 * scalePoint y) asInteger.
	matrix := IntegerArray new: 4.
	angle isZero ifTrue: [
		matrix at: 1 put: oneX.
		matrix at: 4 put: oneY.
	] ifFalse: [
		| phi cos sin |
		phi := angle degreesToRadians.
		cos := (phi sin * oneX) rounded.
		sin := (phi cos * oneY) rounded.
		matrix at: 1 put: sin.
		matrix at: 2 put: cos negated.
		matrix at: 3 put: cos.
		matrix at: 4 put: sin.
 	].
	delta := IntegerArray new: 2.
	delta at: 1 put: (aPoint x * 64) rounded. 
	delta at: 2 put: (aPoint y * 64) rounded.
	self primSetTransform: matrix delta: delta.
! !

!FT2Face methodsFor: 'rendering' stamp: 'tween 8/2/2006 17:40'!
angle: angle scalePoint: scalePoint offset: aPoint slant: slant
	| oneX oneY matrix delta slantOne|
	oneX := (16r10000 * scalePoint x) asInteger.
	oneY :=  (16r10000 * scalePoint y) asInteger.
	slantOne := (16r10000 * scalePoint x * slant) asInteger.
	matrix := IntegerArray new: 4.
	angle isZero ifTrue: [
		matrix at: 1 put: oneX.
		matrix at: 2 put: slantOne.
		matrix at: 4 put: oneY.
	] ifFalse: [
		| phi cos sin |
		phi := angle degreesToRadians.
		cos := (phi sin * oneX) rounded.
		sin := (phi cos * oneY) rounded.
		matrix at: 1 put: sin.
		matrix at: 2 put: cos negated.
		matrix at: 3 put: cos.
		matrix at: 4 put: sin.
 	].
	delta := IntegerArray new: 2.
	delta at: 1 put: (aPoint x * 64) rounded. 
	delta at: 2 put: (aPoint y * 64) rounded.
	self primSetTransform: matrix delta: delta.
! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
ascender
	^ascender! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
availableSizes
	^availableSizes! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 17:06'!
bbox
	bbox
		ifNil: [bbox := Rectangle new.
			self primLoadBbox: bbox].
	^ bbox! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 21:05'!
charmaps
	"Answer an Array of Strings naming the different character maps available for setCharMap:"
	charmaps ifNil: [
		charmaps := Array new: numCharmaps.
		self getCharMapsInto: charmaps ].
	^charmaps! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
descender
	^descender! !

!FT2Face methodsFor: 'rendering' stamp: 'tween 8/2/2006 21:19'!
emboldenOutline: strength
	^self primEmboldenGlyphSlotOutline: (strength * 64) rounded! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 20:46'!
encoding
	encoding ifNil: [ self getCharMap ].
	^encoding! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
faceFlags
	^faceFlags! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
faceIndex
	^faceIndex! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
familyName
	^familyName! !

!FT2Face methodsFor: 'charmaps' stamp: 'nk 11/3/2004 19:36'!
getCharMap
	self primGetCharMap.! !

!FT2Face methodsFor: 'charmaps' stamp: 'nk 11/3/2004 20:38'!
getCharMapsInto: array
	self primGetCharMapsInto: array.! !

!FT2Face methodsFor: 'accessing' stamp: 'bf 11/17/2005 15:56'!
glyph
	glyph ifNil: [ glyph := FT2GlyphSlot fromFace: self ].
	^glyph! !

!FT2Face methodsFor: 'glyphs' stamp: 'jl 5/30/2006 14:08'!
glyphOfCharacter: aCharacter
	"load a glyph with outline, glyph is not scaled "
	| em aGlyph |
	em := self unitsPerEm.
	self validate.
	self setPixelWidth: em height: em.
	self loadCharacter: aCharacter asInteger flags: LoadIgnoreTransform. "load glyph metrics"
	aGlyph := self glyph shallowCopy. " copy because 'face glyph' is only a slot"
	aGlyph outline: (self characterOutline: aCharacter).
	^aGlyph! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
handle
	^handle! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
height
	^height! !

!FT2Face methodsFor: 'testing' stamp: 'tween 8/7/2006 08:46'!
isBold
	styleFlags == nil ifTrue:[^false].
	^styleFlags allMask: StyleFlagBold! !

!FT2Face methodsFor: 'testing' stamp: 'tween 8/7/2006 08:47'!
isFixedWidth
	styleFlags == nil ifTrue:[^false].
	^faceFlags allMask: 4 "FT_FACE_FLAG_FIXED_WIDTH" ! !

!FT2Face methodsFor: 'testing' stamp: 'tween 8/7/2006 08:47'!
isItalic
	styleFlags == nil ifTrue:[^false].
	^styleFlags allMask: StyleFlagItalic! !

!FT2Face methodsFor: 'testing' stamp: 'tween 8/7/2006 08:47'!
isRegular
	styleFlags == nil ifTrue:[^true].
	^styleFlags = 0! !

!FT2Face methodsFor: 'kerning' stamp: 'tween 3/11/2007 21:17'!
kerningLeft: leftCharacter right: rightCharacter
	[^self primGetKerningLeft: (self primGetCharIndex: leftCharacter asInteger)  
		right: (self primGetCharIndex: rightCharacter asInteger) 
	] on: FT2Error do:[:e | ^0@0]! !

!FT2Face methodsFor: 'glyphs' stamp: 'nk 11/3/2004 18:25'!
loadCharacter: index flags: flags
	self primLoadCharacter: index flags: flags.
	glyph
		ifNil: [ glyph := FT2GlyphSlot fromFace: self ]
		ifNotNil: [ glyph loadFrom: self ].
! !

!FT2Face methodsFor: 'outlines' stamp: 'jl 5/24/2006 15:22'!
loadCharacterOutline: index flags: flags
	| em outline |
	em := unitsPerEm.
	self setPixelWidth: em height: em.
	self loadCharacter: index flags: flags.
	outline := FT2Outline new.
	outline primLoadSizesFrom: self.
	outline allocateArrays.
	outline primLoadArraysFrom: self.

	^outline! !

!FT2Face methodsFor: 'private' stamp: 'tween 7/31/2006 21:30'!
loadFields
	self isValid 
		ifTrue:[
			[self primLoadFields] 
			on: FT2Error
			do:[:e |
				"need to do something here"]]! !

!FT2Face methodsFor: 'glyphs' stamp: 'nk 11/3/2004 18:25'!
loadGlyph: index flags: flags
	self primLoadGlyph: index flags: flags.
	glyph
		ifNil: [ glyph := FT2GlyphSlot fromFace: self ]
		ifNotNil: [ glyph loadFrom: self ].
! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
maxAdvanceHeight
	^maxAdvanceHeight! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
maxAdvanceWidth
	^maxAdvanceWidth! !

!FT2Face methodsFor: 'accessing' stamp: 'tween 7/24/2006 22:49'!
memoryFaceData
	self subclassResponsibility! !

!FT2Face methodsFor: 'initialize-release' stamp: 'tween 8/12/2006 10:01'!
newFaceFromExternalMemory: aFreeTypeExternalMemory index: anInteger
	| memSize |

	aFreeTypeExternalMemory validate.
	memSize := aFreeTypeExternalMemory bytes size.
	[self 
		primNewFaceFromExternalMemory: aFreeTypeExternalMemory 
		size: memSize 
		index: anInteger]
			on: FT2Error 
			do:[:e |"need to do something here?"].
	self isValid ifTrue:[self class register: self]! !

!FT2Face methodsFor: 'initialize-release' stamp: 'tween 3/16/2007 03:58'!
newFaceFromFile: fileName index: anInteger
	[self primNewFaceFromFile: fileName index: anInteger]
		on: FT2Error 
		do:[:e | ^self "need to do something here?"].
	self class register: self.! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
numCharmaps
	^numCharmaps! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
numFaces
	^numFaces! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
numFixedSizes
	^numFixedSizes! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
numGlyphs
	^numGlyphs! !

!FT2Face methodsFor: 'accessing' stamp: 'tween 8/11/2007 11:24'!
postscriptName
	^self primGetPostscriptName! !

!FT2Face methodsFor: 'private-primitives' stamp: 'tween 8/6/2006 15:47'!
primDestroyHandle
	<primitive: 'primitiveDoneFacePreserveFields' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'tween 8/2/2006 21:14'!
primEmboldenGlyphSlotOutline: strengthInteger
	<primitive: 'primitiveEmboldenFaceGlyphSlotOutline' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'jl 5/30/2006 13:21'!
primGetCharIndex: characterCode
	"Return the glyph index of a given character code"
	<primitive: 'primitiveGetFaceCharIndex' module: 'FT2Plugin'>
	^self primitiveFailed.
! !

!FT2Face methodsFor: 'private-primitives' stamp: 'nk 11/3/2004 19:35'!
primGetCharMap
	<primitive: 'primitiveGetFaceCharMap' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private-primitives' stamp: 'nk 11/4/2004 13:35'!
primGetCharMapsInto: array
	<primitive: 'primitiveGetFaceCharMapsIntoArray' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'jl 5/30/2006 13:23'!
primGetKerningLeft: leftGlyphIndex right: rightGlyphIndex
	"self primGetKerningLeft: $V asInteger  right: $a asInteger "
	<primitive: 'primitiveGetKerningLeftRight' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'tween 8/11/2007 11:24'!
primGetPostscriptName 
	<primitive: 'primitiveGetPostscriptName' module: 'FT2Plugin'>
	^nil! !

!FT2Face methodsFor: 'private-primitives' stamp: 'jl 5/30/2006 15:59'!
primGetTrackKerningPointSize: pointSize degree: degree
	<primitive: 'primitiveGetTrackKerningPointSizeDegree' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'jl 5/29/2006 15:52'!
primHasKerning
	<primitive: 'primitiveHasKerning' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'nk 11/4/2004 13:34'!
primLoadBbox: aRectangle
	<primitive: 'primitiveLoadFaceBbox' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'nk 11/3/2004 18:05'!
primLoadCharacter: index flags: flags
	<primitive: 'primitiveLoadCharacter' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private' stamp: 'tween 7/29/2006 11:31'!
primLoadFields
	<primitive: 'primitiveLoadFaceFields' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private-primitives' stamp: 'nk 11/3/2004 18:05'!
primLoadGlyph: index flags: flags
	<primitive: 'primitiveLoadGlyph' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private-primitives' stamp: 'nk 11/3/2004 15:58'!
primNewFaceFromFile: fileName index: anInteger
	<primitive: 'primitiveNewFaceFromFileAndIndex' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private-primitives' stamp: 'tween 7/24/2006 21:10'!
primNewMemoryFaceByteSize: anInteger index: anInteger2
	<primitive: 'primitiveNewMemoryFaceByteSizeAndIndex' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private-primitives' stamp: 'bf 11/19/2005 12:56'!
primRenderGlyphIntoForm: aForm
	<primitive: 'primitiveRenderGlyphIntoForm' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private-primitives' stamp: 'tween 8/13/2006 15:56'!
primRenderGlyphIntoForm: aForm pixelMode: anInteger
	<primitive: 'primitiveRenderGlyphIntoFormWithRenderMode' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private-primitives' stamp: 'bf 11/18/2005 19:33'!
primSetBitmapLeft: x top: y
	<primitive: 'primitiveSetBitmapLefttop' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'nk 11/3/2004 19:35'!
primSetCharMap: encodingString
	<primitive: 'primitiveSetFaceCharMap' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Face methodsFor: 'private-primitives' stamp: 'nk 11/4/2004 13:35'!
primSetPixelWidth: x height: y
	<primitive: 'primitiveSetPixelSizes' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'bf 11/19/2005 15:36'!
primSetTransform: matrixWordArray delta: deltaWordArray
	"matrix is 16.16 fixed point
		x' = x*m[0] + y*m[1]                                 
		y' = x*m[2] + y*yy[3]
	delta is 26.6 fixed point
		x' = x + d[0]
		y' = y + d[1]
	"
	<primitive: 'primitiveSetTransform' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'tween 8/2/2006 20:45'!
primTransformGlyphSlotOutline:  anIntegerArray
	<primitive: 'primitiveTransformFaceGlyphSlotOutline' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'private-primitives' stamp: 'tween 8/2/2006 20:45'!
primTranslateGlyphSlotOutline:  anIntegerArray
	<primitive: 'primitiveTranslateFaceGlyphSlotOutline' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'printing' stamp: 'tween 7/28/2006 14:53'!
printOn: aStream 
	super printOn: aStream.
	handle isNil ifTrue: [^self].
	"self familyName isNil ifTrue: [ self loadFields ]."
	aStream
		nextPut: $[;
		nextPutAll: (self familyName ifNil: ['?']);
		space;
		nextPutAll: (self styleName ifNil: ['?']);
		nextPut: $]! !

!FT2Face methodsFor: 'rendering' stamp: 'bf 11/19/2005 12:56'!
renderGlyphIntoForm: aForm
	"render the current glyph (selected by loadChar/loadGlyph into the given form (1 or 8 bpp)"
	self primRenderGlyphIntoForm: aForm
! !

!FT2Face methodsFor: 'rendering' stamp: 'tween 8/13/2006 15:57'!
renderGlyphIntoForm: aForm pixelMode: anInteger
	"render the current glyph (selected by loadChar/loadGlyph into the given form (1 or 8 bpp)
	with pixel mode anInteger "
	self primRenderGlyphIntoForm: aForm pixelMode: anInteger
! !

!FT2Face methodsFor: 'charmaps' stamp: 'nk 11/3/2004 20:39'!
setCharMap: encodingString
	self primSetCharMap: encodingString.
	self primGetCharMap.
! !

!FT2Face methodsFor: 'glyphs' stamp: 'nk 11/3/2004 18:23'!
setPixelWidth: x height: y
	self primSetPixelWidth: x height: y! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
size
	^size! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
styleFlags
	^styleFlags! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
styleName
	^styleName! !

!FT2Face methodsFor: 'rendering' stamp: 'tween 8/2/2006 20:47'!
transformOutlineAngle: angle scalePoint: scalePoint slant: slant
	| oneX oneY matrix  slantOne|
	oneX := (16r10000 * scalePoint x) asInteger.
	oneY :=  (16r10000 * scalePoint y) asInteger.
	slantOne := (16r10000 * scalePoint x * slant) asInteger.
	matrix := IntegerArray new: 4.
	angle isZero ifTrue: [
		matrix at: 1 put: oneX.
		matrix at: 2 put: slantOne.
		matrix at: 4 put: oneY.
	] ifFalse: [
		| phi cos sin |
		phi := angle degreesToRadians.
		cos := (phi sin * oneX) rounded.
		sin := (phi cos * oneY) rounded.
		matrix at: 1 put: sin.
		matrix at: 2 put: cos negated.
		matrix at: 3 put: cos.
		matrix at: 4 put: sin.
 	].
	self primTransformGlyphSlotOutline: matrix! !

!FT2Face methodsFor: 'rendering' stamp: 'tween 8/2/2006 20:48'!
translateOutlineBy: aPoint
	| delta|
	delta := IntegerArray new: 2.
	delta at: 1 put: (aPoint x * 64) rounded. 
	delta at: 2 put: (aPoint y * 64) rounded.
	self primTranslateGlyphSlotOutline: delta.! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
underlinePosition
	^underlinePosition! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
underlineThickness
	^underlineThickness! !

!FT2Face methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:56'!
unitsPerEm
	^unitsPerEm! !

FT2Face subclass: #FreeTypeFace
	instanceVariableNames: 'filename index fileContentsExternalMemory valid hasKerning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Fonts'!

!FreeTypeFace class methodsFor: 'font dirs' stamp: 'tween 3/16/2007 12:44'!
fontPathFor: aFilename
	"aFilename is local. Try hard to return a valid path to be handed to freetype library"
	
	"temporary solution ;-)"
	^(FileDirectory default
		directoryNamed: 'Fonts')
			fullPathFor: aFilename! !

!FreeTypeFace class methodsFor: 'instance creation' stamp: 'tween 3/16/2007 12:44'!
fromBytes: aByteArray index: anInteger
	"share alike instances"
	
	self allInstancesDo: [:inst |
		(inst fileContentsExternalMemoryBytes = aByteArray and: [inst index = anInteger])
			ifTrue: [^inst "validate"]].
	^(self basicNew)
		fileContentsExternalMemory: (FreeTypeExternalMemory bytes: aByteArray);
		index: anInteger;
		yourself! !

!FreeTypeFace class methodsFor: 'instance creation' stamp: 'tween 3/16/2007 12:44'!
fromFile: aFileName index: anInteger
	"share alike instances"
	^FileDirectory splitName: aFileName to: [:dir :fname |
		self rememberFontDir: dir.
		self allInstancesDo: [:inst |
			(inst filename = aFileName and: [inst index = anInteger])
				ifTrue: [^inst "validate"]].
		(self basicNew)
			filename: aFileName;
			index: anInteger;
			yourself]! !

!FreeTypeFace class methodsFor: 'font dirs' stamp: 'tween 3/16/2007 12:44'!
rememberFontDir: aDirecory! !

!FreeTypeFace methodsFor: 'initialize-release' stamp: 'tween 3/16/2007 12:44'!
actAsExecutor
	super actAsExecutor.
	filename := '<finalizer>'.! !

!FreeTypeFace methodsFor: 'initialize-release' stamp: 'tween 3/16/2007 12:53'!
beNull
	super beNull.
	valid := nil
	! !

!FreeTypeFace methodsFor: 'validation' stamp: 'tween 3/16/2007 12:44'!
create
	"create me in the FT2Plugin. This gets my handle, and loads the fields"
	
	fileContentsExternalMemory isNil
		ifTrue:[		
			self
				newFaceFromFile: (self class fontPathFor: filename)
				index: index]
		ifFalse:[
			self newFaceFromExternalMemory: fileContentsExternalMemory index: index].
	self loadFields
! !

!FreeTypeFace methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:44'!
familyName
	^super familyName ifNil:['?']! !

!FreeTypeFace methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:44'!
fileContentsExternalMemory: aFreeTypeExternalMemory
	fileContentsExternalMemory := aFreeTypeExternalMemory! !

!FreeTypeFace methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:44'!
fileContentsExternalMemoryBytes
	^fileContentsExternalMemory ifNotNil:[fileContentsExternalMemory bytes]! !

!FreeTypeFace methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:44'!
filename
	^filename! !

!FreeTypeFace methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:44'!
filename: aString
	filename := aString! !

!FreeTypeFace methodsFor: 'testing' stamp: 'tween 3/16/2007 12:44'!
hasFamilyName
	^super familyName notNil! !

!FreeTypeFace methodsFor: 'testing' stamp: 'tween 3/31/2007 14:52'!
hasKerning
	^hasKerning ifNil:[
		[hasKerning := self primHasKerning = 64] 
			on: Error do:[:e | hasKerning := false].
		hasKerning]! !

!FreeTypeFace methodsFor: 'testing' stamp: 'tween 3/16/2007 12:44'!
hasStyleName
	^super styleName notNil! !

!FreeTypeFace methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:44'!
index
	^index! !

!FreeTypeFace methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:44'!
index: anInteger
	index := anInteger! !

!FreeTypeFace methodsFor: 'testing' stamp: 'tween 3/31/2007 16:18'!
isValid
	^valid ifNil:[valid := super isValid]! !

!FreeTypeFace methodsFor: 'validation' stamp: 'tween 3/17/2007 12:21'!
newFaceFromExternalMemory: aFreeTypeExternalMemory index: anInteger
	| answer |
	valid := nil.
	answer := super newFaceFromExternalMemory: aFreeTypeExternalMemory index: anInteger.
	valid := super isValid.
	^answer
	! !

!FreeTypeFace methodsFor: 'validation' stamp: 'tween 3/17/2007 12:19'!
newFaceFromFile: fileName index: anInteger
	| answer |
	valid := nil.
	answer := super newFaceFromFile: fileName index: anInteger.
	valid := super isValid.
	^answer
	! !

!FreeTypeFace methodsFor: 'validation' stamp: 'tween 3/16/2007 12:44'!
primNewFaceFromExternalMemory: aFreeTypeExternalMemory size: anInteger index: anInteger2
	<primitive: 'primitiveNewMemoryFaceFromExternalMemoryAndIndex' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FreeTypeFace methodsFor: 'caching' stamp: 'tween 3/31/2007 16:36'!
releaseCachedState

	hasKerning := nil.
	self destroyHandle.
! !

!FreeTypeFace methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:44'!
styleName
	^super styleName ifNil:['']! !

!FreeTypeFace methodsFor: 'validation' stamp: 'tween 3/16/2007 12:44'!
validate
	"If the receiver is not valid (has a nil handle), then create the 
	receiver to obtain a handle and load the receiver's fields"
	
	self isValid ifFalse: [self create]! !

!FT2Handle class methodsFor: 'system startup' stamp: 'nk 3/17/2005 16:23'!
clearRegistry
	Registry ifNotNilDo: 
			[:r |
			r finalizeValues.
			r do: [:k | k ifNotNil: [k beNull] ]].
	Registry := nil! !

!FT2Handle class methodsFor: 'private-handle registry' stamp: 'nk 3/17/2005 16:28'!
deregister: aHandle
	Registry ifNotNilDo: [ :reg | | finalizer |
		finalizer := reg remove: aHandle ifAbsent: [].
		finalizer ifNotNil: [ finalizer beNull ] ].
! !

!FT2Handle class methodsFor: 'error reporting' stamp: 'nk 11/3/2004 13:51'!
errorCode
	<primitive: 'primitiveErrorCode' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Handle class methodsFor: 'error reporting' stamp: 'nk 11/3/2004 15:49'!
errorString
	<primitive: 'primitiveErrorString' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Handle class methodsFor: 'class initialization' stamp: 'tween 7/28/2006 07:42'!
initialize
	"FT2Handle initialize"

	Smalltalk removeFromStartUpList: self. "in case it was added by earlier version"
	Smalltalk addToShutDownList: self.
! !

!FT2Handle class methodsFor: 'error reporting' stamp: 'nk 11/3/2004 15:50'!
moduleErrorCode
	<primitive: 'primitiveModuleErrorCode' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Handle class methodsFor: 'private-handle registry' stamp: 'tween 7/25/2006 00:58'!
register: aHandle

	self registry ifNotNilDo: [ :reg |
		reg add: aHandle.
			^self ].
	self error: 'WeakArrays are not supported in this VM!!' ! !

!FT2Handle class methodsFor: 'private-handle registry' stamp: 'nk 3/17/2005 16:51'!
registry
	WeakArray isFinalizationSupported ifFalse:[^nil].
	^Registry ifNil: [ Registry := FT2HandleRegistry new]! !

!FT2Handle class methodsFor: 'system startup' stamp: 'tween 7/28/2006 07:43'!
shutDown: quitting 
	"we must not save handles (which are pointers) in the image"
	self clearRegistry.
	FT2Handle allSubInstances do: [:h | h beNull].	"if some handle was not registered"
! !

!FT2Handle class methodsFor: 'initialize-release' stamp: 'nk 11/3/2004 21:00'!
unload
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.
! !

!FT2Handle methodsFor: 'private' stamp: 'nk 11/3/2004 16:10'!
beNull
	handle := nil.! !

!FT2Handle methodsFor: 'private' stamp: 'nk 11/4/2004 16:44'!
destroyHandle
	self class deregister: self.
	self pvtDestroyHandle! !

!FT2Handle methodsFor: 'error handling' stamp: 'nk 11/3/2004 13:51'!
errorCode
	<primitive: 'primitiveErrorCode' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Handle methodsFor: 'error handling' stamp: 'nk 11/3/2004 21:07'!
errorString
	<primitive: 'primitiveErrorString' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2Handle methodsFor: 'finalization' stamp: 'nk 11/3/2004 12:21'!
finalize
	self pvtDestroyHandle.
! !

!FT2Handle methodsFor: 'private' stamp: 'nk 11/3/2004 21:19'!
handle
	^handle! !

!FT2Handle methodsFor: 'initialize-release' stamp: 'nk 3/11/2005 18:44'!
initialize
	self shouldNotImplement.! !

!FT2Handle methodsFor: 'printing' stamp: 'nk 3/17/2005 16:40'!
isValid
	^handle notNil and: [ handle anySatisfy: [ :b | b isZero not ] ]! !

!FT2Handle methodsFor: 'private' stamp: 'nk 11/3/2004 12:21'!
primDestroyHandle
	self subclassResponsibility! !

!FT2Handle methodsFor: 'error handling' stamp: 'nk 11/4/2004 13:32'!
primitiveFailed
	^self primitiveFailed: 'Freetype2 primitive failed'! !

!FT2Handle methodsFor: 'error handling' stamp: 'nk 11/4/2004 13:33'!
primitiveFailed: aString
	^FT2Error new
		signal: aString! !

!FT2Handle methodsFor: 'printing' stamp: 'nk 3/17/2005 14:08'!
printOn: aStream
	| handleHex |
	super printOn: aStream.
	handle isNil ifTrue: [ ^aStream nextPutAll: '<nil>' ].
	handleHex := (handle unsignedLongAt: 1 bigEndian: SmalltalkImage current isBigEndian) printStringHex.
	aStream nextPutAll: '<0x'; nextPutAll: handleHex; nextPut: $>.! !

!FT2Handle methodsFor: 'private' stamp: 'nk 11/3/2004 16:23'!
pvtDestroyHandle
	"This should only be sent from the finalizer."
	handle ifNil: [ ^self ].
	self primDestroyHandle.
	self beNull.! !

FT2Handle subclass: #FT2Library
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2Library commentStamp: '<historical>' prior: 0!
This is a wrapper for the global 'library' in the plugin.
It is provided for the use of Cairo APIs that take an FT_Library argument.!

!FT2Library class methodsFor: 'instance creation' stamp: 'nk 3/17/2005 14:19'!
current
	^[ (self basicNew)
		current ] on: FT2Error do: [ :ex | ex return: nil ].! !

!FT2Library methodsFor: 'private-primitives' stamp: 'tween 3/17/2007 14:18'!
current
	^[self primCurrentLibrary] on: Error do: [:e | nil]! !

!FT2Library methodsFor: 'private-primitives' stamp: 'nk 11/4/2004 13:27'!
destroyHandle
	"This is not a managed handle, but a global. Do nothing."! !

!FT2Library methodsFor: 'private-primitives' stamp: 'nk 11/4/2004 13:32'!
primCurrentLibrary
	<primitive: 'primitiveLibraryHandle' module: 'FT2Plugin'>
	^self primitiveFailed! !

FT2Handle subclass: #FT2MemoryFaceData
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2MemoryFaceData class methodsFor: 'instance creation' stamp: 'tween 8/6/2006 11:11'!
bytes: aByteArray
	| answer |
	answer := self basicNew
		bytes: aByteArray;
		yourself.
	^answer! !

!FT2MemoryFaceData methodsFor: 'accessing' stamp: 'tween 7/24/2006 23:04'!
bytes
	^bytes
	! !

!FT2MemoryFaceData methodsFor: 'accessing' stamp: 'tween 7/24/2006 22:43'!
bytes: aByteArray

	bytes := aByteArray.
	! !

!FT2MemoryFaceData methodsFor: 'initialize-release' stamp: 'tween 7/24/2006 21:53'!
free
	^self destroyHandle! !

!FT2MemoryFaceData methodsFor: 'primitives' stamp: 'tween 7/24/2006 21:52'!
primDestroyHandle
	<primitive: 'primitiveFreeMemoryFaceData' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2MemoryFaceData methodsFor: 'primitives' stamp: 'tween 7/24/2006 22:32'!
primMalloc: aByteArray
	"copy aByteArray into newly allocated, external memory, and store the
	address of that memory in the receiver's handle"
	<primitive: 'primitiveMallocMemoryFaceData' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FT2MemoryFaceData methodsFor: 'validation' stamp: 'tween 7/31/2006 21:48'!
validate
	self isValid 
		ifFalse: [
			bytes ifNotNil:[
				[self primMalloc: bytes]
					on: FT2Error 
					do:[:e |"need to do something here?"].
				self isValid ifTrue:[self class register: self]]]! !

FT2Handle subclass: #FreeTypeExternalMemory
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FreeTypeExternalMemory class methodsFor: 'instance creation' stamp: 'tween 8/12/2006 08:42'!
bytes: aByteArray
	| answer |
	answer := self basicNew
		bytes: aByteArray;
		yourself.
	^answer! !

!FreeTypeExternalMemory methodsFor: 'accessing' stamp: 'tween 8/12/2006 08:40'!
bytes
	^bytes! !

!FreeTypeExternalMemory methodsFor: 'accessing' stamp: 'tween 8/12/2006 08:40'!
bytes: aByteArray
	bytes := aByteArray! !

!FreeTypeExternalMemory methodsFor: 'primitives' stamp: 'tween 8/12/2006 10:25'!
primCopyToExternalMemory: aByteArray
	"copy aByteArray into newly allocated, external memory, and store the
	address of that memory in the receiver's handle"
	<primitive: 'primitiveCopyToExternalMemory' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FreeTypeExternalMemory methodsFor: 'primitives' stamp: 'tween 8/12/2006 10:24'!
primDestroyHandle
	<primitive: 'primitiveFreeExternalMemory' module: 'FT2Plugin'>
	^self primitiveFailed! !

!FreeTypeExternalMemory methodsFor: 'validation' stamp: 'tween 8/12/2006 10:25'!
validate
	self isValid 
		ifFalse: [
			bytes ifNotNil:[
				[self primCopyToExternalMemory: bytes]
					on: FT2Error 
					do:[:e |"need to do something here?"].
				self isValid ifTrue:[self class register: self]]]! !

Object subclass: #FT2Outline
	instanceVariableNames: 'contoursSize pointsSize points tags contours flags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2Outline commentStamp: '<historical>' prior: 0!
@instVar: contoursSize - The number of contours in the outline.
@instVar: pointsSize - The number of points in the outline.
@instVar: points - an array of  26.6 fixed point integer pairs giving the outline's point coordinates.

@instVar: tags	- an array of pointsSize bytes, giving each outline point's type. 

(counting from 0)

If bit 0 is unset, the point is 'off' the curve, i.e., a Bzier control point, while it is 'on' when set.

Bit 1 is meaningful for 'off' points only. If set, it indicates a third-order Bzier arc control point; and a second-order control point if unset.

@instVar: contours - an array of contoursSize shorts, giving the end point of each contour within the outline. For example, the first contour is defined by the points '0' to 'contours[0]', the second one is defined by the points 'contours[0]+1' to 'contours[1]', etc.

@instVar: flags - a set of bit flags used to characterize the outline and give hints to the scan-converter and hinter on how to convert/grid-fit it.!

!FT2Outline methodsFor: 'private' stamp: 'jl 5/24/2006 13:58'!
allocateArrays
	" allocate the arrays for the primLoadArraysFrom:"
	points := 	IntegerArray new: pointsSize * 2.
	tags := 		ByteArray new: pointsSize.
	contours := 	ShortIntegerArray new: contoursSize.! !

!FT2Outline methodsFor: 'accessing' stamp: 'jl 5/24/2006 15:19'!
contoursCollection
	"returns a list of contours with tag => points list pairs"
	| allPoints result start end |
	allPoints := self pointCollection.
	
	result := OrderedCollection new.
	start := 1.
	"no normal iteration because contours size can be bigger than contourSize"
	1 to: contoursSize do: [ :i |
		end := (contours at: i) + 1. "c converion"
		result add: ((tags copyFrom: start to: end) ->  (allPoints copyFrom: start to: end)).
		start := end + 1.
	].

	^result

		

		
! !

!FT2Outline methodsFor: 'accessing' stamp: 'jl 5/24/2006 14:26'!
pointCollection

	^(1 to: pointsSize * 2 by: 2) collect: [ :i | ((points at: i) / 64) @ ((points at: i + 1) / 64)]

		

		
! !

!FT2Outline methodsFor: 'private' stamp: 'jl 5/23/2006 17:01'!
primLoadArraysFrom: anFT2Face
	<primitive: 'primitiveLoadOutlineArraysFromFace' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Outline methodsFor: 'private' stamp: 'jl 5/23/2006 17:01'!
primLoadSizesFrom: anFT2Face
	<primitive: 'primitiveLoadOutlineSizesFromFace' module: 'FT2Plugin'>
	^self primitiveFailed.! !

Object subclass: #FT2Version
	instanceVariableNames: 'major minor patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-Base'!

!FT2Version commentStamp: '<historical>' prior: 0!
Do not rearrange these fields!!

This is used to report FT2 version information. Its fields must remain unchanged, or you must change FT2Plugin>>primitiveVersion.!

!FT2Version class methodsFor: 'instance creation' stamp: 'nk 11/4/2004 11:10'!
current
	"
	FT2Version current
	"
	^ [(self new)
		libraryVersion;
		yourself] on: Error do: [:ex | ex return: nil]! !

!FT2Version methodsFor: 'primitives' stamp: 'nk 11/3/2004 11:20'!
libraryVersion
	<primitive: 'primitiveVersion' module: 'FT2Plugin'>
	^self primitiveFailed.
! !

!FT2Version methodsFor: 'accessing' stamp: 'nk 3/21/2004 11:03'!
major
	^major! !

!FT2Version methodsFor: 'accessing' stamp: 'nk 3/21/2004 11:03'!
minor
	^minor! !

!FT2Version methodsFor: 'accessing' stamp: 'nk 11/3/2004 11:17'!
patch
	^patch! !

!FT2Version methodsFor: 'printing' stamp: 'nk 11/3/2004 11:22'!
printOn: aStream
	aStream print: major; nextPut: $.; print: minor; nextPut:$.; print: patch.! !

Object subclass: #FontFamilyAbstract
	instanceVariableNames: 'familyName members'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!FontFamilyAbstract methodsFor: 'member lookup' stamp: 'tween 8/18/2007 13:50'!
closestMemberWithStretchValue: stretchValue weightValue: weightValue slantValue: slantValue
	"answer the member that has weight, slant and stretch values that most closely 
	match those given by stretchValue, weightValue, and slantValue"
	
	^(self members asSortedCollection:[:a :b | 
		a isCloserMatchThan: b 
			toStretch: stretchValue 
			weight: weightValue 
			slant: slantValue]) first. ! !

!FontFamilyAbstract methodsFor: 'accessing' stamp: 'tween 8/18/2007 13:46'!
familyName
	"Answer the value of familyName"

	^ familyName! !

!FontFamilyAbstract methodsFor: 'accessing' stamp: 'tween 8/18/2007 13:46'!
familyName: anObject
	"Set the value of familyName"

	familyName := anObject! !

!FontFamilyAbstract methodsFor: 'accessing' stamp: 'tween 8/18/2007 13:47'!
members
	"Answer the value of members"

	^ members! !

!FontFamilyAbstract methodsFor: 'printing' stamp: 'tween 9/7/2007 19:36'!
printOn: aStream
	aStream 
		nextPutAll: self class name asString;
		nextPut: $ ;
		nextPutAll: self familyName printString! !

FontFamilyAbstract subclass: #FreeTypeFontFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!FreeTypeFontFamily methodsFor: 'accessing' stamp: 'tween 8/25/2007 14:26'!
addMember: aFreeTypeFontFamilyMember
	aFreeTypeFontFamilyMember family: self.
	members add: aFreeTypeFontFamilyMember! !

!FreeTypeFontFamily methodsFor: 'accessing' stamp: 'tween 8/16/2007 22:58'!
addMembersFromFileInfos: aCollectionOfFreeTypeFileInfo
	
	| member |
	aCollectionOfFreeTypeFileInfo do:[:aFileInfo |
		member := FreeTypeFontFamilyMember fromFileInfo: aFileInfo.
		(self memberWithStyleName: member styleName)
			ifNil:[self addMember: member]].
	! !

!FreeTypeFontFamily methodsFor: 'simulated members' stamp: 'tween 9/29/2007 12:57'!
addSimulatedMembers
	| membersBySlantAndStretch heaviest membersByWeightAndStretch regular oblique |
	membersBySlantAndStretch := Dictionary new.
	members do:[:each| 
		(membersBySlantAndStretch 
			at: {each slantValue. each stretchValue} 
			ifAbsentPut:[OrderedCollection new]) 
				add: each].
	membersBySlantAndStretch keysAndValuesDo:[:key :col |
		heaviest := col ifNotEmpty:[col first].
		col do:[:each |
			heaviest weightValue < each weightValue
				ifTrue:[heaviest := each]].
		(heaviest weightValue between: (LogicalFont weightRegular - 50) and: (LogicalFont weightMedium + 50))
			ifTrue:[	members add: heaviest asSimulatedBold]].			
	membersByWeightAndStretch := Dictionary new.
	members do:[:each| | normalizedWeight |
		normalizedWeight := each weightValue.
		each weightValue = LogicalFont weightMedium ifTrue:[normalizedWeight := LogicalFont weightRegular].	
		"regular and medium weights are used interchangeably.
		For example, FreeSans has Regular-weightMedium(500), and Oblique-weightRegular(400).
		We don't want to simulate oblique-weightMedium(500) when a real 
		Oblique-weightMedium(500) exists, so we normalize any weightMedium(500)
		values to weightRegular(400) to prevent this happening" 	
		(membersByWeightAndStretch 
			at: {normalizedWeight. each stretchValue} 
			ifAbsentPut:[OrderedCollection new]) 
				add: each].	
	membersByWeightAndStretch keysAndValuesDo:[:key :col |
		regular := col detect: [:each | each slantValue = 0] ifNone:[].
		oblique := col detect:[:each | each slantValue > 0] ifNone:[]. "oblique or italic"
		(oblique isNil and:[regular notNil]) 
			ifTrue:[
				regular simulated
					ifTrue:[members add: regular asSimulatedBoldOblique]
					ifFalse:[	members add: regular asSimulatedOblique]]]! !

!FreeTypeFontFamily methodsFor: 'initialize-release' stamp: 'tween 8/16/2007 20:44'!
initialize
	super initialize.
	members := OrderedCollection new.! !

!FreeTypeFontFamily methodsFor: 'accessing' stamp: 'tween 8/16/2007 22:59'!
memberWithStyleName: aString
	^members detect:[:each | each styleName = aString] ifNone:[]
! !

!FreeTypeFontFamily methodsFor: 'simulated members' stamp: 'tween 8/18/2007 22:22'!
rebuildSimulatedMembers
	"FOR TESTING ONLY"
	
	members := members reject:[:each| each simulated].
	self addSimulatedMembers.! !

FontFamilyAbstract subclass: #TextStyleAsFontFamily
	instanceVariableNames: 'textStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!TextStyleAsFontFamily methodsFor: 'accessing' stamp: 'tween 8/25/2007 14:25'!
members
	^members ifNil:[
		members := #('Regular' 'Italic' 'Bold' 'Bold Italic')
		  collect:[:each | 
			TextStyleAsFontFamilyMember new 
				family: self;
				styleName: each;
				yourself]]! !

!TextStyleAsFontFamily methodsFor: 'accessing' stamp: 'tween 8/16/2007 22:09'!
textStyle
	"Answer the value of textStyle"

	^ textStyle! !

!TextStyleAsFontFamily methodsFor: 'accessing' stamp: 'tween 8/16/2007 22:09'!
textStyle: anObject
	"Set the value of textStyle"

	textStyle := anObject! !

Object subclass: #FontFamilyMemberAbstract
	instanceVariableNames: 'family styleName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!FontFamilyMemberAbstract methodsFor: 'converting' stamp: 'tween 9/8/2007 13:25'!
asLogicalFontOfPointSize: pointSize
	^LogicalFont
		familyName: self family familyName 
		pointSize: pointSize 
		stretchValue: self stretchValue
		weightValue: self weightValue
		slantValue: self slantValue! !

!FontFamilyMemberAbstract methodsFor: 'comparing' stamp: 'tween 8/18/2007 13:42'!
closenessVector
	^self closenessVectorForStretch: self stretchValue slant: self slantValue weight: self weightValue! !

!FontFamilyMemberAbstract methodsFor: 'comparing' stamp: 'tween 9/29/2007 13:00'!
closenessVectorForStretch: stretch slant: slant weight: weight
	| normalizedSlant |
	normalizedSlant := slant.
	normalizedSlant ~= 0 ifTrue:[
		 "treat italic and oblique as though they were they same"
		normalizedSlant := LogicalFont slantItalic].
	^{(stretch - LogicalFont stretchRegular) * 11. slant * 7. ((weight - LogicalFont weightRegular) / 100) * 5}! !

!FontFamilyMemberAbstract methodsFor: 'accessing' stamp: 'tween 8/25/2007 14:22'!
family
	^family! !

!FontFamilyMemberAbstract methodsFor: 'accessing' stamp: 'tween 8/25/2007 14:22'!
family: aFontFamily
	family := aFontFamily! !

!FontFamilyMemberAbstract methodsFor: 'comparing' stamp: 'tween 8/18/2007 13:43'!
isCloserMatchThan: otherMember toStretch: inputStretch weight: inputWeight slant: inputSlant 
	| inputVector vector otherVector distance otherDistance dotProduct otherDotProduct |
	
	inputVector := self closenessVectorForStretch: inputStretch slant: inputSlant weight: inputWeight.
	vector := self closenessVector.
	otherVector := otherMember closenessVector.
	distance := (((inputVector first - vector first) raisedTo: 2) +
			((inputVector second - vector second) raisedTo: 2) +
			((inputVector third - vector third) raisedTo: 2)) sqrt.
	otherDistance := (((inputVector first - otherVector first) raisedTo: 2) +
			((inputVector second - otherVector second) raisedTo: 2) +
			((inputVector third - otherVector third) raisedTo: 2)) sqrt.
	distance < otherDistance ifTrue:[^true].
	distance > otherDistance ifTrue:[^false].	
	dotProduct := (inputVector first * vector first) +
				(inputVector second * vector second) +
				(inputVector third * vector third).
	otherDotProduct := (inputVector first * otherVector first) +
				(inputVector second * otherVector second) +
				(inputVector third * otherVector third).
	dotProduct > otherDotProduct ifTrue:[^true].
	dotProduct < otherDotProduct ifTrue:[^false].	
	vector first > otherVector first ifTrue:[^true].
	vector first < otherVector first ifTrue:[^false].
	vector second > otherVector second ifTrue:[^true].
	vector second < otherVector second ifTrue:[^false].
	vector third > otherVector third ifTrue:[^true].
	vector third < otherVector third ifTrue:[^false].
	^false ! !

!FontFamilyMemberAbstract methodsFor: 'accessing' stamp: 'tween 9/8/2007 13:24'!
slantValue
	self subclassResponsibility! !

!FontFamilyMemberAbstract methodsFor: 'accessing' stamp: 'tween 9/8/2007 13:24'!
stretchValue
	self subclassResponsibility! !

!FontFamilyMemberAbstract methodsFor: 'accessing' stamp: 'tween 8/18/2007 13:41'!
styleName
	"Answer the value of styleName"

	^ styleName! !

!FontFamilyMemberAbstract methodsFor: 'accessing' stamp: 'tween 8/18/2007 13:41'!
styleName: anObject
	"Set the value of styleName"

	styleName := anObject! !

!FontFamilyMemberAbstract methodsFor: 'accessing' stamp: 'tween 9/8/2007 13:24'!
weightValue
	self subclassResponsibility! !

FontFamilyMemberAbstract subclass: #FreeTypeFontFamilyMember
	instanceVariableNames: 'fileInfo stretchName stretchValue weightName weightValue slantName slantValue simulated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!FreeTypeFontFamilyMember class methodsFor: 'instance creation' stamp: 'tween 8/16/2007 21:39'!
fromFileInfo: aFreeTypeFileInfo
	
	^self new
		fileInfo: aFreeTypeFileInfo;
		simulated: false;
		styleName: aFreeTypeFileInfo styleNameExtracted;
		stretchName: aFreeTypeFileInfo stretch;
		stretchValue: aFreeTypeFileInfo stretchValue;
		weightName: aFreeTypeFileInfo weight;
		weightValue: aFreeTypeFileInfo weightValue;
		slantName: aFreeTypeFileInfo slant;
		slantValue: aFreeTypeFileInfo slantValue;
		yourself
		! !

!FreeTypeFontFamilyMember methodsFor: 'comparing' stamp: 'tween 8/16/2007 23:23'!
<= aFreeTypeFontFamilyMember
	^self sortValue <= aFreeTypeFontFamilyMember sortValue! !

!FreeTypeFontFamilyMember methodsFor: 'copying' stamp: 'tween 9/29/2007 12:49'!
asSimulatedBold
	^self copy 
		weightValue: LogicalFont weightBold;
		styleName: (fileInfo styleNameWithWeightForcedToBe: 'Bold');
		simulated: true;
		yourself! !

!FreeTypeFontFamilyMember methodsFor: 'copying' stamp: 'tween 9/29/2007 12:50'!
asSimulatedBoldOblique
	^self copy 
		slantValue: LogicalFont slantItalic; "treat italic and oblique the same"
		weightValue:LogicalFont weightBold;
		styleName: (fileInfo styleNameWithWeightForcedToBe: 'Bold' italicForcedToBe: 'Oblique');
		simulated: true;
		yourself! !

!FreeTypeFontFamilyMember methodsFor: 'copying' stamp: 'tween 9/29/2007 12:50'!
asSimulatedOblique
	^self copy 
		slantValue: LogicalFont slantItalic;  "treat italic and oblique the same"
		styleName: (fileInfo styleNameWithItalicForcedToBe: 'Oblique');
		simulated: true;
		yourself! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:46'!
fileInfo
	"Answer the value of fileInfo"

	^ fileInfo! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:46'!
fileInfo: anObject
	"Set the value of fileInfo"

	fileInfo := anObject! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
simulated
	"Answer the value of simulated"

	^ simulated! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
simulated: anObject
	"Set the value of simulated"

	simulated := anObject! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
slantName
	"Answer the value of slantName"

	^ slantName! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
slantName: anObject
	"Set the value of slantName"

	slantName := anObject! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
slantValue
	"Answer the value of slantValue"

	^ slantValue! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
slantValue: anObject
	"Set the value of slantValue"

	slantValue := anObject! !

!FreeTypeFontFamilyMember methodsFor: 'comparing' stamp: 'tween 9/29/2007 12:51'!
sortValue
	| v normalizedWeight | 
	normalizedWeight := weightValue.
	normalizedWeight = LogicalFont weightMedium 
		ifTrue:["sort medium and regular weights as though they were the same"
			normalizedWeight := LogicalFont weightRegular]. 
	v :=self simulated ifTrue:[10000] ifFalse:[0].
	v := v + (stretchValue * 1000).
	v := v + (normalizedWeight).
	v := v + (slantValue).
	^v
! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
stretchName
	"Answer the value of stretchName"

	^ stretchName! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
stretchName: anObject
	"Set the value of stretchName"

	stretchName := anObject! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
stretchValue
	"Answer the value of stretchValue"

	^ stretchValue! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
stretchValue: anObject
	"Set the value of stretchValue"

	stretchValue := anObject! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
weightName
	"Answer the value of weightName"

	^ weightName! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
weightName: anObject
	"Set the value of weightName"

	weightName := anObject! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
weightValue
	"Answer the value of weightValue"

	^ weightValue! !

!FreeTypeFontFamilyMember methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:29'!
weightValue: anObject
	"Set the value of weightValue"

	weightValue := anObject! !

FontFamilyMemberAbstract subclass: #TextStyleAsFontFamilyMember
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!TextStyleAsFontFamilyMember methodsFor: 'comparing' stamp: 'tween 8/16/2007 23:30'!
<=  aTextStyleAsFontFamilyMember
	| orderedItems |
	orderedItems := #('Condensed' 'Condensed Italic' 'Condensed Bold'  'Condensed Bold Italic' 'Regular' 'Italic' 'Bold' 'Bold Italic').
	^(orderedItems indexOf: self styleName) <= (orderedItems indexOf: aTextStyleAsFontFamilyMember styleName)! !

!TextStyleAsFontFamilyMember methodsFor: 'squeak emphasis' stamp: 'tween 9/29/2007 12:43'!
emphasisCode
	" Answer the squeak emphasis code (1=bold, 2=italic, 3=boldItalic etc"
	| answer |
	answer := 0.
	(styleName includesSubString: 'Italic') 
		ifTrue:[answer := answer bitOr: LogicalFont squeakSlantItalic].
	(styleName includesSubString: 'Condensed')
		ifTrue:[answer := answer bitOr: LogicalFont squeakStretchCondensed].
	(styleName includesSubString: 'Bold')
		ifTrue:[answer := answer bitOr: LogicalFont squeakWeightBold].
	^answer! !

!TextStyleAsFontFamilyMember methodsFor: 'testing' stamp: 'tween 8/17/2007 00:16'!
simulated 
	^false! !

!TextStyleAsFontFamilyMember methodsFor: 'LogicalFont emphasis' stamp: 'tween 9/29/2007 12:39'!
slantValue
	^(styleName includesSubString: 'Italic') 
		ifTrue:[LogicalFont slantItalic] 
		ifFalse:[LogicalFont slantRegular]! !

!TextStyleAsFontFamilyMember methodsFor: 'LogicalFont emphasis' stamp: 'tween 9/29/2007 12:40'!
stretchValue
	^(styleName includesSubString: 'Condensed') 
		ifTrue:[LogicalFont stretchCompressed]
		ifFalse:[LogicalFont stretchRegular]! !

!TextStyleAsFontFamilyMember methodsFor: 'LogicalFont emphasis' stamp: 'tween 9/29/2007 12:38'!
weightValue
	^(styleName includesSubString: 'Bold')
		ifTrue:[LogicalFont weightBold] 
		ifFalse:[LogicalFont weightRegular]! !

Object subclass: #FontProviderAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!FontProviderAbstract commentStamp: 'tween 3/14/2007 22:59' prior: 0!
Abstract superClass for fontProviders
	examples of possible fontProviders are 
		StrikeFontProvider
		FreeTypeFontProvider
		Win32NativeFontProvider
		!

!FontProviderAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 22:00'!
families
	self subclassResponsibility! !

!FontProviderAbstract methodsFor: 'font lookup' stamp: 'tween 3/16/2007 17:57'!
fontFor: aLogicalFont
	^nil! !

FontProviderAbstract subclass: #FreeTypeFontProvider
	instanceVariableNames: 'fileInfos fileInfoCache tempFileInfos embeddedFileInfoCache families tempFamilies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

FreeTypeFontProvider class
	instanceVariableNames: 'current'!

!FreeTypeFontProvider commentStamp: 'tween 3/15/2007 17:23' prior: 0!
A FreeTypeFontProvider is xxxxxxxxx.

Instance Variables
	fontInfoCache:		<Object>
	fontInfos:		<Object>

fontInfoCache
	- xxxxx

fontInfos
	- set of FreeTypeFontInfo. Info about all the fonts that are available
!

FreeTypeFontProvider class
	instanceVariableNames: 'current'!

!FreeTypeFontProvider class methodsFor: 'accessing' stamp: 'tween 3/23/2007 09:59'!
current
	"
	current := nil.
	TimeProfileBrowser onBlock: [FreeTypeFontProvider current]
	"
	^current 
		ifNil:[
			current := self new.
			current updateFromSystem]! !

!FreeTypeFontProvider class methodsFor: 'class initialization' stamp: 'tween 2/5/2008 22:42'!
initialize
	"
	self initialize
	"
	Smalltalk removeFromStartUpList: self.
	Smalltalk addToStartUpList: self after: SecurityManager. "actually it needs to be before AutoStart"
		
	"ensure that other classes have also been initialized by forcefully initializing them now.
	It then does not matter which order they are initialized in during the package load"
	FT2Constants initialize.
	FreeTypeCache initialize.
	FreeTypeCacheConstants initialize.
	FreeTypeSettings initialize.

	"an instVar, pendingKernX,  is added to both CharacterScanner and MultiCharacterScanner by 
	the preamble of the package. However, some versions of the monticello loader don't run the
	preamble code. So, we check if the instVars have been added, and if not add them now"
	(CharacterScanner instVarNames includes: 'pendingKernX') ifFalse:[
		Compiler evaluate: 'Object subclass: #CharacterScanner
	instanceVariableNames: ''destX lastIndex xTable destY stopConditions text textStyle alignment leftMargin rightMargin font line runStopIndex spaceCount spaceWidth emphasisCode kern indentationLevel wantsColumnBreaks pendingKernX''
	classVariableNames: ''DefaultStopConditions NilCondition PaddedSpaceCondition SpaceCondition''
	poolDictionaries: ''TextConstants''
	category: ''Graphics-Text'' '].
	(MultiCharacterScanner instVarNames includes: 'pendingKernX') ifFalse:[
Compiler evaluate: 'Object subclass: #MultiCharacterScanner
	instanceVariableNames: ''destX lastIndex xTable destY stopConditions text textStyle alignment leftMargin rightMargin font line runStopIndex spaceCount spaceWidth emphasisCode kern indentationLevel wantsColumnBreaks presentation presentationLine numOfComposition baselineY firstDestX pendingKernX''
	classVariableNames: ''DefaultStopConditions NilCondition PaddedSpaceCondition SpaceCondition''
	poolDictionaries: ''TextConstants''
	category: ''Multilingual-Scanning'' '].			
	
	self current. "this creates an instance of me, and updates from the system"! !

!FreeTypeFontProvider class methodsFor: 'startup' stamp: 'tween 3/30/2007 18:42'!
startUp: resuming
	resuming 
		ifTrue:[
			self current updateFromSystem]! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 3/15/2007 19:06'!
absoluteOrRelativePathFor: absolutePath locationType: aSymbol
	"answer a relative path from an absolute path according to the location type aSymbol"
	| p |

	aSymbol = #absolute ifTrue:[^absolutePath].
	aSymbol = #imageRelative ifTrue:[p := SmalltalkImage current imagePath].
	aSymbol = #vmRelative ifTrue:[p := SmalltalkImage current vmPath].
	(p notNil and:[absolutePath asLowercase beginsWith: p asLowercase])
		ifTrue:[^absolutePath copyFrom: p size + 1 to: absolutePath size].
	^absolutePath
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 3/16/2007 11:02'!
absolutePathFor: path locationType: aSymbol
	"answer an absolute path from an absolute or relative path according to the location type aSymbol"

	aSymbol = #imageRelative
		 ifTrue:[^SmalltalkImage current imagePath, FileDirectory slash, path ].
	aSymbol = #vmRelative 
		ifTrue:[^SmalltalkImage current vmPath ", FileDirectory slash" , path].
	^path
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:39'!
addFileInfo: aFreeTypeFileInfo index: i
	fileInfos add: aFreeTypeFileInfo
	
	
		
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'accessing' stamp: 'tween 7/28/2007 13:28'!
addFirstFileInfo: aFreeTypeFileInfo index: i
	fileInfos addFirst: aFreeTypeFileInfo
	
	
		
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'accessing' stamp: 'tween 8/12/2007 12:31'!
addFromFileContents: bytes baseName:  originalFileBaseName
	| i face numFaces info externalMem cachedInfo cachedNumFaces |

	i:= 0.
	[(cachedInfo := self validEmbeddedCachedInfoFor: bytes index: i) notNil]
		whileTrue:[
			i = 0 ifTrue:[cachedNumFaces := cachedInfo numFaces].
			self addFirstFileInfo: cachedInfo index: i.
			i := i + 1.].
	(cachedNumFaces notNil and:[i >= cachedNumFaces]) ifTrue:[^self].
	[externalMem := FreeTypeExternalMemory bytes: bytes.
	externalMem validate.
	face := FreeTypeFace basicNew fileContentsExternalMemory: externalMem .
	[ "we use the primNewFaceFromFile:index: method because we want to do this as fast as possible and we don't need the face registered because it will be explicitly destroyed later"
	face primNewFaceFromExternalMemory: externalMem size: bytes size index: i.
	face loadFields] 
		on: FT2Error 
		do:[:e | 
			self failedToOpen:face index: i.
			^externalMem destroyHandle.].
	(face height notNil  and:[face hasFamilyName and:[face hasStyleName and:[face isValid]]])
		ifFalse:[
			self failedToOpen:face index: i.
			^externalMem destroyHandle.]
		ifTrue:[
			numFaces isNil ifTrue:[numFaces := face numFaces].
			info :=FreeTypeEmbeddedFileInfo new
				baseName: originalFileBaseName;
				fileContents: bytes;
				index: i;
				familyName: face familyName;
				styleName: face styleName;
				postscriptName: face postscriptName;
				bold: face isBold;
				italic: face isItalic;
				fixedWidth: face isFixedWidth;
				numFaces: numFaces;
				extractAttributesFromNames;
				yourself.
			self addFirstFileInfo: info index: i.
			self cacheEmbeddedFileInfo: info index: i.
			"Transcript show: 'from file : ', info asString."
			face destroyHandle.
			externalMem destroyHandle].
	i := i + 1.
	i < numFaces "note, we use < rather than <= , because i is zero based"] whileTrue:[].
	
	
		
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'font families' stamp: 'tween 8/16/2007 20:39'!
buildFamilies
	| familyNames family |
	families := Dictionary new.
	familyNames :=	(fileInfos collect:[:each | each familyGroupName]) asSet asSortedCollection asArray.
	familyNames do:[:familyName |
		family := self buildFamilyNamed: familyName.
		families at: familyName put: family].
	
	
	
	! !

!FreeTypeFontProvider methodsFor: 'font families' stamp: 'tween 8/16/2007 21:43'!
buildFamilyNamed: aFamilyGroupName
	| infos family|
	family := FreeTypeFontFamily new
		familyName: aFamilyGroupName;
		yourself. 
	infos := fileInfos select:[:each | each familyGroupName = aFamilyGroupName].
	family addMembersFromFileInfos: infos.
	family addSimulatedMembers.
	^family
		
			
			
		! !

!FreeTypeFontProvider methodsFor: 'accessing' stamp: 'tween 7/28/2007 13:50'!
cacheEmbeddedFileInfo: aFreeTypeEmbeddedFileInfo index: i

	(embeddedFileInfoCache  at:  {aFreeTypeEmbeddedFileInfo fileSize. i} ifAbsentPut:[Set new])
		add:  aFreeTypeEmbeddedFileInfo
	
	
		
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'accessing' stamp: 'tween 3/16/2007 12:41'!
cacheFileInfo: aFreeTypeFileInfo index: i

	(fileInfoCache  at:  {aFreeTypeFileInfo fileSize. i} ifAbsentPut:[Set new])
		add:  aFreeTypeFileInfo
	
	
		
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'loading and updating' stamp: 'tween 7/28/2007 14:22'!
embedFilesInDirectory: aFileDirectory
	"embed all the files in aFileDirectory
	
	FreeTypeFontProvider current embedFilesInDirectory: (FileDirectory default directoryNamed: 'Fonts')
	"
	| filestream bytes basename |
	aFileDirectory fileNames do:[:filename |
		filestream  := aFileDirectory fileNamed: filename.
		filestream binary.
		bytes := filestream contents.
		filestream close.
		basename := FileDirectory baseNameFor: filename.
		self addFromFileContents: bytes baseName: basename].
	"update so that missing text styles are created."
	self updateFromSystem.
	"clear all the logicalFonts realFonts so that embedded fonts take precedence over external ones"
	LogicalFont allInstances do:[:logFont | logFont clearRealFont]
		! !

!FreeTypeFontProvider methodsFor: 'error handling' stamp: 'tween 3/16/2007 12:04'!
failedToOpen:face from: path index: i
	face destroyHandle.
	"Transcript cr; show: 'Failed : ', path asString, '[', i asString,']'."
	"remove all cache entries for path with index >= i"
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'error handling' stamp: 'tween 7/28/2007 12:36'!
failedToOpen:face index: i
	face destroyHandle.
	"Transcript cr; show: 'Failed : ', path asString, '[', i asString,']'."
	"remove all cache entries for path with index >= i"
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'font families' stamp: 'tween 8/18/2007 14:19'!
families
	
	^tempFamilies ifNil:[families]! !

!FreeTypeFontProvider methodsFor: 'accessing' stamp: 'tween 7/15/2007 23:45'!
fileInfosByFamilyAndGroup
	"Answer a Dictionary of Dictionaries of Sets.
	familyName->familyGroupName->Set(FreeTypeFileInfo)
	
	self current fileInfosByFamilyAndGroup
	"
	| answer family group |
	answer := Dictionary new.
	"file could be in fileInfos twice?
	need to only process once, need directory precedence?"
	fileInfos do:[:info |
		family := answer at: info familyName ifAbsentPut:[Dictionary new].
		group := family at: info familyGroupName ifAbsentPut: [OrderedCollection new].
		group 
			detect:[:each| 
				each bold = info bold
				and:[ each italic = info italic
				and:[each fixedWidth = info fixedWidth
				and:[ each postscriptName = info postscriptName
				and:[each styleName = info styleName]]]]]
			ifNone:[group add: info]].
	^answer	! !

!FreeTypeFontProvider methodsFor: 'font lookup' stamp: 'tween 9/29/2007 10:48'!
fontFor: aLogicalFont familyName: familyName
	| info answer simulatedSqueakEmphasis needsSimulatedBold needsSimulatedSlant
	squeakBoldEmphasis squeakItalicEmphasis |
	
	FT2Library current == nil ifTrue:[^nil].
	info:= self fontInfoFor: aLogicalFont familyName: familyName.
	info ifNil:[^nil].
	answer := FreeTypeFont forLogicalFont: aLogicalFont fileInfo: info.
	needsSimulatedBold := aLogicalFont isBoldOrBolder and:[(info isBolderThan: 500) not].
	needsSimulatedSlant := aLogicalFont isItalicOrOblique and: [info isItalicOrOblique not].
	(needsSimulatedBold or:[needsSimulatedSlant])
		ifTrue:[
			squeakBoldEmphasis := 1.
			squeakItalicEmphasis := 2.
			simulatedSqueakEmphasis := 0.
			needsSimulatedBold 
				ifTrue:[
					simulatedSqueakEmphasis := simulatedSqueakEmphasis + squeakBoldEmphasis].
			needsSimulatedSlant 
				ifTrue:[
					simulatedSqueakEmphasis := simulatedSqueakEmphasis + squeakItalicEmphasis].
			answer simulatedEmphasis: simulatedSqueakEmphasis].
	answer face validate.
	answer face isValid ifFalse:[^nil].  "we may get this if startup causes text display BEFORE receiver has been updated from the system"
	^answer! !

!FreeTypeFontProvider methodsFor: 'font lookup' stamp: 'tween 8/27/2007 11:33'!
fontInfoFor: aLogicalFont familyName: familyName
	| family member |
	
	"use tempFileInfos if not nil, i.e. during an update" 
	"^self fontInfoFor: aLogicalFont in: (tempFileInfos ifNil:[fileInfos]) "
	family := self families at: familyName ifAbsent:[].
	family ifNil:[^nil].
	member := family 
		closestMemberWithStretchValue: aLogicalFont stretchValue 
		weightValue: aLogicalFont weightValue 
		slantValue: aLogicalFont slantValue.
	member ifNil:[^nil].
	^member fileInfo! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 4/28/2007 10:49'!
getMacOSXFontFolderPaths
	"Answer the Mac OS X font folder paths.
	This needs some FFI code, but for the time being, we guess these and omit the user fonts folder"
	
	^#('/System/Library/Fonts' '/Library/Fonts')! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 4/13/2007 08:25'!
getUnixFontFolderPaths
	"Answer the unix/linux font folder paths"
	^#('/usr/share/fonts' '/usr/local/share/fonts')! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 3/25/2007 14:48'!
getWindowsFontFolderPath
	"Answer the windows font folder path.
	This is obtained through the Windows API if FFI is present,
	otherwise it is a guess !!"
	| externalLibraryClass externalTypeClass fun buff r |
	
	externalLibraryClass := Smalltalk at: #ExternalLibraryFunction ifAbsent:[].
	externalTypeClass := Smalltalk at: #ExternalType ifAbsent:[].
	(externalLibraryClass isNil or:[externalTypeClass isNil]) 
		ifTrue:[^self guessWindowsFontFolderPath].
	fun := externalLibraryClass
		name: 'SHGetFolderPathA'
		module: 'shfolder.dll'
		callType: 1
		returnType: externalTypeClass long
		argumentTypes: {
			externalTypeClass long.
			externalTypeClass long.
			externalTypeClass long.
			externalTypeClass long.
			externalTypeClass char asPointerType}.
	buff := ByteArray new: 1024.
	[r := fun
		invokeWith: 0
		with: "CSIDL_FONTS" 16r0014
		with: 0
		with: 0
		with: buff] on: Error do: [:e |
			"will get error if ffiplugin is missing" 
			^self guessWindowsFontFolderPath].
	^(buff copyFrom: 1 to: (buff indexOf: 0) - 1) asString	! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 3/25/2007 14:25'!
guessWindowsFontFolderPath
	"Guess the location of the Windows font folder"
	| possibles d |

	possibles := Set new.
	'cdefghijklmnopqrstuvwxyz' do:[:drive |
		#('\windows\fonts' '\winnt\fonts') do:[:path |
			(d := FileDirectory on: drive asString, ':', path) exists
				ifTrue:[possibles add: d]]].
	possibles := possibles asSortedCollection: [:a :b | a directoryEntry creationTime >= b  directoryEntry creationTime].
	possibles ifNotEmpty:[^possibles first pathName].
	^nil
	
		 	
			! !

!FreeTypeFontProvider methodsFor: 'initialize-release' stamp: 'tween 8/16/2007 20:31'!
initialize
	fileInfos := OrderedCollection  new: 100.
	fileInfoCache := Dictionary new: 100. "keyed by file size" 
	embeddedFileInfoCache := Dictionary new: 10. "keyed by file size" 
	families := Array new.
	! !

!FreeTypeFontProvider methodsFor: 'loading and updating' stamp: 'tween 3/14/2007 23:17'!
loadFromSystem
	self updateFromSystem.
	! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 4/28/2007 11:09'!
platformAbsoluteDirectories
	| answer dir path |
	
	answer := OrderedCollection new.
	SmalltalkImage current platformName = 'Win32'
		ifTrue:[
			path := self getWindowsFontFolderPath.
			(path notNil and:[(dir := FileDirectory on: path) exists])
				ifTrue:[answer add: dir]].
	SmalltalkImage current platformName = 'unix'
		ifTrue:[
			self getUnixFontFolderPaths do:[:each |
				(dir := FileDirectory on: each) exists
					ifTrue:[answer add: dir]]].
	SmalltalkImage current platformName = 'Mac OS'
		ifTrue:[
			SmalltalkImage current osVersion asNumber >= 1000
				ifTrue:["OS X"
					self getMacOSXFontFolderPaths do:[:each |
						(dir := FileDirectory on: each) exists
							ifTrue:[answer add: dir]]]].
	^answer! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 3/26/2007 22:57'!
platformImageRelativeDirectories
	| answer path fontDirectory |
	
	answer := OrderedCollection new.
	(path :=  SmalltalkImage current imagePath)
		ifNotEmpty:[
			(path endsWith: FileDirectory slash) ifFalse:[path := path, FileDirectory slash].
			(fontDirectory := FileDirectory on: path, 'Fonts') exists
				ifTrue:[answer addLast: fontDirectory]].
	^answer! !

!FreeTypeFontProvider methodsFor: 'file paths' stamp: 'tween 3/26/2007 22:58'!
platformVMRelativeDirectories
	| answer path fontDirectory |
	
	answer := OrderedCollection new.
	(path :=  SmalltalkImage current vmPath)
		ifNotEmpty:[
			(path endsWith: FileDirectory slash) ifFalse:[path := path, FileDirectory slash].
			(fontDirectory := FileDirectory on: path, 'Fonts') exists
				ifTrue:[answer addLast: fontDirectory]].
	^answer! !

!FreeTypeFontProvider methodsFor: 'loading and updating' stamp: 'tween 3/29/2007 17:16'!
updateFromDirectory: aDirectory locationType: aSymbol done: aSet
	"get info from fonts in aDirectory"
	
	(aSet includes: aDirectory) ifTrue:[^self].
	aSet add: aDirectory.
	aDirectory entries do:[:each |
		each isDirectory ifFalse:[
			"SUSE 10.2 has lots of files ending .gz that aren't fonts.
			We skip them to save time'"
			((each name beginsWith:'.') or:[each name asLowercase endsWith:'.gz'])
				ifFalse:[
					self updateFromFileEntry: each directory: aDirectory  locationType: aSymbol]]].
	aDirectory entries do:[:each |
		each isDirectory ifTrue:[
			self updateFromDirectory: (aDirectory directoryNamed: each name) locationType: aSymbol done: aSet]].	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'loading and updating' stamp: 'tween 8/12/2007 12:31'!
updateFromFileEntry: aDirectoryEntry directory: aFileDirectory locationType: aSymbol
	| i face numFaces cachedInfo info cachedNumFaces path |
	"(path findString: '\\') > 0 ifTrue:[self halt]."
	i:= 0.
	[(cachedInfo := self validCachedInfoFor: aDirectoryEntry directory: aFileDirectory index: i) notNil]
		whileTrue:[
			i = 0 ifTrue:[cachedNumFaces := cachedInfo numFaces].
			self addFileInfo: cachedInfo index: i.
			i := i + 1.].
	(cachedNumFaces notNil and:[i >= cachedNumFaces]) ifTrue:[^self].
	path := aFileDirectory fullNameFor: aDirectoryEntry name .
	[face := FreeTypeFace basicNew filename: path; index:  i.
	["we use the primNewFaceFromFile:index: method because we want to do this as fast as possible and we don't need the face registered because it will be explicitly destroyed later"
	face primNewFaceFromFile: path index: i.
	face loadFields] 
		on: FT2Error 
		do:[:e | ^self failedToOpen:face from: path index: i].
	(face height notNil  and:[face hasFamilyName and:[face hasStyleName and:[face isValid]]])
		ifFalse:[^self failedToOpen:face from: path index: i]
		ifTrue:[
			numFaces isNil ifTrue:[numFaces := face numFaces].
			info :=FreeTypeFileInfo new
				absoluteOrRelativePath: (self absoluteOrRelativePathFor: path locationType: aSymbol);
				absolutePath: path; "used for quick lookup on same platform"
				locationType: aSymbol;
				index: i;
				fileSize:  aDirectoryEntry fileSize;
				modificationTime: aDirectoryEntry modificationTime;
				familyName: face familyName;
				styleName: face styleName;
				postscriptName: face postscriptName;
				bold: face isBold;
				italic: face isItalic;
				fixedWidth: face isFixedWidth;
				numFaces: numFaces;
				extractAttributesFromNames;
				yourself.
			self addFileInfo: info index: i.
			self cacheFileInfo: info index: i.
			"Transcript show: 'from file : ', info asString."
			face destroyHandle].
	i := i + 1.
	i < numFaces "note, we use < rather than <= , because i is zero based"] whileTrue:[].
	
	
		
	
	
	
			
	
	! !

!FreeTypeFontProvider methodsFor: 'loading and updating' stamp: 'tween 8/19/2007 16:57'!
updateFromSystem
	| done platformDirs vmDirs imageDirs  i |
	
	i := 0.
	tempFileInfos := fileInfos. "tempFileInfos will be used during update"
	tempFamilies := families.   "tempFamilies will be used during update"
	fileInfos := OrderedCollection  new: 100.
	'FreeType' displayProgressAt: Display center from: 0 to:  3 during:[:mainBar |
		'Updating cached file info' displayProgressAt: Display center from: 0 to:  fileInfoCache size during:[:bar |
			fileInfoCache valuesDo:[:col |
				col copy do:[:each | | dir |
					dir := FileDirectory on: (FileDirectory dirPathFor: each absolutePath).
					(dir exists not or:[(dir isAFileNamed: (dir localNameFor: each absolutePath)) not])	
						ifTrue:[col remove: each]].
			bar value: (i :=  i + 1).]].
		mainBar value: 1.
		FT2Library current == nil
			ifFalse:[
				"Add all the embedded file infos"
				embeddedFileInfoCache valuesDo:[:eachSet | 
					eachSet do:[:each | fileInfos addFirst: each]].
				done := Set new. "visited directories are tracked in done, so that they are not processed twice"
				platformDirs := self platformAbsoluteDirectories.
				vmDirs := self platformVMRelativeDirectories.
				imageDirs := self platformImageRelativeDirectories.
				i := 0.
				'Loading font files' displayProgressAt: Display center from: 0 to:  3 during:[:bar |
					imageDirs do:[:each |
						self updateFromDirectory: each locationType: #imageRelative done: done ].
					bar value: (i := i + 1).
					vmDirs do:[:each |
						self updateFromDirectory: each locationType: #vmRelative done: done ].
					bar value: (i := i + 1).
					platformDirs do:[:each |
						self updateFromDirectory: each locationType: #absolute done: done ].
					bar value: (i := i + 1) ]].
		mainBar value: 2.
		i := 0.
		'Calculating available font families' displayProgressAt: Display center from: 0 to:  1  during:[:bar |
			"self removeUnavailableTextStyles."
			"self addTextStylesWithPointSizes: #(8 10 12 15 24)."
			tempFileInfos := nil.
			self buildFamilies.
			tempFamilies := nil.			
			bar value: (i := i + 1)].
		mainBar value: 3].
	LogicalFont allInstances do:[:each | each clearRealFont]. "in case they have a bad one"
			! !

!FreeTypeFontProvider methodsFor: 'loading and updating' stamp: 'tween 3/17/2007 10:16'!
validCachedInfoFor: aDirectoryEntry directory: aFileDirectory index: i
	"answer info from cache if the file on the disk has the same size/timestamp as the cached info, otherwise answer nil"
	| cacheEntry fileSize modificationTime path|

	fileSize := aDirectoryEntry fileSize.
	modificationTime :=  aDirectoryEntry modificationTime.
	cacheEntry := (fileInfoCache at: {fileSize. i} ifAbsentPut:[Set new])
		detect:[:each |
			path := path ifNil:["only build path when needed" aFileDirectory fullNameFor: aDirectoryEntry name].
			each modificationTime = modificationTime
			and: [(self absolutePathFor: each absoluteOrRelativePath locationType: each locationType) = path]]
		ifNone:[].
	"cacheEntry ifNotNil:[Transcript cr; show: 'from cache : ', cacheEntry asString]."
	^cacheEntry
	! !

!FreeTypeFontProvider methodsFor: 'loading and updating' stamp: 'tween 7/28/2007 13:34'!
validEmbeddedCachedInfoFor: bytes index: i
	"answer info from cache if the bytes are the same as the cached info, otherwise answer nil"
	| cacheEntry fileSize |

	fileSize := bytes size.
	cacheEntry := (embeddedFileInfoCache at: {fileSize. i} ifAbsentPut:[Set new])
		detect:[:each | each fileContents = bytes]
		ifNone:[].
	^cacheEntry
	! !

Object subclass: #FreeTypeCache
	instanceVariableNames: 'maximumSize used fontTable fifo'
	classVariableNames: ''
	poolDictionaries: 'FreeTypeCacheConstants'
	category: 'FreeType-Cache'!

FreeTypeCache class
	instanceVariableNames: 'current'!

FreeTypeCache class
	instanceVariableNames: 'current'!

!FreeTypeCache class methodsFor: 'system shutdown' stamp: 'tween 8/10/2006 15:44'!
clearCacheOnShutdown
	"answer true if the cache should be cleared on image shutdown"
	
	^true! !

!FreeTypeCache class methodsFor: 'accessing' stamp: 'tween 8/10/2006 15:33'!
clearCurrent
	"
	self clearCurrent.
	"
	current := nil! !

!FreeTypeCache class methodsFor: 'accessing' stamp: 'tween 8/10/2006 17:03'!
current
	current isNil ifFalse:[^current].
	^current := self new! !

!FreeTypeCache class methodsFor: 'accessing' stamp: 'tween 8/10/2006 09:30'!
defaultMaximumSize
	"answer the default maximumSize in bytes"
	^1024*5000 "5 Megabytes"! !

!FreeTypeCache class methodsFor: 'accessing' stamp: 'tween 8/10/2006 15:45'!
initialize
	"
	self initialize.
	"
	
	Smalltalk addToShutDownList: self.  "should it be at a particular place in the list?"! !

!FreeTypeCache class methodsFor: 'accessing' stamp: 'tween 8/10/2006 15:45'!
shutDown: quitting 

	(current notNil and: [self clearCacheOnShutdown])
		ifTrue:[self current removeAll]! !

!FreeTypeCache methodsFor: 'add-remove' stamp: 'tween 8/10/2006 19:34'!
atFont: aFreeTypeFont charCode: charCodeInteger type: typeFlag 
	| entry charCodeTable typeTable |
	(charCodeTable := fontTable at: aFreeTypeFont ifAbsent:[])
		ifNotNil:[
			(typeTable := charCodeTable at: charCodeInteger ifAbsent:[])
				ifNotNil:[
					(entry := typeTable at: typeFlag ifAbsent:[])
						ifNotNil:[
							fifo moveDown: entry.
							^entry object]]].
	self error: 'Not found'! !

!FreeTypeCache methodsFor: 'add-remove' stamp: 'tween 8/10/2006 21:20'!
atFont: aFreeTypeFont charCode: charCodeInteger type: typeFlag ifAbsentPut: aBlock 
	| charCodeTable typeTable entry v vSize |
	
	charCodeTable := fontTable at: aFreeTypeFont ifAbsentPut:[self dictionaryClass new: 60].
	typeTable := charCodeTable at: charCodeInteger ifAbsentPut:[self dictionaryClass new: 10].
	entry := typeTable at: typeFlag ifAbsent:[].
	entry 
		ifNotNil:[
			fifo moveDown: entry.
			^entry object].
	v := aBlock value.
	vSize := self sizeOf: v.
	(maximumSize notNil and:[vSize > maximumSize]) 
		ifTrue:[^v].  
	used := used + vSize.
	entry := (self fifoEntryClass new
		 font: aFreeTypeFont;
		charCode: charCodeInteger;
		type: typeFlag;
		object: v;
		yourself).
	typeTable at: typeFlag put: entry.
	fifo addLast: entry.
	maximumSize ifNotNil:[self shrinkTo: maximumSize].
	^v
	! !

!FreeTypeCache methodsFor: 'add-remove' stamp: 'tween 8/10/2006 21:20'!
atFont: aFreeTypeFont charCode: charCodeInteger type: typeFlag put: anObject 
	| charCodeTable typeTable anObjectSize oldEntry oldEntrySize entry |
	
	anObjectSize := self sizeOf: anObject.
	(maximumSize notNil and:[anObjectSize > maximumSize]) 
		ifTrue:[^anObject].  
	(charCodeTable := fontTable at: aFreeTypeFont ifAbsentPut:[self dictionaryClass new: 60])
		ifNotNil:[
			(typeTable := charCodeTable at: charCodeInteger ifAbsentPut:[self dictionaryClass new: 10])
				ifNotNil:[
					oldEntry := typeTable at: typeFlag ifAbsent:[].
					oldEntrySize := (oldEntry isNil 
						ifTrue:[0] 
						ifFalse:[self sizeOf: oldEntry object]). 
					entry := (self fifoEntryClass new
						font: aFreeTypeFont;
						charCode: charCodeInteger;
						type: typeFlag;
						object: anObject;
						yourself).
					typeTable at: typeFlag put: entry]].
	used := used + anObjectSize - oldEntrySize.
	oldEntry ifNotNil: [fifo remove: oldEntry].
	fifo addLast: entry.
	maximumSize ifNotNil:[self shrinkTo: maximumSize].
	^anObject
	! !

!FreeTypeCache methodsFor: 'private' stamp: 'tween 8/10/2006 13:20'!
dictionaryClass
	^Dictionary! !

!FreeTypeCache methodsFor: 'private' stamp: 'tween 8/10/2006 19:03'!
fifoClass
	^FreeTypeCacheLinkedList! !

!FreeTypeCache methodsFor: 'private' stamp: 'tween 8/10/2006 13:22'!
fifoEntryClass
	^FreeTypeCacheEntry! !

!FreeTypeCache methodsFor: 'initialization' stamp: 'tween 8/10/2006 13:40'!
initialize
	maximumSize := self class defaultMaximumSize.
	fontTable := self dictionaryClass new: 100.
	used := 0.
	fifo := self fifoClass new
	! !

!FreeTypeCache methodsFor: 'public' stamp: 'tween 8/10/2006 12:56'!
maximumSize: anIntegerOrNil

	maximumSize := anIntegerOrNil.
	maximumSize ifNotNil:[
		used > maximumSize
			ifTrue:["shrink"
				self shrinkTo: maximumSize]]! !

!FreeTypeCache methodsFor: 'add-remove' stamp: 'tween 8/10/2006 13:40'!
removeAll
	fontTable := self dictionaryClass new: 100.
	fifo := self fifoClass new.
	used := 0.

	! !

!FreeTypeCache methodsFor: 'add-remove' stamp: 'tween 8/10/2006 15:03'!
removeAllForFont: aFreeTypeFont
	| toRemove d |
	
	(fontTable includesKey: aFreeTypeFont) ifFalse:[^self].
	toRemove := IdentitySet new.
	fifo do:[:entry |
		entry font = aFreeTypeFont
			ifTrue:[toRemove add: entry]].
	toRemove do:[:entry | 
		fifo remove: entry.
		d := (fontTable at: entry font) at: entry charCode.
		d removeKey: entry type.	
		used := used - (self sizeOf: entry object) ]. 

	! !

!FreeTypeCache methodsFor: 'add-remove' stamp: 'tween 8/10/2006 15:28'!
removeAllForType: typeFlag
	| toRemove d |
	
	toRemove := IdentitySet new.
	fifo do:[:entry |
		entry type = typeFlag
			ifTrue:[toRemove add: entry]].
	toRemove do:[:entry | 
		fifo remove: entry.
		d := (fontTable at: entry font) at: entry charCode.
		d removeKey: entry type.	
		used := used - (self sizeOf: entry object) ]. 

	! !

!FreeTypeCache methodsFor: 'public' stamp: 'tween 8/10/2006 13:46'!
report
	"answer a description of the current state of the cache"
	| usedPercent |
	usedPercent := maximumSize isNil
		ifTrue:[0]
		ifFalse:[(used * 100 / maximumSize) asFloat rounded].
	^usedPercent asString,'% Full (maximumSize: ', maximumSize asString, ' , used: ', used asString,')'! !

!FreeTypeCache methodsFor: 'private' stamp: 'tween 9/29/2007 20:10'!
shrinkTo: newSize
	"if the used size is greater than newSize, then remove all the receiver's entries"
	
	used > newSize ifTrue:[self removeAll]! !

!FreeTypeCache methodsFor: 'public' stamp: 'tween 8/10/2006 15:14'!
sizeOf: anObject
	^(anObject isKindOf: Form)
		ifTrue:[(anObject bitsSize * 4) + 32]
		ifFalse:[4]
	! !

Object subclass: #FreeTypeFileInfoAbstract
	instanceVariableNames: 'index familyName styleName postscriptName bold italic fixedWidth numFaces familyGroupName slant slantValue weight stretch weightValue stretchValue styleNameExtracted upright'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

FreeTypeFileInfoAbstract subclass: #FreeTypeEmbeddedFileInfo
	instanceVariableNames: 'fileContents baseName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!FreeTypeEmbeddedFileInfo methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:21'!
baseName
	"Answer the value of baseName"

	^ baseName! !

!FreeTypeEmbeddedFileInfo methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:19'!
baseName: anObject
	"Set the value of baseName"

	baseName := anObject! !

!FreeTypeEmbeddedFileInfo methodsFor: 'accessing' stamp: 'tween 9/29/2007 08:21'!
familyGroupName
	
	^familyGroupName
	! !

!FreeTypeEmbeddedFileInfo methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:19'!
fileContents
	"Answer the value of fileContents"

	^ fileContents! !

!FreeTypeEmbeddedFileInfo methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:19'!
fileContents: anObject
	"Set the value of fileContents"

	fileContents := anObject! !

!FreeTypeEmbeddedFileInfo methodsFor: 'accessing' stamp: 'tween 7/28/2007 12:43'!
fileSize
	^fileContents size! !

!FreeTypeEmbeddedFileInfo methodsFor: 'testing' stamp: 'tween 7/16/2007 00:31'!
isEmbedded
	^true! !

!FreeTypeEmbeddedFileInfo methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:16'!
locationType
	"Answer the value of locationType"

	^ #embedded! !

!FreeTypeEmbeddedFileInfo methodsFor: 'printing' stamp: 'tween 8/16/2007 01:08'!
printOn: aStream
	"super printOn: aStream."
	aStream 
		nextPutAll:  '{', self locationType asString,'}';
		nextPutAll: '(' , fileContents size asString, ' bytes )';
		nextPutAll: '[',index asString,'] ';
		nextPutAll: familyName asString;
		nextPutAll: ' - ', styleName asString;
		nextPutAll: ' - ', postscriptName asString;		
		nextPutAll: ' ',(bold ifTrue:['B'] ifFalse:['']);
		nextPutAll: ' ',(italic ifTrue:['I'] ifFalse:['']);
		nextPutAll: ' ',(fixedWidth ifTrue:['Monospaced'] ifFalse:['']);
		nextPutAll: ' ',(stretchValue asString);
		nextPutAll: ' ',(weightValue asString);	
		cr! !

FreeTypeFileInfoAbstract subclass: #FreeTypeFileInfo
	instanceVariableNames: 'absoluteOrRelativePath absolutePath locationType modificationTime fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/15/2007 18:29'!
absoluteOrRelativePath
	"Answer the value of absoluteOrRelativePath"

	^ absoluteOrRelativePath! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/15/2007 18:29'!
absoluteOrRelativePath: anObject
	"Set the value of absoluteOrRelativePath"

	absoluteOrRelativePath := anObject! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/16/2007 04:26'!
absolutePath
	"Answer the value of absolutePath"

	^ absolutePath! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/16/2007 04:26'!
absolutePath: anObject
	"Set the value of absolutePath"

	absolutePath := anObject! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 8/12/2007 16:53'!
baseName
	^(FileDirectory baseNameFor: (FileDirectory localNameFor: absolutePath))! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 9/29/2007 08:22'!
familyGroupName
	
	^familyGroupName! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/16/2007 00:55'!
fileSize
	"Answer the value of fileSize"

	^ fileSize! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/16/2007 00:55'!
fileSize: anObject
	"Set the value of fileSize"

	fileSize := anObject! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/15/2007 17:31'!
locationType
	"Answer the value of locationType"

	^ locationType! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/15/2007 17:31'!
locationType: anObject
	"Set the value of locationType"

	locationType := anObject! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/16/2007 01:14'!
modificationTime
	"Answer the value of modificationTime"

	^ modificationTime! !

!FreeTypeFileInfo methodsFor: 'accessing' stamp: 'tween 3/16/2007 01:14'!
modificationTime: anObject
	"Set the value of modificationTime"

	modificationTime := anObject! !

!FreeTypeFileInfo methodsFor: 'printing' stamp: 'tween 8/16/2007 01:08'!
printOn: aStream
	"super printOn: aStream."
	aStream 
		nextPutAll: familyGroupName asString, '::',styleNameExtracted asString, ' '; 
		nextPutAll:  
			(locationType = #absolute 
				ifTrue:[''] 
				ifFalse:['{',locationType asString,'}']);
		nextPutAll: absoluteOrRelativePath asString;
		nextPutAll: '[',index asString,'] ';
		nextPutAll: familyName asString;
		nextPutAll: ' - ', styleName asString;
		nextPutAll: ' - ', postscriptName asString;		
		nextPutAll: ' ',(bold ifTrue:['B'] ifFalse:['']);
		nextPutAll: ' ',(italic ifTrue:['I'] ifFalse:['']);
		nextPutAll: ' ',(fixedWidth ifTrue:['Monospaced'] ifFalse:['']);
		nextPutAll: ' ',(stretchValue asString);
		nextPutAll: ' ',(weightValue asString);	
		cr! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
bold
	"Answer the value of bold"

	^ bold! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
bold: anObject
	"Set the value of bold"

	bold := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 9/8/2007 22:34'!
extractAttributesFromNames
	"derive values for the receiver's style(italic), weight, and stretch inst vars.
	Also set the familyGroupName and styleNameExtracted"

	| p |

	p:= FreeTypeNameParser new
		familyNameIn: self validFamilyName;
		styleNameIn: self validStyleName;
		italicFlag: italic;
		boldFlag: bold;
		parse.
	familyGroupName := p familyName.
	slant := p extractedSlant.
	slantValue := p extractedSlantValue.
	weight := p extractedWeight.
	weightValue := p extractedWeightValue.
	stretch := p extractedStretch.
	stretchValue := p extractedStretchValue.
	upright := p extractedUpright.
	styleNameExtracted := ''.
	stretch ifNotNil:[
		styleNameExtracted := styleNameExtracted ,stretch].
	(weight notNil "and:[weight asLowercase ~= 'medium']") 
		ifTrue:[
			styleNameExtracted := styleNameExtracted , ' ', weight].
	slant ifNotNil:[
		styleNameExtracted := styleNameExtracted , ' ', slant].
	styleNameExtracted := styleNameExtracted withBlanksTrimmed.
	styleNameExtracted ifEmpty: [
		styleNameExtracted := upright ifNil:['Regular']].
		 
	! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
familyGroupName
	"Answer the value of familyGroupName"

	^ familyGroupName! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
familyName
	"Answer the value of familyName"

	^ familyName! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
familyName: anObject
	"Set the value of familyName"

	familyName := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
fixedWidth
	"Answer the value of fixedWidth"

	^ fixedWidth! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
fixedWidth: anObject
	"Set the value of fixedWidth"

	fixedWidth := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
index
	"Answer the value of index"

	^ index! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
index: anObject
	"Set the value of index"

	index := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 9/29/2007 10:42'!
isBolderThan: val
	^self weightValue >= val! !

!FreeTypeFileInfoAbstract methodsFor: 'testing' stamp: 'tween 7/16/2007 00:31'!
isEmbedded
	^false! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 9/29/2007 10:41'!
isItalicOrOblique
	^self slantValue > 0! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
italic
	"Answer the value of italic"

	^ italic! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
italic: anObject
	"Set the value of italic"

	italic := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
numFaces
	"Answer the value of numFaces"

	^ numFaces! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
numFaces: anObject
	"Set the value of numFaces"

	numFaces := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
postscriptName
	"Answer the value of postscriptName"

	^ postscriptName! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
postscriptName: anObject
	"Set the value of postscriptName"

	postscriptName := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:59'!
slant
	"Answer the value of slant"

	^ slant! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 21:39'!
slantValue
	^slantValue! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/11/2007 14:22'!
stretch
	"Answer the value of stretch"

	^ stretch! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 01:04'!
stretchValue
	"Answer the value of stretchValue"

	^ stretchValue! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 01:04'!
stretchValue: anObject
	"Set the value of stretchValue"

	stretchValue := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:59'!
style
	"Answer the value of slant"

	^ slant! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
styleName
	"Answer the value of styleName"

	^ styleName! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 7/16/2007 00:20'!
styleName: anObject
	"Set the value of styleName"

	styleName := anObject! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/12/2007 19:27'!
styleNameExtracted
	^styleNameExtracted! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 9/8/2007 23:23'!
styleNameWithItalicForcedToBe: aString
	| answer |
	answer := ''.
	stretch ifNotNil:[
		answer := answer ,stretch].
	(weight notNil "and:[weight asLowercase ~= 'medium']") 
		ifTrue:[
			answer := answer , ' ', weight].
	answer := answer , ' ', aString.
	answer := answer withBlanksTrimmed.
	^answer
		 
	! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 20:59'!
styleNameWithWeightForcedToBe: aString
	| answer |
	answer := ''.
	stretch ifNotNil:[
		answer := answer ,stretch].
	answer := answer , ' ', aString.
	slant ifNotNil:[
		answer := answer , ' ', slant].
	answer := answer withBlanksTrimmed.
	^answer
		 
	! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 02:31'!
styleNameWithWeightForcedToBe: aString italicForcedToBe: aString2
	| answer |
	answer := ''.
	stretch ifNotNil:[
		answer := answer ,stretch].
	answer := answer , ' ', aString.
	answer := answer , ' ', aString2.
	answer := answer withBlanksTrimmed.
	^answer
		 
	! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 9/1/2007 18:38'!
validFamilyName
	"answer the receiver's familyName, or an alternative 
	name to use if the familyName is invalid for some reason"
	
	(familyName copyWithout: $? ) 
		ifEmpty:[
			"workaround problem with FreeType 2.2.1 and MS Gothic, MS Mincho
			where familyName is not read correctly. This may be fixed in later versions
			of FreeType"
			self baseName asUppercase = 'MSGOTHIC'
				ifTrue:[
					index = 0 ifTrue:[^'MS Gothic'].
					index = 1 ifTrue:[^'MS PGothic'].
					index = 2 ifTrue:[^'MS UI Gothic']].
			self baseName asUppercase = 'MSMINCHO'
				ifTrue:[
					index = 0 ifTrue:[^'MS Mincho'].
					index = 1 ifTrue:[^'MS PMincho'].				
			^self baseName asUppercase, ' ', index asString]].
	^familyName! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/12/2007 17:06'!
validStyleName
	"answer the receiver's styleName, or an alternative 
	name to use if the styleName is invalid for some reason"
	
	| answer |
	(styleName copyWithout: $? ) 
		ifEmpty:[
			"workaround problem with FreeType 2.2.1 and MS Gothic, MS Mincho
			where familyName is not read correctly. This may be fixed in later versions
			of FreeType"
			answer := ''.
			italic ifTrue:[answer := answer , 'Italic '].
			bold ifTrue:[answer := answer, 'Bold '].
			(italic or:[bold]) not ifTrue:[answer := answer, 'Regular '].
			^answer withBlanksTrimmed].
	^styleName! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/11/2007 14:22'!
weight
	"Answer the value of weight"

	^ weight! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 01:04'!
weightValue
	"Answer the value of weightValue"

	^ weightValue! !

!FreeTypeFileInfoAbstract methodsFor: 'accessing' stamp: 'tween 8/16/2007 01:04'!
weightValue: anObject
	"Set the value of weightValue"

	weightValue := anObject! !

Object subclass: #FreeTypeGlyphRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'FT2Constants'
	category: 'FreeType-GlyphRendering'!

FreeTypeGlyphRenderer class
	instanceVariableNames: 'current'!

!FreeTypeGlyphRenderer commentStamp: 'tween 4/4/2007 09:48' prior: 0!
This class produces glyphs for a FreeTypeFont.
It can be subclassed to provide, for example, sub-pixel anti-aliased glyphs.!

FreeTypeGlyphRenderer class
	instanceVariableNames: 'current'!

!FreeTypeGlyphRenderer class methodsFor: 'instance creation' stamp: 'tween 4/4/2007 19:24'!
current
	"
	FreeTypeGlyphRenderer current
	"
	^current ifNil:[current := self new]! !

!FreeTypeGlyphRenderer class methodsFor: 'accessing' stamp: 'tween 4/4/2007 09:50'!
current: aKindOfFreeTypeGlyphRender
	current := aKindOfFreeTypeGlyphRender! !

!FreeTypeGlyphRenderer methodsFor: 'private' stamp: 'tween 4/4/2007 10:25'!
convert8To32: aGlyphForm
		"convert aGlyphForm from the 8 bit deep form produced by FreeType, where each byte represents the intensity of a single pixel, to a 32 bit deep form" 
	| w h s answer rowstart bytes word littleEndian shift v a colorVal |

	bytes := aGlyphForm bits.
	w := aGlyphForm width.
	h := aGlyphForm height.
	answer := aGlyphForm class extent: w@h depth: 32.
	answer 
		offset: (aGlyphForm offset x) @(aGlyphForm offset y);
		advance: aGlyphForm advance;
		linearAdvance: aGlyphForm linearAdvance.
	s := w + 3 >> 2.
	littleEndian := aGlyphForm isLittleEndian.
	0 to: h - 1 do: [:y |
		rowstart := (y * s)+1.
		0 to: w - 1 do:[:x | 
			word := bytes at: rowstart + (x//4).
			shift := 8* (littleEndian 
				ifTrue:[x bitAnd: 3] 
				ifFalse:[3-(x bitAnd: 3)]).
			v := word >>shift bitAnd: 16rFF.
			a := v > 0 ifTrue:[16rFF] ifFalse:[0].
			colorVal := v + (v bitShift: 8) +  (v bitShift: 16) + (a bitShift: 24).
			answer bits integerAt: (y*w)+(x+1) put: colorVal]].
	^answer! !

!FreeTypeGlyphRenderer methodsFor: 'private' stamp: 'tween 4/4/2007 21:24'!
convert8to32: aGlyphForm colorValue: foreColorValue
	"convert from the 8 bit deep form produced by FreeType, where each byte represents the intensity of a single pixel, to a 32 bit deep form with pixels of color foreColorValue " 
	| w h s answer rowstart bytes word littleEndian shift v a colorVal foreColorVal foreColorA foreColorR foreColorG foreColorB r g b |

	foreColorVal := foreColorValue.
	foreColorA := foreColorVal >> 24.
	foreColorR := foreColorVal >> 16 bitAnd: 16rFF.
	foreColorG := foreColorVal >> 8 bitAnd: 16rFF.
	foreColorB := foreColorVal bitAnd: 16rFF.
	bytes := aGlyphForm bits.
	w := aGlyphForm width.
	h := aGlyphForm height.
	answer := aGlyphForm class extent: w@h depth: 32.
	answer 
		offset: (aGlyphForm offset x) @ (aGlyphForm offset y);
		advance: aGlyphForm advance;
		linearAdvance: aGlyphForm linearAdvance.
	s := w + 3 >> 2.
	littleEndian := aGlyphForm isLittleEndian.
	0 to: h - 1 do: [:y |
		rowstart := (y * s)+1.
		0 to: w - 1 do:[:x | 
			word := bytes at: rowstart + (x//4).
			shift := 8* (littleEndian 
				ifTrue:[x bitAnd: 3] 
				ifFalse:[3-(x bitAnd: 3)]).
			v := word >>shift bitAnd: 16rFF.
			a := v > 0 ifTrue:[v * foreColorA // 16rFF] ifFalse:[0].
			r := v > 0 ifTrue:[a * foreColorR // 16rFF] ifFalse:[0].
			g := v > 0 ifTrue:[a * foreColorG // 16rFF] ifFalse:[0].
			b := v > 0 ifTrue:[a * foreColorB // 16rFF] ifFalse:[0].
			colorVal := (a bitShift: 24) + (r bitShift: 16) + (g bitShift: 8) + b.
			answer bits integerAt: (y*w)+(x+1) put: colorVal]].
	^answer! !

!FreeTypeGlyphRenderer methodsFor: 'private' stamp: 'tween 4/4/2007 10:28'!
fixBytesForMono: aGlyphForm
	"On Windows, the bits in each byte are in reverse order, and inverted.
	i.e. 2r10100000 should be 2r11111010  to display correctly.
	This needs further investigation"
	| b newB bits |
	bits := aGlyphForm bits.
	1 to: bits byteSize do:[:i |
		b := bits byteAt: i.
		newB := ((((((((b bitAnd: 2r10000000) bitShift: -7)
			bitOr: ((b bitAnd: 2r1000000) bitShift: -5))
			bitOr: ((b bitAnd: 2r100000) bitShift: -3))
			bitOr: ((b bitAnd: 2r10000) bitShift: -1))
			bitOr: ((b bitAnd: 2r1000) bitShift: 1))
			bitOr: ((b bitAnd: 2r100) bitShift: 3))
			bitOr: ((b bitAnd: 2r10) bitShift: 5))
			bitOr: ((b bitAnd: 2r1) bitShift: 7).
		bits byteAt: i put: (newB bitXor: 2r11111111)].
	^aGlyphForm! !

!FreeTypeGlyphRenderer methodsFor: 'public' stamp: 'tween 4/4/2007 10:35'!
glyphOf: aCharacter colorValue: aColorValue mono: monoBoolean subpixelPosition: sub font: aFreeTypeFont

	| f |
	f := self 
		renderGlyph: aCharacter 
		depth: (monoBoolean ifTrue:[1] ifFalse:[8]) 
		subpixelPosition: sub
		font: aFreeTypeFont.
	monoBoolean 
		ifTrue:[
			f := self fixBytesForMono: f.
			f := f asFormOfDepth: 8].
	f := self convert8to32: f colorValue: aColorValue.
	^f
	! !

!FreeTypeGlyphRenderer methodsFor: 'public' stamp: 'tween 4/4/2007 20:53'!
mode41GlyphOf: aCharacter colorValue: aColorValue mono: monoBoolean subpixelPosition: sub font: aFreeTypeFont

	| f |
	f := self 
		renderGlyph: aCharacter 
		depth: (monoBoolean ifTrue:[1] ifFalse:[8]) 
		subpixelPosition: sub 
		font: aFreeTypeFont.
	monoBoolean 
		ifTrue:[
			f := self fixBytesForMono: f.
			f := f asFormOfDepth: 32]
		ifFalse:[
			f := self convert8To32: f].
	^f! !

!FreeTypeGlyphRenderer methodsFor: 'private' stamp: 'tween 9/29/2007 09:46'!
renderGlyph: aCharacter depth: depth subpixelPosition: sub font: aFreeTypeFont
	"Glyphs are either 1 or 8 bit deep. For 32 bpp we use 8 bits, otherwise 1"
	| em form glyph charCode slant extraWidth extraHeight boldExtra offsetX offsetY s
	synthBoldStrength hintingFlags flags face |

	charCode := aCharacter asUnicode asInteger.
	(aFreeTypeFont face charmaps includes:'unic')
		ifTrue:[
			(aFreeTypeFont isSymbolFont and:[charCode >= 16r20 and: [charCode <= 16rFF ] ])
				ifTrue:[charCode := charCode + 16rF000]]
		ifFalse:[
			(aFreeTypeFont face charmaps includes:'armn')
				ifTrue:[ "select apple roman char map, and map character from unicode to mac encoding"
					aFreeTypeFont face setCharMap:'armn'.
					charCode := aCharacter squeakToMac asUnicode asInteger. "check this!!"]].
	aCharacter < $  ifTrue: ["charCode := $  asUnicode asInteger"
		^(GlyphForm extent: 0@0 depth: depth)
			advance: 0@0;
			linearAdvance: 0@0;
			offset:0@0;
			yourself ].
	em := aFreeTypeFont pixelSize.
	[face := aFreeTypeFont face.
	face setPixelWidth: em height: em.
	hintingFlags := FreeTypeSettings current hintingFlags.
	flags :=  LoadNoBitmap bitOr:( LoadIgnoreTransform bitOr: hintingFlags). 
	face loadCharacter:charCode flags: flags]
	on: FT2Error do:[:e | 
		^(GlyphForm extent: 0@0 depth: depth)
			advance: 0@0;
			linearAdvance: 0@0;
			offset:0@0;
			yourself]. 
	glyph := face glyph. 
	slant := aFreeTypeFont simulatedItalicSlant.
	extraWidth := (glyph height * slant) abs ceiling.
	synthBoldStrength := aFreeTypeFont simulatedBoldStrength.
	boldExtra := 4 * synthBoldStrength abs ceiling.
	extraWidth := extraWidth + boldExtra.
	sub > 0 ifTrue:[ extraWidth := extraWidth + 1].
	extraHeight := boldExtra.
	form := GlyphForm extent: (glyph width + extraWidth + 1)@(glyph height + extraHeight+ 1) depth: depth.
	s := (glyph height-glyph hBearingY)  * slant.
	s := s sign * (s abs ceiling). 
	offsetX := glyph hBearingX negated + s + (boldExtra // 2) .
	offsetY := glyph height - glyph hBearingY + (boldExtra//2).
	synthBoldStrength ~= 0
		ifTrue:[face emboldenOutline: synthBoldStrength].
	face transformOutlineAngle: 0 scalePoint: 1@1  slant: slant.
	face translateOutlineBy: (offsetX+(sub/64))@offsetY.
	face renderGlyphIntoForm: form.
	form offset: (glyph hBearingX - s - (boldExtra // 2) ) @ (glyph hBearingY + 1 + (boldExtra / 2) ceiling  ) negated.
	"When not hinting FreeType sets the advance to the truncated linearAdvance.
	The characters appear squashed together. Rounding is probably better, so we fix the advance here"
	aFreeTypeFont subPixelPositioned
		ifTrue:[ form advance: glyph roundedPixelLinearAdvance]
		ifFalse:[ form advance: glyph advance].
	form linearAdvance: glyph linearAdvance.
	^form! !

!FreeTypeGlyphRenderer methodsFor: 'public' stamp: 'tween 4/4/2007 19:25'!
subGlyphOf: aCharacter colorValue: aColorValue mono: monoBoolean subpixelPosition: sub font: aFreeTypeFont
	"the default renderer does not support sub-pixel anti-aliasing,
	so answer an ordinary glyph"
	^self mode41GlyphOf: aCharacter colorValue: aColorValue mono: monoBoolean subpixelPosition: sub font: aFreeTypeFont
! !

Object subclass: #FreeTypeNameParser
	instanceVariableNames: 'combinedName familyNameIn styleNameIn delimiters tokens extractedSlant extractedSlantValue extractedUpright extractedStretch extractedWeight italicFlag boldFlag extractedWeightValue extractedStretchValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

FreeTypeNameParser class
	instanceVariableNames: 'weightNames stretchNames obliqueNames normalNames italicNames'!

FreeTypeNameParser class
	instanceVariableNames: 'weightNames stretchNames obliqueNames normalNames italicNames'!

!FreeTypeNameParser class methodsFor: 'known names' stamp: 'tween 8/16/2007 02:47'!
italicAndObliqueNames
	^self italicNames, self obliqueNames! !

!FreeTypeNameParser class methodsFor: 'known names' stamp: 'tween 9/30/2007 12:44'!
italicNames
	"Answer a sequence of String tokens that indicate an italic font
	within a font family-style name"
	"
	TO RE-INITIALIZE...
	self instVarNamed: #italicNames put: nil.
	"
	italicNames ifNotNil:[^italicNames].
	^italicNames := #(
		'ita'
		'ital'
		'italic'
		'cursive'
		'kursiv').! !

!FreeTypeNameParser class methodsFor: 'known names' stamp: 'tween 9/30/2007 12:44'!
normalNames
	"Answer a sequence of String tokens that indicate a Regular
	(i.e. non-oblique, non-italic) font within a font family-style name"
	"
	TO RE-INITIALIZE...
	self instVarNamed: #normalNames put: nil.
	"
	normalNames ifNotNil:[^normalNames].
	^normalNames := #('Book' 'Normal' 'Regular' 'Roman' 'Upright').! !

!FreeTypeNameParser class methodsFor: 'known names' stamp: 'tween 9/30/2007 12:43'!
obliqueNames
	"Answer a sequence of String tokens that indicate an oblique font
	within a font family-style name"
	"
	TO RE-INITIALIZE...
	self instVarNamed: #obliqueNames put: nil.
	"
	obliqueNames ifNotNil:[^obliqueNames].
	^obliqueNames := #(
		'inclined'
		'oblique'
		'backslanted'
		'backslant'
		'slanted').! !

!FreeTypeNameParser class methodsFor: 'known names' stamp: 'tween 9/30/2007 12:42'!
stretchNames
	"Answer a sequence of arrays.
	Each array has an integer stretch value as its first element (1 - 9).
	The remaining elements are String tokens which might appear
	within a font family-style name"
	"
	TO RE-INITIALIZE...
	self instVarNamed: #stretchNames put: nil.
	"
	stretchNames ifNotNil:[^stretchNames].
	^stretchNames := {
		{LogicalFont stretchExtraCompressed. 'extra'. 'compressed'}.
		{LogicalFont stretchExtraCompressed. 'extracompressed'}.
		{LogicalFont stretchExtraCompressed. 'ext'. 'compressed'}.
		{LogicalFont stretchExtraCompressed. 'extcompressed'}.
		{LogicalFont stretchUltraCompressed. 'ultra'. 'compressed'}.
		{LogicalFont stretchUltraCompressed. 'ultracompressed'}.
		{LogicalFont stretchUltraCondensed. 'ultra'. 'condensed'}.
		{LogicalFont stretchUltraCondensed. 'ultracondensed'}.
		{LogicalFont stretchUltraCondensed. 'ultra'. 'cond'}.
		{LogicalFont stretchUltraCondensed. 'ultracond'}.
		{LogicalFont stretchCompressed. 'compressed'}.
		{LogicalFont stretchExtraCondensed. 'extra'. 'condensed'}.
		{LogicalFont stretchExtraCondensed. 'extracondensed'}.
		{LogicalFont stretchExtraCondensed. 'ext'. 'condensed'}.
		{LogicalFont stretchExtraCondensed. 'extcondensed'}.
		{LogicalFont stretchExtraCondensed. 'extra'. 'cond'}.
		{LogicalFont stretchExtraCondensed. 'extracond'}.
		{LogicalFont stretchExtraCondensed. 'ext'. 'cond'}.
		{LogicalFont stretchExtraCondensed. 'extcond'}.
		{LogicalFont stretchNarrow. 'narrow'}.
		{LogicalFont stretchCompact. 'compact'}.
		{LogicalFont stretchSemiCondensed. 'semi'. 'condensed'}.
		{LogicalFont stretchSemiCondensed. 'semicondensed'}.
		{LogicalFont stretchSemiCondensed. 'semi'. 'cond'}.
		{LogicalFont stretchSemiCondensed. 'semicond'}.
		{LogicalFont stretchWide. 'wide'}.
		{LogicalFont stretchSemiExpanded. 'semi'. 'expanded'}.
		{LogicalFont stretchSemiExpanded. 'semiexpanded'}.
		{LogicalFont stretchSemiExtended. 'semi'. 'extended'}.
		{LogicalFont stretchSemiExtended. 'semiextended'}.
		{LogicalFont stretchExtraExpanded. 'extra'. 'expanded'}.
		{LogicalFont stretchExtraExpanded. 'extraexpanded'}.
		{LogicalFont stretchExtraExpanded. 'ext'. 'expanded'}.
		{LogicalFont stretchExtraExpanded. 'extexpanded'}.
		{LogicalFont stretchExtraExtended. 'extra'. 'extended'}.
		{LogicalFont stretchExtraExtended. 'extraextended'}.
		{LogicalFont stretchExtraExtended. 'ext'. 'extended'}.
		{LogicalFont stretchExtraExtended. 'extextended'}.
		{LogicalFont stretchUltraExpanded. 'ultra'. 'expanded'}.
		{LogicalFont stretchUltraExpanded. 'ultraexpanded'}.
		{LogicalFont stretchUltraExtended. 'ultra'. 'extended'}.
		{LogicalFont stretchUltraExtended. 'ultraextended'}.
		{LogicalFont stretchCondensed. 'condensed'}.
		{LogicalFont stretchCondensed. 'cond'}.
		{LogicalFont stretchExpanded. 'expanded'}.
		{LogicalFont stretchExtended. 'extended'}	
		}.  "search for them in the order given here"
! !

!FreeTypeNameParser class methodsFor: 'known names' stamp: 'tween 9/30/2007 12:41'!
weightNames
	"Answer a sequence of arrays.
	Each array has an integer weight value as its first element.
	The remaining elements are String tokens which might appear
	within a font family-style name"
	"
	TO RE-INITIALIZE...
	self instVarNamed: #weightNames put: nil.
	"
	weightNames ifNotNil:[^weightNames].
	^weightNames := {
		{LogicalFont weightExtraThin. 'extra'. 'thin'}.
		{LogicalFont weightExtraThin.'extrathin'}.
		{LogicalFont weightExtraThin. 'ext'. 'thin'}.
		{LogicalFont weightExtraThin. 'extthin'}.
		{LogicalFont weightUltraThin.'ultra'. 'thin'}.
		{LogicalFont weightUltraThin.'ultrathin'}.
		{LogicalFont weightExtraLight. 'extra'. 'light'}.
		{LogicalFont weightExtraLight. 'extralight'}.
		{LogicalFont weightExtraLight. 'ext'. 'light'}.
		{LogicalFont weightExtraLight. 'extlight'}.
		{LogicalFont weightUltraLight. 'ultra'. 'light'}.
		{LogicalFont weightUltraLight. 'ultralight'}.
		{LogicalFont weightSemiBold. 'semi'. 'bold'}.
		{LogicalFont weightSemiBold. 'semibold'}.
		{LogicalFont weightDemiBold. 'demi'. 'bold'}.
		{LogicalFont weightDemiBold. 'demibold'}.
		{LogicalFont weightExtraBold. 'extra'. 'bold'}.
		{LogicalFont weightExtraBold. 'extrabold'}.
		{LogicalFont weightExtraBold. 'ext'. 'bold'}.
		{LogicalFont weightExtraBold. 'extbold'}. 
		{LogicalFont weightUltraBold. 'ultra'. 'bold'}.
		{LogicalFont weightUltraBold. 'ultrabold'}.
		{LogicalFont weightExtraBlack. 'extra'. 'black'}.
		{LogicalFont weightExtraBlack. 'extrablack'}.
		{LogicalFont weightExtraBlack. 'ext'. 'black'}.
		{LogicalFont weightExtraBlack. 'extblack'}.
		{LogicalFont weightUltraBlack.'ultra'. 'black'}.
		{LogicalFont weightUltraBlack. 'ultrablack'}.
		{LogicalFont weightBold. 'bold'}.
		{LogicalFont weightThin.'thin'}.
		{LogicalFont weightLight. 'light'}.
		{LogicalFont weightMedium. 'medium'}.
		{LogicalFont weightBlack. 'black'}.
		{LogicalFont weightHeavy. 'heavy'}.
		{LogicalFont weightNord. 'nord'}.
		{LogicalFont weightDemi. 'demi'}.
		{LogicalFont weightUltra. 'ultra'}.
		} 
			! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 8/13/2007 23:02'!
addStyleNameToCombinedName: aStyleString
	| lcCombined lcStyleName addStyle index |
	lcCombined := combinedName asLowercase.
	lcStyleName := aStyleString asLowercase.
	addStyle := true.
	(index := lcCombined findString: lcStyleName) > 0
		ifTrue:[ 
			(index = 1 or:[delimiters includes: (lcCombined at: index - 1)])
				ifTrue:[
					((index + lcStyleName size > lcCombined size) or:[ delimiters includes: (lcCombined at: index + lcStyleName size) ])
						ifTrue:["don't add the style to the combinedName, because it already contains it"
							addStyle := false]]].
	addStyle ifTrue:[combinedName := combinedName , ' ', aStyleString].
	! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/12/2007 20:14'!
boldFlag: aBoolean
	boldFlag := aBoolean! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 9/29/2007 12:03'!
extractSlant

	|  matches start end |

	"match and remove last italic/oblique token"
	extractedSlant := nil.
	extractedSlantValue := LogicalFont slantRegular. "not italic or oblique"
	(self italicAndObliqueNames 
		detect: [:each |
			(matches := self lastMatchValueSequence: {each}) notNil]
		ifNone:[]) ifNotNil:[
			start := matches first second.
			end :=  matches last third.
			extractedSlant := combinedName copyFrom: start to: end.
			"extractedSlantValue := (self italicNames includes: extractedSlant asLowercase)
				ifTrue:[1]
				ifFalse:[2]."
			extractedSlantValue := LogicalFont slantItalic. "treat italic and oblique the same, as italic"
			[start > 1 and:[delimiters includes: (combinedName at: start - 1)]] "also remove delimiters before token"
				whileTrue:[start := start - 1].
			[end < combinedName size and:[delimiters includes: (combinedName at: end + 1)]] "also remove delimiters after token"
				whileTrue:[end := end + 1].		
			combinedName := combinedName copyReplaceFrom: start to: end with: ' '.].
	(extractedSlant isNil and:[italicFlag])
		ifTrue:["no italic specified in familyName or styleName; force it to be 'Italic'"
			extractedSlant := 'Italic'.
			extractedSlantValue := LogicalFont slantItalic]		! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 9/29/2007 12:35'!
extractStretch
	"match and remove last stretch tokens"
	| matches start end |

	extractedStretchValue := LogicalFont stretchRegular.
	(self stretchNames 
		detect: [:each |
			matches := self lastMatchValueSequence: each allButFirst.
			matches ifNotNil:[extractedStretchValue := each first].
			matches notNil]
		ifNone:[]) ifNotNil:[
			start := matches first second.
			end :=  matches last third.
			extractedStretch := combinedName copyFrom: start to: end.
			[start > 1 and:[delimiters includes: (combinedName at: start - 1)]] "also remove delimiters before token"
				whileTrue:[start := start - 1].
			[end < combinedName size and:[delimiters includes: (combinedName at: end + 1)]] "also remove delimiters after token"
				whileTrue:[end := end + 1].		
			combinedName := combinedName copyReplaceFrom: start to: end with: ' '.
			"re-tokenize"
			"tokens := self tokenize: combinedName delimiters: delimiters"].	! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 8/14/2007 22:01'!
extractUpright
	"extract from current combined name.
	answer new combinedName"
	| normalTok start end | 

	normalTok := tokens reversed 
		detect: [:tok | 
			(self normalNames 
				detect: [:str | str asLowercase = tok first asLowercase] 
				ifNone:[]) notNil ]
		ifNone:[].
	normalTok ifNotNil:[
		"remove it from combinedName"
		start := normalTok second.
		end :=  normalTok third.
		extractedUpright := combinedName copyFrom: start to: end.
		[start > 1 and:[delimiters includes: (combinedName at: start - 1)]]
			whileTrue:[start := start - 1].
		[end < combinedName size and:[delimiters includes: (combinedName at: end + 1)]]
			whileTrue:[end := end + 1].		
		combinedName := combinedName copyReplaceFrom: start to: end with: ' '].

	! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 9/29/2007 12:34'!
extractWeight
	"match and remove last weight tokens"
	| matches start end |

	extractedWeightValue := LogicalFont weightRegular.
	(self weightNames 
		detect: [:each |
			matches := self lastMatchValueSequence: each allButFirst.
			matches ifNotNil:[extractedWeightValue := each first].
			matches notNil]
		ifNone:[]) ifNotNil:[
			start := matches first second.
			end :=  matches last third.
			extractedWeight := combinedName copyFrom: start to: end.
			[start > 1 and:[delimiters includes: (combinedName at: start - 1)]] "also remove delimiters before token"
				whileTrue:[start := start - 1].
			[end < combinedName size and:[delimiters includes: (combinedName at: end + 1)]] "also remove delimiters after token"
				whileTrue:[end := end + 1].		
			combinedName := combinedName copyReplaceFrom: start to: end with: ' '.].	
	(extractedWeight isNil and:[boldFlag])
		ifTrue:["no weight specified in familyName or styleName; force it to be 'Bold'"
			extractedWeight := 'Bold'.
			extractedWeightValue := LogicalFont weightBold]	! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/16/2007 21:32'!
extractedSlant
	^extractedSlant! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/16/2007 21:33'!
extractedSlantValue
	^extractedSlantValue! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/12/2007 12:29'!
extractedStretch
	^extractedStretch! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/16/2007 00:55'!
extractedStretchValue
	^extractedStretchValue! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/16/2007 01:16'!
extractedUpright
	^extractedUpright! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/12/2007 12:29'!
extractedWeight
	^extractedWeight! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/16/2007 00:55'!
extractedWeightValue
	^extractedWeightValue! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/12/2007 00:14'!
familyName
	^combinedName withBlanksTrimmed! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/11/2007 18:06'!
familyName: familyName
	familyNameIn := familyName.

	! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/11/2007 23:39'!
familyNameIn: familyName
	familyNameIn := familyName.

	! !

!FreeTypeNameParser methodsFor: 'initialize-release' stamp: 'tween 8/14/2007 22:01'!
initialize
	delimiters := ',.-_'.
	Character separators do:[:c | delimiters := delimiters , c asString].
! !

!FreeTypeNameParser methodsFor: 'known names' stamp: 'tween 8/16/2007 02:54'!
italicAndObliqueNames
	^self class italicAndObliqueNames! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/12/2007 20:14'!
italicFlag: aBoolean
	italicFlag := aBoolean! !

!FreeTypeNameParser methodsFor: 'known names' stamp: 'tween 8/16/2007 02:12'!
italicNames
	^self class italicNames! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 8/11/2007 18:23'!
lastMatchValueSequence: values
	"answer the last contiguous tokens that match pattern tokens, 
	or nil if not found.
	matching is case insensitive "
	| answer  nullToken match tok |
	nullToken := {''. nil. nil}.
	tokens size - values size + 1 to: 1 by: -1 do:[:ti |
		match := true.
		answer := Array new.
		1 to: values size do:[:vi |
			tok := tokens at: ti + vi - 1 ifAbsent: [nullToken].
			(match and: [tok first asLowercase = ( values at: vi) asLowercase])
				ifFalse:[match := false]
				ifTrue:[answer := answer, {tok} ]].
		match ifTrue:[^answer]].
	^nil
			
! !

!FreeTypeNameParser methodsFor: 'known names' stamp: 'tween 8/25/2007 13:28'!
normalNames
	^self class normalNames
! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 8/16/2007 21:32'!
parse

	| styleName |
	styleNameIn := self splitBadTokensIn: styleNameIn.
	combinedName := styleNameIn withBlanksTrimmed.
	tokens := self tokenize: combinedName.
	self extractUpright.
	styleName := combinedName.
	combinedName := familyNameIn withBlanksTrimmed.
	self addStyleNameToCombinedName: styleName..
	tokens := self tokenize: combinedName.
	self extractSlant.
	tokens := self tokenize: combinedName.
	self extractStretch.
	tokens := self tokenize: combinedName.
	self extractWeight.
	! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 8/14/2007 22:11'!
splitBadTokensIn: aString
	"split tokens such as BoldOblique, that should be two words"
	| i str |
	str := aString.
	#(	('bold' 'oblique') ('bold' 'italic')
	) do:[:pair |
		(i := str asLowercase findString: pair first, pair second startingAt: 1) > 0
			ifTrue:[
				str := (str first: i + pair first size - 1), ' ', (str last: (str size - (i + pair first size - 1)))]].
	^str! !

!FreeTypeNameParser methodsFor: 'known names' stamp: 'tween 9/29/2007 11:41'!
stretchNames
	^self class stretchNames! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/11/2007 18:06'!
styleName: styleName
	
	styleNameIn := styleName. 
! !

!FreeTypeNameParser methodsFor: 'accessing' stamp: 'tween 8/11/2007 23:39'!
styleNameIn: styleName
	
	styleNameIn := styleName. 
! !

!FreeTypeNameParser methodsFor: 'parsing' stamp: 'tween 8/11/2007 18:08'!
tokenize: aString 
	"answer an OrderedCollection of {string. start. end} tuples.
	tokens are separated by $- $_ $, $. and whitespace"
	| tokens answer start |
	
	tokens := aString findTokens: delimiters keep: delimiters.
	answer := OrderedCollection new.
	start := 1.
	tokens do:[:tok |
		(delimiters includes: tok first)
			ifFalse:[answer add: {tok. start. start+tok size - 1}].
		start := start + tok size].
	^answer! !

!FreeTypeNameParser methodsFor: 'known names' stamp: 'tween 9/29/2007 11:41'!
weightNames
	^self class weightNames
			! !

Object subclass: #FreeTypeSettings
	instanceVariableNames: 'gamma hinting lightHinting subPixelAntiAliasing forceAutoHinting lcdHinting lcdvHinting monoHinting bitBltSubPixelAvailable subPixelFilters forceNonSubPixelCount gammaTable gammaInverseTable'
	classVariableNames: ''
	poolDictionaries: 'FT2Constants FreeTypeCacheConstants'
	category: 'FreeType-Settings'!

FreeTypeSettings class
	instanceVariableNames: 'current'!

FreeTypeSettings class
	instanceVariableNames: 'current'!

!FreeTypeSettings class methodsFor: 'preferences notifications' stamp: 'tween 3/30/2007 19:06'!
FreeTypeCacheSizePreferenceChanged
	FreeTypeCache current 
		maximumSize: Preferences FreeTypeCacheSize * 1024
	! !

!FreeTypeSettings class methodsFor: 'preferences notifications' stamp: 'tween 3/30/2007 18:50'!
GlyphContrastPreferenceChanged
	self current glyphContrastPreferenceChanged
		
	! !

!FreeTypeSettings class methodsFor: 'preferences notifications' stamp: 'tween 3/30/2007 18:10'!
HintingFullPreferenceChanged
	self current hintingFullPreferenceChanged
		
	! !

!FreeTypeSettings class methodsFor: 'preferences notifications' stamp: 'tween 3/30/2007 18:10'!
HintingLightPreferenceChanged
	self current hintingLightPreferenceChanged
		
	! !

!FreeTypeSettings class methodsFor: 'preferences notifications' stamp: 'tween 3/30/2007 18:10'!
HintingNonePreferenceChanged
	self current hintingNonePreferenceChanged
		
	! !

!FreeTypeSettings class methodsFor: 'preferences notifications' stamp: 'tween 7/15/2007 22:35'!
HintingNormalPreferenceChanged
	self current hintingNormalPreferenceChanged
		
	! !

!FreeTypeSettings class methodsFor: 'preferences notifications' stamp: 'tween 3/30/2007 18:10'!
MonitorTypeCRTPreferenceChanged
	self current monitorTypeCRTPreferenceChanged
		
	! !

!FreeTypeSettings class methodsFor: 'preferences notifications' stamp: 'tween 3/30/2007 18:10'!
MonitorTypeLCDPreferenceChanged
	self current monitorTypeLCDPreferenceChanged
		
	! !

!FreeTypeSettings class methodsFor: 'instance creation' stamp: 'tween 3/30/2007 17:54'!
current
	current == nil ifFalse:[^current].
	^current := self new! !

!FreeTypeSettings class methodsFor: 'class initialization' stamp: 'tween 8/31/2007 17:58'!
initialize
	"
	self initialize
	"
	Smalltalk removeFromStartUpList: self.
	Smalltalk addToStartUpList: self . 
	Smalltalk removeFromShutDownList: self.
	Smalltalk addToShutDownList: self.
	self initializePreferences! !

!FreeTypeSettings class methodsFor: 'class initialization' stamp: 'tween 3/2/2008 18:42'!
initializePreferences
	"create preferences for all my settings if they are missing
	self initializePreferences
	"

	Preferences
		addBooleanPreference: #HintingFull
		categories: {'FreeType'}
		default: false
		balloonHelp: 'Changes glyph shapes so that their features are snapped to pixel boundaries. Glyphs are monochrome, with no anti-aliasing. This option changes the shapes the most.'
		projectLocal: false
		changeInformee: self
		changeSelector: #HintingFullPreferenceChanged.
	Preferences
		addBooleanPreference: #HintingNormal
		categories: {'FreeType'}
		default: false
		balloonHelp: 'Changes glyph shapes so that their features are snapped to pixel boundaries. Glyphs are anti-aliased'
		projectLocal: false
		changeInformee: self
		changeSelector: #HintingNormalPreferenceChanged.
	Preferences
		addBooleanPreference: #HintingLight
		categories: {'FreeType'}
		default: true
		balloonHelp: 'Changes glyph shapes so that their features are partially snapped to pixel boundaries. This option changes the shapes less than HintingFull, resulting in better shapes, but less contrast.'
		projectLocal: false
		changeInformee: self
		changeSelector: #HintingLightPreferenceChanged.
	Preferences
		addBooleanPreference: #HintingNone
		categories: {'FreeType'}
		default: false
		balloonHelp: 'Uses the original glyph shapes without snapping their features to pixel boundaries. This gives the best shapes, but with less contrast and more fuzziness.'
		projectLocal: false
		changeInformee: self
		changeSelector: #HintingNonePreferenceChanged.
	Preferences
		addPreference: #GlyphContrast
		categories: {'FreeType'}
		default: 50
		balloonHelp: 'Change the contrast level for glyphs. This is an integer between 1 and 100. (the default value is 50)'
		projectLocal: false
		changeInformee: self
		changeSelector: #GlyphContrastPreferenceChanged
		viewRegistry: (Smalltalk at: #PreferenceViewRegistry ifPresent:[:c | c ofNumericPreferences])  .
	Preferences
		addPreference: #FreeTypeCacheSize
		categories: {'FreeType'}
		default: 5000
		balloonHelp: 'The size of the cache in KBytes (default is 5000K)'
		projectLocal: false
		changeInformee: self
		changeSelector: #FreeTypeCacheSizePreferenceChanged
		viewRegistry:  (Smalltalk at: #PreferenceViewRegistry ifPresent:[:c | c ofNumericPreferences]) ! !

!FreeTypeSettings class methodsFor: 'shutdown' stamp: 'tween 8/31/2007 18:00'!
shutDown: quitting 
	self current clearBitBltSubPixelAvailable.
	self current clearForceNonSubPixelCount! !

!FreeTypeSettings class methodsFor: 'startup' stamp: 'tween 3/30/2007 18:03'!
startUp: resuming
	resuming 
		ifTrue:[
			self current 
				clearBitBltSubPixelAvailable;
				clearForceNonSubPixelCount]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 4/5/2007 08:17'!
bitBltSubPixelAvailable	
	"Answer true if the the subPixel combination rule is available, false otherwise.
	to test :-
	
	bitBltSubPixelAvailable := false. 
	FreeTypeCache current removeAll.
	Smalltalk isMorphic
		ifTrue:[World restoreMorphicDisplay]
		
	"
	
	| form bitBlt color |
	bitBltSubPixelAvailable == nil ifFalse:[^bitBltSubPixelAvailable].
	form := Form extent: 10@10 depth: 32.
	bitBlt := GrafPort toForm: form.
	bitBlt combinationRule: 41.
	bitBlt sourceForm: (Form extent: 5@5 depth: 32).
	bitBlt destOrigin: 1@1.
	bitBlt width: 5; height: 5.
	color := Color black asNontranslucentColor pixelValueForDepth: 32.
	[bitBlt 
		copyBitsColor: (color bitAnd: 16rFFFFFF)
		alpha: (color bitAnd: 16rFF000000) >> 24 
		gammaTable: nil
		ungammaTable: nil]
	on: Error do:[:e | ^bitBltSubPixelAvailable := false].
	#toDo. "need to check that rule 41 has done the right thing, and isn't someone elses new BitBlt rule"
	^bitBltSubPixelAvailable := true
	! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:04'!
clearBitBltSubPixelAvailable	
	
	bitBltSubPixelAvailable := nil.! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:03'!
clearForceNonSubPixelCount
	
	forceNonSubPixelCount := nil. ! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:12'!
defaultSubPixelFilterRatios
	^#((1 3 5 3 1) (1 3 5 3 1) (1 3 5 3 1))! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:12'!
forceAutoHinting
	^forceAutoHinting ifNil:[forceAutoHinting := false]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:13'!
forceNonSubPixelCount
	^forceNonSubPixelCount ifNil:[forceNonSubPixelCount := 0]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:13'!
forceNonSubPixelDuring: aBlock
	forceNonSubPixelCount ifNil:[forceNonSubPixelCount := 0].
	forceNonSubPixelCount := forceNonSubPixelCount + 1.
	aBlock ensure:[forceNonSubPixelCount := forceNonSubPixelCount - 1]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:13'!
gamma
	^gamma ifNil:[gamma := 1.0]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:25'!
gammaInverseTable
	^gammaInverseTable! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:25'!
gammaTable
	^gammaTable! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/29/2008 10:42'!
glyphContrastPreferenceChanged
	" value between 1 and 100.
	100 is highest contrast and maps to gamma 0.25
	1 is lowest contrast and maps to gamma 2.22"
	| v g |
	v := (((Preferences GlyphContrast asNumber) min: 100) max: 1) asFloat.
	(v closeTo: 50.0) 
		ifTrue:[g := 1.0]
		ifFalse:[
			g := ((100 - v)+50/100.0) raisedTo: 2].
	self setGamma: g.
	World restoreMorphicDisplay.
! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:13'!
hinting
	^hinting ifNil:[hinting := true]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:15'!
hintingFlags
	| answer |
	answer := 0. 	
	self hinting 
		ifTrue:[
			self forceAutoHinting ifTrue:[answer := answer bitOr: 32 "forceAutoHinting"].	
			self lightHinting ifTrue:[answer := answer bitOr: LoadTargetLight].
			self monoHinting ifTrue:[answer := answer bitOr: LoadTargetMono].
			self lcdHinting ifTrue:[answer := answer bitOr: LoadTargetLCD].
			self lcdvHinting ifTrue:[answer := answer bitOr: LoadTargetLCDV]]
		ifFalse:[answer := 2 "no hinting"].
	^answer! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/29/2008 10:42'!
hintingFullPreferenceChanged
	Preferences HintingFull
		ifTrue:[Preferences disable: #HintingNone; disable: #HintingLight; disable: #HintingNormal]
		ifFalse:[
			(Preferences HintingNone or:[Preferences HintingLight or:[Preferences HintingNormal]])
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #HintingFull]].
	monoHinting := Preferences HintingFull.
	lightHinting := Preferences HintingLight.
	hinting := monoHinting or:[lightHinting or:[Preferences HintingNormal]].
	FreeTypeCache current removeAll.
	FreeTypeFont allSubInstances do:[:each | each clearCachedMetrics].
	NewParagraph allSubInstances do:[:each | each composeAll].
	World restoreMorphicDisplay.

! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/29/2008 10:42'!
hintingLightPreferenceChanged
	Preferences HintingLight
		ifTrue:[Preferences disable: #HintingFull; disable: #HintingNone; disable: #HintingNormal]
		ifFalse:[
			(Preferences HintingFull or:[Preferences HintingNone or:[Preferences HintingNormal]])
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #HintingLight]].
	monoHinting := Preferences HintingFull.
	lightHinting := Preferences HintingLight.
	hinting := monoHinting or:[lightHinting or:[Preferences HintingNormal]].
	FreeTypeCache current removeAll.
	FreeTypeFont allSubInstances do:[:each | each clearCachedMetrics].
	NewParagraph allSubInstances do:[:each | each composeAll].
	World restoreMorphicDisplay.
! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/29/2008 10:42'!
hintingNonePreferenceChanged
	Preferences HintingNone
		ifTrue:[Preferences disable: #HintingFull; disable: #HintingLight; disable: #HintingNormal]
		ifFalse:[
			(Preferences HintingFull or:[Preferences HintingLight or:[Preferences HintingNormal]])
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #HintingNone]].
	monoHinting := Preferences HintingFull.
	lightHinting := Preferences HintingLight.
	hinting := monoHinting or:[lightHinting or:[Preferences HintingNormal]].
	FreeTypeCache current removeAll.
	FreeTypeFont allSubInstances do:[:each | each clearCachedMetrics].
	NewParagraph allSubInstances do:[:each | each composeAll].
	World restoreMorphicDisplay.! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/29/2008 10:43'!
hintingNormalPreferenceChanged
	Preferences HintingNormal
		ifTrue:[Preferences disable: #HintingNone; disable: #HintingLight; disable: #HintingFull ]
		ifFalse:[
			(Preferences HintingNone or:[Preferences HintingLight or:[Preferences HintingFull]])
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #HintingNormal]].
	monoHinting := Preferences HintingFull.
	lightHinting := Preferences HintingLight.
	hinting := monoHinting or:[lightHinting or:[Preferences HintingNormal]].
	FreeTypeCache current removeAll.
	FreeTypeFont allSubInstances do:[:each | each clearCachedMetrics].
	NewParagraph allSubInstances do:[:each | each composeAll].
	World restoreMorphicDisplay.

! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:15'!
lcdHinting
	^lcdHinting ifNil:[lcdHinting := false]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:15'!
lcdvHinting
	^lcdvHinting ifNil:[lcdvHinting := false]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:16'!
lightHinting
	^lightHinting ifNil:[lightHinting := true]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/29/2008 10:43'!
monitorTypeCRTPreferenceChanged
	Preferences MonitorTypeCRT
		ifTrue:[Preferences disable: #MonitorTypeLCD]
		ifFalse:[
			Preferences MonitorTypeLCD
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #MonitorTypeCRT]].
	subPixelAntiAliasing := Preferences MonitorTypeLCD.
	World restoreMorphicDisplay.
	! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/25/2008 15:22'!
monitorTypeLCDPreferenceChanged
	Preferences MonitorTypeLCD
		ifTrue:[Preferences disable: #MonitorTypeCRT]
		ifFalse:[
			Preferences MonitorTypeCRT
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #MonitorTypeLCD]].
	subPixelAntiAliasing := Preferences MonitorTypeLCD.
	World restoreMorphicDisplay.! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:17'!
monoHinting
	^monoHinting ifNil:[monoHinting := false]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 4/2/2007 23:29'!
pretendBitBltSubPixelUnavailableDuring: aBlock	
	"
	For testing/profiling only. 
	
	Answer true if the the subPixel combination rule is available, false otherwise.
	to test :-
	
	bitBltSubPixelAvailable := false. 
	FreeTypeCache current removeAll.
	Smalltalk isMorphic
		ifTrue:[World restoreMorphicDisplay]
		
	"
	| old |
	old := bitBltSubPixelAvailable.
	[bitBltSubPixelAvailable := false.
	FreeTypeCache current removeAll.
	aBlock value.
	] ensure:[
		bitBltSubPixelAvailable := old.
		FreeTypeCache current removeAll.]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/29/2008 10:41'!
setGamma: aFloat

	(aFloat closeTo: self gamma)
		ifFalse:[
			gamma := aFloat.
			(gamma closeTo: 1.0)
				ifTrue:[gammaTable := gammaInverseTable := nil]
				ifFalse:[
					gammaTable := ByteArray new: 256.
					gammaInverseTable := ByteArray new: 256.
					0 to: 255 do:[:i |
						| g ug |
						g := ((i / 255.0) raisedTo: (1.0/gamma)) * 255.
						ug := ((i / 255.0) raisedTo: gamma) * 255.
						g := (g rounded min: 255) max: 0 .
						ug := (ug rounded min: 255) max: 0 .
						gammaTable at: i + 1 put: g.
						gammaInverseTable at: i + 1 put: ug]].
				World restoreMorphicDisplay]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'marcus.denker 11/29/2008 10:43'!
setSubPixelFilter: ratiosArray
	"Set the subPixelFilters from ratiosArray.
	the ratiosArray can specify the red, green, and blue filter ratios separately.
	e.g. #((1 3 5 3 1) (1 4 7 4 1) (1 2 3 2 1))
	or, as single set of ratios e.g. #(1 3 5 3 1)" 
	
	| validArray newFilters |
	validArray := ratiosArray.
	(ratiosArray size = 5)
		ifTrue:[validArray := {ratiosArray. ratiosArray. ratiosArray}].
	newFilters := self subPixelFiltersFromRatios: validArray. 
	(newFilters = subPixelFilters)
		ifFalse:[
			subPixelFilters := newFilters.
			FreeTypeCache current removeAllForType: FreeTypeCacheGlyphLCD.
			World restoreMorphicDisplay]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:20'!
subPixelAntiAliasing
	self bitBltSubPixelAvailable ifFalse:[^false].
	self forceNonSubPixelCount > 0 ifTrue:[^false].
	^subPixelAntiAliasing ifNil:[false]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:22'!
subPixelFilters
	^subPixelFilters ifNil:[subPixelFilters := self subPixelFiltersFromRatios: self defaultSubPixelFilterRatios]! !

!FreeTypeSettings methodsFor: 'accessing' stamp: 'tween 3/30/2007 18:22'!
subPixelFiltersFromRatios: anArray
	"Convert the ratios in anArray to a similar array containing the filter proportions as floats.
	Example:
	if <array3ofArrays5> = #((1 3 5 3 1) (1 3 5 3 1) (1 3 5 3 1))
	Then the answer is #(#(0.0769230769230769 0.2307692307692308 0.3846153846153846 0.2307692307692308 0.0769230769230769) #(0.0769230769230769 0.2307692307692308 0.3846153846153846 0.2307692307692308 0.0769230769230769) #(0.0769230769230769 0.2307692307692308 0.3846153846153846 0.2307692307692308 0.0769230769230769))"
	
	| r g b rRatios gRatios bRatios rsum gsum bsum rfilter gfilter bfilter blurR blurG blurB |
		
	r := "Color red luminance" 1.0 .
	g := "Color green luminance" 1.0 .
	b := "Color blue luminance"1.0 .
	blurR :=  anArray first.
	blurG := anArray second.
	blurB := anArray third.
	rRatios := blurR collect:[:i | r*i].
	gRatios := blurG collect:[:i | g*i].
	bRatios := blurB collect:[:i | b*i].
	"rRatios := 	{g*blurR first .	b*blurR second.	r*blurR third.	g*bl.	b*blur*blur }.							
	gRatios := 	{b*blur*blur.	r*blur.	g.		b*blur.	r*blur*blur}.
	bRatios :=	{r*blur*blur.	g*blur.	b.		r*blur.	g*blur*blur }."
	rsum := rRatios inject:0 into:[:t :i | t+i].
	gsum := gRatios inject:0 into:[:t :i | t+i].
	bsum := bRatios inject:0 into:[:t :i | t+i].
	rfilter := rRatios collect:[:e | e / rsum].
	gfilter := gRatios collect:[:e | e / gsum].
	bfilter := bRatios collect:[:e | e / bsum].
	^{rfilter. gfilter. bfilter}! !

Object subclass: #LogicalFontManager
	instanceVariableNames: 'fontProviders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FreeType-FontManager'!

LogicalFontManager class
	instanceVariableNames: 'current'!

LogicalFontManager class
	instanceVariableNames: 'current'!

!LogicalFontManager class methodsFor: 'accessing' stamp: 'tween 3/17/2007 13:53'!
current
	"
	current := nil.
	self current
	"
	^current ifNil:[current := self defaultCurrent]! !

!LogicalFontManager class methodsFor: 'instance creation' stamp: 'tween 9/8/2007 14:45'!
defaultCurrent
	^self new
		addFontProvider: FreeTypeFontProvider current;
		yourself! !

!LogicalFontManager methodsFor: 'accessing' stamp: 'tween 9/29/2007 09:14'!
addFontProvider: aFontProvider

	fontProviders addLast: aFontProvider
	! !

!LogicalFontManager methodsFor: 'font families' stamp: 'tween 9/29/2007 09:14'!
allFamilies
	"answer an Array containing all the font families from the receiver's fontProviders,
	together with any TextStyle font families, sorted by family name"
	| answer textStyleFamilies textStyleFamilyName | 
	answer := Set new.
	fontProviders do:[:each | answer addAll: each families].
	textStyleFamilies := TextStyle knownTextStylesWithoutDefault collect:[:textStyleName |
		TextStyleAsFontFamily new
			textStyle: (TextStyle named: textStyleName);
			familyName: textStyleName;
			yourself].
	"reject any textStyles whose defaultFont also appears as a fontFamily"
	textStyleFamilies := textStyleFamilies reject:[:textStyleFamily |
		textStyleFamilyName :=  textStyleFamily textStyle defaultFont familyName.
		(answer detect:[:fontFamily | fontFamily familyName = textStyleFamilyName] ifNone:[]) notNil].
	answer addAll: textStyleFamilies.
	^(answer asSortedCollection: [:a :b | a familyName <= b familyName]) asArray.

	! !

!LogicalFontManager methodsFor: 'font lookup' stamp: 'tween 8/18/2007 10:42'!
bestFontFor: aLogicalFont
	"look up best font from the receivers fontProviders"
	
	^self bestFontFor: aLogicalFont whenFindingAlternativeIgnoreAll: Set new
! !

!LogicalFontManager methodsFor: 'font lookup' stamp: 'tween 9/29/2007 09:14'!
bestFontFor: aLogicalFont whenFindingAlternativeIgnoreAll: ignoreSet
	"look up best real font from the receivers fontProviders.
	If we can't find a font, then answer an alternative real font.
	
	ignoreSet contains the LogicalFonts that we have already attempted to
	get an alternative real font from. We ignore those on each iteration so that we don't 
	recurse forever"
	| answer textStyle font |
	
	aLogicalFont familyNames do:[:familyName |
		fontProviders do:[:p |
			(answer := p fontFor: aLogicalFont familyName: familyName)
				ifNotNil:[^answer]].
		textStyle := TextStyle named: familyName.
		textStyle ifNotNil:[
			font := textStyle fontOfPointSize: aLogicalFont pointSize.
			font ifNotNil:[^font emphasized: aLogicalFont emphasis]]].
	"not found, so use the default TextStyle"
	textStyle := TextStyle default.
	textStyle ifNotNil:[
		font := textStyle fontOfPointSize: aLogicalFont pointSize.
		(font isKindOf: LogicalFont) ifFalse:[^font emphasized: aLogicalFont emphasis].
		(ignoreSet includes: font)
			ifFalse:[
				ignoreSet add: font.  "remember that we have visited font so that we don't loop forever"
				"try again using the default TextStyle's logicalFont"
				^self bestFontFor: font whenFindingAlternativeIgnoreAll: ignoreSet]].
	"Neither the family, nor any of the fallback families, is available. 
	Any non-LogicalFont will do as a fallback"
	(TextConstants select: [:each | each isKindOf: TextStyle]) 
		do:[:ts | 
			((font := ts fontOfPointSize: aLogicalFont pointSize) isKindOf: LogicalFont)
				ifFalse:[^font emphasized:  aLogicalFont emphasis]].
	"There are no non-logical fonts in TextConstants - let it fail by answering nil"
	^nil
	
			
! !

!LogicalFontManager methodsFor: 'initialize-release' stamp: 'tween 3/14/2007 22:56'!
initialize
	super initialize.
	fontProviders := OrderedCollection new: 10
	! !

!TTCFont methodsFor: '*FreeType-addition' stamp: 'tween 4/23/2006 22:52'!
derivativeFont: aNewlyCreatedDerivativeFont mainFont: aMainFont

	self derivativeFont: aNewlyCreatedDerivativeFont at: aMainFont emphasis.
	aNewlyCreatedDerivativeFont emphasis: aMainFont emphasis.
	aNewlyCreatedDerivativeFont lineGlyph: (aMainFont ttcDescription at: $_).! !

!TTCFont methodsFor: '*FreeType-addition' stamp: 'tween 4/23/2006 21:45'!
initialize: aFont

	self initialize.
	self ttcDescription: aFont ttcDescription.
! !

!TTCFont methodsFor: '*FreeType-addition' stamp: 'tween 4/23/2006 22:54'!
lineGlyph: ignore
	^self! !
FT2Constants initialize!
LogicalFont initialize!
FreeTypeCache initialize!
FreeTypeFontProvider initialize!
FreeTypeSettings initialize!
FT2Handle initialize!
FreeTypeCacheConstants initialize!
